<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version 1.1.2
 * ("License"); You may not use this file except in compliance with the 
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an  "AS IS"  basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 * The Original Code is:  SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
********************************************************************************/

include('ecversion.php');

// more than 8MB memory needed for graphics
// memory limit default value = 16M
ini_set('memory_limit','256M');

// show or hide world clock, calculator and FCKEditor
// world_clock_display default value = true
// calculator_display default value = true
// fckeditor_display default value = true
$WORLD_CLOCK_DISPLAY = 'true';
$CALCULATOR_DISPLAY = 'true';
$FCKEDITOR_DISPLAY = 'true';

// url for customer portal (Example: http://vtiger.com/portal)
$PORTAL_URL = 'http://your-domain.com/customerportal';

// helpdesk support email id and support name (Example: 'support@vtiger.com' and 'vtiger support')
$HELPDESK_SUPPORT_EMAIL_ID = 'support@your-domain.com';
$HELPDESK_SUPPORT_NAME = 'your-domain name';

/* database configuration
      db_server
      db_port
      db_hostname
      db_username
      db_password
      db_name
*/

$dbconfig['db_server'] = '_DBC_SERVER_';
$dbconfig['db_port'] = ':_DBC_PORT_';
$dbconfig['db_username'] = '_DBC_USER_';
$dbconfig['db_password'] = '_DBC_PASS_';
$dbconfig['db_name'] = '_DBC_NAME_';
$dbconfig['db_type'] = '_DBC_TYPE_';
$dbconfig['db_status'] = '_DB_STAT_';

// TODO: test if port is empty
// TODO: set db_hostname dependending on db_type
$dbconfig['db_hostname'] = $dbconfig['db_server'].$dbconfig['db_port'];

// log_sql default value = false
$dbconfig['log_sql'] = false;

// persistent default value = true
$dbconfigoption['persistent'] = true;

// autofree default value = false
$dbconfigoption['autofree'] = false;

// debug default value = 0
$dbconfigoption['debug'] = 0;

// seqname_format default value = '%s_seq'
$dbconfigoption['seqname_format'] = '%s_seq';

// portability default value = 0
$dbconfigoption['portability'] = 0;

// ssl default value = false
$dbconfigoption['ssl'] = false;

$host_name = $dbconfig['db_hostname'];

$site_URL = '_SITE_URL_';

// root directory path
$root_directory = '_VT_ROOTDIR_';

// cache direcory path
$cache_dir = '_VT_CACHEDIR_';

// tmp_dir default value prepended by cache_dir = images/
$tmp_dir = '_VT_TMPDIR_';

// import_dir default value prepended by cache_dir = import/
$import_dir = 'cache/import/';

// upload_dir default value prepended by cache_dir = upload/
$upload_dir = '_VT_UPLOADDIR_';

// mail server parameters
$mail_server = '_MAIL_SERVER_';
$mail_server_username = '_MAIL_USERNAME_';
$mail_server_password = '_MAIL_PASSWORD_';

// maximum file size for uploaded files in bytes also used when uploading import files
// upload_maxsize default value = 3000000
$upload_maxsize = 3000000;

// flag to allow export functionality
// 'all' to allow anyone to use exports 
// 'admin' to only allow admins to export 
// 'none' to block exports completely 
// allow_exports default value = all
$allow_exports = 'all';

// files with one of these extensions will have '.txt' appended to their filename on upload
// upload_badext default value = php, php3, php4, php5, pl, cgi, py, asp, cfm, js, vbs, html, htm
$upload_badext = array('php', 'php3', 'php4', 'php5', 'pl', 'cgi', 'py', 'asp', 'cfm', 'js', 'vbs', 'html', 'htm');

// full path to include directory including the trailing slash
// includeDirectory default value = $root_directory..'include/
$includeDirectory = $root_directory.'include/';

// list_max_entries_per_page default value = 20
$list_max_entries_per_page = '20';

// limitpage_navigation default value = 5
$limitpage_navigation = '5';

// history_max_viewed default value = 5
$history_max_viewed = '5';

// define list of menu tabs
//$moduleList = Array('Home', 'Dashboard', 'Contacts', 'Accounts', 'Opportunities', 'Cases', 'Notes', 'Calls', 'Emails', 'Meetings', 'Tasks','MessageBoard');

// map sugar language codes to jscalendar language codes
// unimplemented until jscalendar language files are fixed
// $cal_codes = array('en_us'=>'en', 'ja'=>'jp', 'sp_ve'=>'sp', 'it_it'=>'it', 'tw_zh'=>'zh', 'pt_br'=>'pt', 'se'=>'sv', 'cn_zh'=>'zh', 'ge_ge'=>'de', 'ge_ch'=>'de', 'fr'=>'fr');

// default_module default value = Home
$default_module = 'Home';

// default_action default value = index
$default_action = 'index';

// set default theme
// default_theme default value = blue
$default_theme = 'softed';

// show or hide time to compose each page
// calculate_response_time default value = true
$calculate_response_time = true;

// default text that is placed initially in the login form for user name
// no default_user_name default value
$default_user_name = '';

// default text that is placed initially in the login form for password
// no default_password default value
$default_password = '';

// create user with default username and password
// create_default_user default value = false
$create_default_user = false;
// default_user_is_admin default value = false
$default_user_is_admin = false;

// if your MySQL/PHP configuration does not support persistent connections set this to true to avoid a large performance slowdown
// disable_persistent_connections default value = false
$disable_persistent_connections = false;

// defined languages available. the key must be the language file prefix. (Example 'en_us' is the prefix for every 'en_us.lang.php' file)
// languages default value = en_us=>US English
$languages = Array('zh_cn'=>'Simplized Chinese',);

//Master currency name
$currency_name = '_MASTER_CURRENCY_';

// default charset
// default charset default value = ISO-8859-1
$default_charset = 'UTF-8';

// default language
// default_language default value = en_us
$default_language = 'zh_cn';

// add the language pack name to every translation string in the display.
// translation_string_prefix default value = false
$translation_string_prefix = false;

//Option to cache tabs permissions for speed.
$cache_tab_perms = true;

//Option to hide empty home blocks if no entries.
$display_empty_home_blocks = false;

// Generating Unique Application Key
$application_unique_key = '_VT_APP_UNIQKEY_';

/*
BIG-5->BIG-5 (Taiwan and Hong Kong)
CP1251->CP1251 (MS Cyrillic)
CP1252->CP1252 (MS Western European & US)
EUC-CN->EUC-CN (Simplified Chinese GB2312)
EUC-JP->EUC-JP (Unix Japanese)
EUC-KR->EUC-KR (Korean)
EUC-TW->EUC-TW (Taiwanese)
ISO-2022-JP->ISO-2022-JP (Japanese)
ISO-2022-KR->ISO-2022-KR (Korean)
ISO-8859-1->ISO-8859-1 (Western European and US)
ISO-8859-2->ISO-8859-2 (Central and Eastern European)
ISO-8859-3->ISO-8859-3 (Latin 3)
ISO-8859-4->ISO-8859-4 (Latin 4)
ISO-8859-5->ISO-8859-5 (Cyrillic)
ISO-8859-6->ISO-8859-6 (Arabic)
ISO-8859-7->ISO-8859-7 (Greek)
ISO-8859-8->ISO-8859-8 (Hebrew)
ISO-8859-9->ISO-8859-9 (Latin 5)
ISO-8859-10->ISO-8859-10 (Latin 6)
ISO-8859-13->ISO-8859-13 (Latin 7)
ISO-8859-14->ISO-8859-14 (Latin 8)
ISO-8859-15->ISO-8859-15 (Latin 9)
KOI8-R->KOI8-R (Cyrillic Russian)
KOI8-U->KOI8-U (Cyrillic Ukranian)
SJIS->SJIS (MS Japanese)
UTF-8->UTF-8
*/
$default_export_charset = "GB2312";
$default_email_charset = "GB2312";
//true for hosting server , false for dedicated servers or virtual private server
//2 for zend3.3.0 , 1 or true for hosting server(real_server_ip) ,false for dedicated servers or virtual private server
$ecustomer_hosting_type = '2';
//current_user or all_to_me
$default_viewscope = "current_user";
$default_activity_view = "day";
$display_latest_notes = true;
$default_use_internalmailer = 1;//1 -> use webmail to send mail ; 0 use out mailer(such outlook) to send mail
$is_disable_approve = false;
$default_reminder_interval = 1;
$is_disable_pm = false;
$monday_first = 1;
$default_number_digits = 2;
$default_number_grouping_seperator = ",";
$default_number_decimal_seperator = ".";
?>