<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version 1.1.2
 * ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an  "AS IS"  basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 * The Original Code is:  SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************
 * $Header: /advent/projects/wesat/ec_crm/sugarcrm/include/utils/EditViewUtils.php,v 1.188 2005/04/29 05:5 * 4:39 rank Exp  
 * Description:  Includes generic helper functions used throughout the application.
 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc.
 * All Rights Reserved.
 * Contributor(s): ______________________________________..
 ********************************************************************************/

require_once('include/database/PearDatabase.php');
require_once('include/ComboUtil.php'); //new
require_once('include/utils/CommonUtils.php'); //new

/** This function returns the ec_field details for a given ec_fieldname.
  * Param $uitype - UI type of the ec_field
  * Param $fieldname - Form ec_field name
  * Param $fieldlabel - Form ec_field label name
  * Param $maxlength - maximum length of the ec_field
  * Param $col_fields - array contains the ec_fieldname and values
  * Param $generatedtype - Field generated type (default is 1)
  * Param $module_name - module name
  * Return type is an array
  */

function getOutputHtml($uitype, $fieldname, $fieldlabel, $maxlength, $col_fields,$generatedtype,$module_name,$mode='')
{
	global $log;
	$log->debug("Entering getOutputHtml() method ...");
	global $adb,$log;
	global $theme;
	global $mod_strings;
	global $app_strings;
	global $current_user;
	global $noof_group_rows;
    require('user_privileges/sharing_privileges_'.$current_user->id.'.php');
	require('user_privileges/user_privileges_'.$current_user->id.'.php');

	$theme_path="themes/".$theme."/";
	$image_path=$theme_path."images/";
	//$fieldlabel = from_html($fieldlabel);
	$fieldvalue = Array();
	$final_arr = Array();
	$value = $col_fields[$fieldname];
	$custfld = '';
	$ui_type[]= $uitype;
	$editview_fldname[] = $fieldname;

	if($generatedtype == 2)
		$mod_strings[$fieldlabel] = $fieldlabel;
	if(!isset($mod_strings[$fieldlabel])) {
		$mod_strings[$fieldlabel] = $fieldlabel;
	}

	if($uitype == 5 || $uitype == 6 || $uitype ==23)
	{	
		//$log->info("uitype is ".$uitype);
		$curr_time = "";
		if($value=='')
		{
			//modified to fix the issue in trac(http://vtiger.fosslabs.com/cgi-bin/trac.cgi/ticket/1469)
			//changed by dingjianting on 2008-11-13 for permitting blank date
			//if($fieldname != 'birthday' && $generatedtype != 2)// && $fieldname != 'due_date')//due date is today's date by default
			//	$disp_value=getNewDisplayDate();

			//Added to display the Contact - Support End Date as one year future instead of today's date -- 30-11-2005
			if($fieldname == 'support_end_date' && $_REQUEST['module'] == 'Contacts')
			{
				$addyear = strtotime("+1 year");
				global $current_user;
				//changed by dingjianting on 2006-12-4 for simplized chinese date format
				$dat_fmt = (($current_user->date_format == '')?('yyyy-mm-dd'):($current_user->date_format));

				$disp_value = (($dat_fmt == 'dd-mm-yyyy')?(date('d-m-Y',$addyear)):(($dat_fmt == 'mm-dd-yyyy')?(date('m-d-Y',$addyear)):(($dat_fmt == 'yyyy-mm-dd')?(date('Y-m-d', $addyear)):(''))));
			}
		}
		else
		{
			$disp_value = getDisplayDate($value);
		}
		$editview_label[]=$mod_strings[$fieldlabel];
		$date_format = parse_calendardate($app_strings['NTC_DATE_FORMAT']);
		if($uitype == 6)
		{
			if($col_fields['time_start']!='')
			{
				$curr_time = $col_fields['time_start'];
			}
			else
			{
				$curr_time = date('H:i');
			}
		}
		if($module_name == 'Events' && $uitype == 23)
		{
			if($col_fields['time_end']!='')
			{
				$curr_time = $col_fields['time_end'];
			}
			else
			{
				$endtime = time() + (60 * 60);
				$curr_time = date('H:i',$endtime);
			}
		}
		$fieldvalue[] = array($disp_value => $curr_time) ;
		if($uitype == 5 || $uitype == 23)
		{
			if($module_name == 'Events' && $uitype == 23)
			{
				$fieldvalue[] = array($date_format=>$current_user->date_format.' '.$app_strings['YEAR_MONTH_DATE']);
			}
			else
				$fieldvalue[] = array($date_format=>$current_user->date_format);
		}
		else
		{
			$fieldvalue[] = array($date_format=>$current_user->date_format.' '.$app_strings['YEAR_MONTH_DATE']);
		}
	}
	elseif($uitype == 15 || $uitype == 16 || $uitype == 111) //uitype 111 added for non editable picklist - ahmed
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		//changed by dingjianting on 2007-10-3 for cache pickListResult
		$key = "picklist_array_".$fieldname;
		$picklist_array = getSqlCacheData($key);
		if(!$picklist_array) {
			if($fieldname == "currency") {
				$pick_query = "select * from ec_currency_info order by id";
				$pickListResult = $adb->query($pick_query);			
				$picklist_array = array();
				while($row = $adb->fetchByAssoc($pickListResult)) {
					$picklist_array[] = $row['currency_name'];
				}
			} elseif($fieldname == "deliveryway") {
				$pick_query = "select * from ec_deliveryways where delivery_status=1 order by id";
				$pickListResult = $adb->query($pick_query);			
				$picklist_array = array();
				$picklist_array[] = $mod_strings["select_delivery"];
				while($row = $adb->fetchByAssoc($pickListResult)) {
					$picklist_array[] = $row['name'];
				}
			}
			else {
				$pick_query = "select * from ec_".$fieldname." order by sortorderid";
				$pickListResult = $adb->query($pick_query);			
				$picklist_array = array();
				while($row = $adb->fetchByAssoc($pickListResult)) {
					$picklist_array[] = $row[strtolower($fieldname)];
				}
			}
			setSqlCacheData($key,$picklist_array);
		}

		//Mikecrowe fix to correctly default for custom pick lists
		$options = array();
		$found = false;
		foreach($picklist_array as $pickListValue)
		{
			if($value == $pickListValue)
			{
				$chk_val = "selected";	
				$found = true;
			}
			else
			{	
				$chk_val = '';
			}
			$options[] = array($pickListValue=>$chk_val );	
		}
		$fieldvalue [] = $options;
	}
	// Related other module id ,support new module
	/*
		CREATE TABLE ec_crmentityrel (
		`module` VARCHAR( 100 ) NOT NULL ,
		`relmodule` VARCHAR( 100 ) NOT NULL ,
		UNIQUE (`module` ,`relmodule` )
		) ENGINE = InnoDB CHARACTER SET utf8 COLLATE utf8_general_ci 
	*/
	elseif($uitype == 10) {
		$query = "SELECT ec_entityname.* FROM ec_crmentityrel inner join ec_entityname on ec_entityname.modulename=ec_crmentityrel.relmodule WHERE ec_crmentityrel.module='".$module_name."' and ec_entityname.entityidfield='".$fieldname."'";
		$fldmod_result = $adb->query($query);
		$rownum = $adb->num_rows($fldmod_result);
		if($rownum > 0) {
			$rel_modulename = $adb->query_result($fldmod_result,0, 'modulename');
			$rel_tablename = $adb->query_result($fldmod_result,0, 'tablename');
			$rel_entityname = $adb->query_result($fldmod_result,0, 'fieldname');
			$rel_entityid = $adb->query_result($fldmod_result,0, 'entityidfield');
		}
		if($value != '')
		{
			$module_entityname = getEntityNameForTen($rel_tablename,$rel_entityname,$fieldname,$value);
		}
		elseif(isset($_REQUEST[$fieldname]) && $_REQUEST[$fieldname] != '')
		{
			if($_REQUEST['module'] == $rel_modulename)
			{
				$module_entityname = '';
			}
			else
			{
				$value = $_REQUEST[$fieldname];
				$module_entityname = getEntityNameForTen($rel_tablename,$rel_entityname,$fieldname,$value);
			}

		}
		$editview_label[] = $app_strings[$fieldlabel];
		$fieldvalue[] = $module_entityname;
		$fieldvalue[] = $value;
		$fieldvalue[] = $rel_entityname;
		$fieldvalue[] = $rel_modulename;
	} // END
	elseif($uitype == 17)
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue [] = $value;
	}
	elseif($uitype == 85) //added for Skype by Minnie
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue [] = $value;
	}
	elseif($uitype == 86) //added for qq by Minnie
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue [] = $value;
	}
	elseif($uitype == 87) //added for msn by Minnie
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue [] = $value;
	}
	elseif($uitype == 88) //added for trade by Minnie
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue [] = $value;
	}
	elseif($uitype == 89) //added for Yahoo by Minnie
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue [] = $value;
	}
	elseif($uitype == 33)
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		$mulsel="select * from ec_".$fieldname." order by sortorderid";
		$multiselect_result = $adb->query($mulsel);
		$noofoptions = $adb->num_rows($multiselect_result);
		$options = array();
		$found = false;
		$valur_arr = explode(' |##| ',$value);
		for($j = 0; $j < $noofoptions; $j++)
		{
			$multiselect_combo = $adb->query_result($multiselect_result,$j,strtolower($fieldname));
			if(in_array($multiselect_combo,$valur_arr))
			{
				$chk_val = "selected";
				$found = true;
			}
			else
			{
				$chk_val = '';
			}
			$options[] = array($multiselect_combo=>$chk_val );
		}
		$fieldvalue [] = $options;
	}
	elseif($uitype == 19 || $uitype == 20)
	{
		if(isset($_REQUEST['body']))
		{
			$value = ($_REQUEST['body']);
		}

		if($fieldname == 'terms_conditions')//for default Terms & Conditions
		{
			//Assign the value from focus->column_fields (if we create Invoice from SO the SO's terms and conditions will be loaded to Invoice's terms and conditions, etc.,)
			$value = $col_fields['terms_conditions'];

			//if the value is empty then only we should get the default Terms and Conditions
			//if($value == '' && $mode != 'edit')
			//	$value=getTermsandConditions();
		}

		$editview_label[]=$mod_strings[$fieldlabel];
		//$value = to_html($value);
		//$value = htmlspecialchars($value, ENT_QUOTES, "UTF-8");
		$fieldvalue [] =  $value;
	}
	elseif($uitype == 21 || $uitype == 24)
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue [] = $value;
	}
	elseif($uitype == 22)
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue[] = $value;
	}
	elseif($uitype == 52)
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		global $current_user;
		if($value != '')
		{
			$assigned_user_id = $value;	
		}
		else
		{
			$assigned_user_id = $current_user->id;
		}
		$combo_lbl_name = 'assigned_user_id';
		if($fieldlabel == 'Assigned To' && $is_admin==false && $profileGlobalPermission[2] == 1 && ($defaultOrgSharingPermission[getTabid($module_name)] == 3 or $defaultOrgSharingPermission[getTabid($module_name)] == 0))
		{
			$user_array = get_user_array(FALSE, "Active", $assigned_user_id);
			$users_combo = get_select_options_array($user_array, $assigned_user_id);
		}
		else
		{
			$user_array = get_user_array(FALSE, "Active", $assigned_user_id);
			$users_combo = get_select_options_array($user_array, $assigned_user_id);
		}
		$fieldvalue [] = $users_combo;
	}
	elseif($uitype == 77)
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		global $current_user;
		if($value != '')
		{
			$assigned_user_id = $value;	
		}
		else
		{
			$assigned_user_id = $current_user->id;
		}
		
		$combo_lbl_name = 'assigned_user_id';		
		$user_array = get_user_array(FALSE, "Active", $assigned_user_id);
		$users_combo = get_select_options_array($user_array, $assigned_user_id);
		$fieldvalue [] = $users_combo;
	}
	elseif($uitype == 53)     
	{  
		$editview_label[]=$mod_strings[$fieldlabel];
		//Security Checks
		if($fieldlabel == 'Assigned To' && $is_admin==false && $profileGlobalPermission[2] == 1 && ($defaultOrgSharingPermission[getTabid($module_name)] == 3 or $defaultOrgSharingPermission[getTabid($module_name)] == 0))
		{
			$result=get_current_user_access_groups($module_name);
		}
		else
		{ 		
			$result = get_group_options();
		}
		$nameArray = $adb->fetch_array($result);


		global $current_user;
		if($value != '' && $value != 0)
		{
			$assigned_user_id = $value;
			$user_checked = "checked";
			$team_checked = '';
			$user_style='display:block';
			$team_style='display:none';			
		}
		else
		{
			if($value=='0')
			{
				$record = $col_fields["record_id"];
				$module = $col_fields["record_module"];

				$selected_groupname = getGroupName($record, $module);
				$user_checked = '';
				$team_checked = 'checked';
				$user_style='display:none';
				$team_style='display:block';
			}
			else	
			{				
				$assigned_user_id = $current_user->id;
				$user_checked = "checked";
				$team_checked = '';
				$user_style='display:block';
				$team_style='display:none';
			}	
		}
		
		if($fieldlabel == 'Assigned To' && $is_admin==false && $profileGlobalPermission[2] == 1 && ($defaultOrgSharingPermission[getTabid($module_name)] == 3 or $defaultOrgSharingPermission[getTabid($module_name)] == 0))
		{
			$user_array = get_user_array(FALSE, "Active", $assigned_user_id);
			$users_combo = get_select_options_array($user_array, $assigned_user_id);
		}
		else
		{
			$user_array = get_user_array(FALSE, "Active", $assigned_user_id);
			$users_combo = get_select_options_array($user_array, $assigned_user_id);
		}


		$GROUP_SELECT_OPTION = '<td width=30%><input type="radio"
			name="assigntype" value="U" '.$user_checked.'
			onclick="toggleAssignType(this.value)">'.$app_strings['LBL_USER'];

		if($noof_group_rows!=0)
		{

			$log->debug("Has a Group, get the Radio button");
			$GROUP_SELECT_OPTION .= '<input
				type="radio" name="assigntype" value="T"'.$team_checked.'
				onclick="toggleAssignType(this.value)">'.$app_strings['LBL_GROUP'];
		}

		$GROUP_SELECT_OPTION .='<br><span
			id="assign_user" style="'.$user_style.'"><select name="assigned_user_id">';

		$GROUP_SELECT_OPTION .= $users_combo;

		$GROUP_SELECT_OPTION .= '</select></span>';

		if($noof_group_rows!=0)
		{
			$log->debug("Has a Group, getting the group names ");
			$GROUP_SELECT_OPTION .='<span id="assign_team" style="'.$team_style.'"><select name="assigned_group_name">';
			
			do
			{
				$groupname=$nameArray["groupname"];
				$selected = '';	
				if(isset($selected_groupname[0]) && $groupname == $selected_groupname[0])
				{
					$selected = "selected";
				}	
				$group_option[] = array($groupname=>$selected);

			}while($nameArray = $adb->fetch_array($result));

		}

		$fieldvalue[]=$users_combo;  
		$fieldvalue[] = $group_option;
	}
	elseif($uitype == 1004) //display creator in editview page
	{
		if(isset($mod_strings[$fieldlabel])) {
			$editview_label[] = $mod_strings[$fieldlabel];
		} else {
			$editview_label[] = $fieldlabel;
		}
		if(empty($value)) {
			global $current_user;
			$value = $current_user->id;
		}
		$fieldvalue[] = getUserName($value);
	}
	elseif($uitype == 1008) //display approvedby in editview page
	{
		if(isset($mod_strings[$fieldlabel])) {
			$editview_label[] = $mod_strings[$fieldlabel];
		} else {
			$editview_label[] = $fieldlabel;
		}
		if(empty($value)) {
			global $current_user;
			$value = $current_user->id;
		}
		$fieldvalue[] = getUserName($value);
	}
	elseif($uitype == 51 || $uitype == 50 || $uitype == 73)
	{
		$account_name = "";
		$convertmode = "";
		if(isset($_REQUEST['convertmode']))
		{
			$convertmode = $_REQUEST['convertmode'];
		}
		if($convertmode != 'update_quote_val' && $convertmode != 'update_so_val')
		{
			if(isset($_REQUEST['account_id']) && $_REQUEST['account_id'] != '')
				$value = $_REQUEST['account_id'];	
		}

		if($value != '')
		{		
			$account_name = getAccountName($value);	
		}
		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue[]=$account_name;
		$fieldvalue[] = $value;
	}
	elseif($uitype == 54)
	{
		$options =Array();
		$editview_label[]=$mod_strings[$fieldlabel];
		$pick_query="select * from ec_groups";
		$pickListResult = $adb->query($pick_query);
		$noofpickrows = $adb->num_rows($pickListResult);
		for($j = 0; $j < $noofpickrows; $j++)
		{
			$pickListValue=$adb->query_result($pickListResult,$j,"name");

			if($value == $pickListValue)
			{
				$chk_val = "selected";	
			}
			else
			{	
				$chk_val = '';	
			}
			$options[] = array($pickListValue => $chk_val );
		}
		$fieldvalue[] = $options;

	}
	elseif($uitype == 55)
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		$options = Array();
		$pick_query="select * from ec_salutationtype order by sortorderid";
		$pickListResult = $adb->query($pick_query);
		$noofpickrows = $adb->num_rows($pickListResult);
		$salt_value = $col_fields["salutationtype"];
		for($j = 0; $j < $noofpickrows; $j++)
		{
			$pickListValue=$adb->query_result($pickListResult,$j,"salutationtype");

			if($salt_value == $pickListValue)
			{
				$chk_val = "selected";	
			}
			else
			{	
				$chk_val = '';	
			}
			$options[] = array($pickListValue => $chk_val );
		}
		$fieldvalue[] = $options;
		$fieldvalue[] = $value;
	}
	elseif($uitype == 59)
	{
		if($_REQUEST['module'] == 'HelpDesk')
		{
			if(isset($_REQUEST['product_id']) & $_REQUEST['product_id'] != '')
				$value = $_REQUEST['product_id'];
		}
		elseif(isset($_REQUEST['parent_id']) & $_REQUEST['parent_id'] != '')
			$value = $_REQUEST['parent_id'];

		if($value != '')
		{		
			$product_name = getProductName($value);	
		}
		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue[]=$product_name;
		$fieldvalue[]=$value;
	}
	elseif($uitype == 63)
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		if($value=='')
			$value=1;
		$options = Array();
		$pick_query="select * from ec_duration_minutes order by sortorderid";
		$pickListResult = $adb->query($pick_query);
		$noofpickrows = $adb->num_rows($pickListResult);
		$salt_value = $col_fields["duration_minutes"];
		for($j = 0; $j < $noofpickrows; $j++)
		{
			$pickListValue=$adb->query_result($pickListResult,$j,"duration_minutes");

			if($salt_value == $pickListValue)
			{
				$chk_val = "selected";
			}
			else
			{
				$chk_val = '';
			}
			$options[$pickListValue] = $chk_val;
		}
		$fieldvalue[]=$value;
		$fieldvalue[]=$options;
	}
	elseif($uitype == 64)
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		$date_format = parse_calendardate($app_strings['NTC_DATE_FORMAT']);
		$fieldvalue[] = $value;
	}
	elseif($uitype == 156)
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue[] = $value;	
		$fieldvalue[] = $is_admin;
	}
	elseif($uitype == 56)
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue[] = $value;	
	}
	elseif($uitype == 57)
	{
		$contact_name = '';	
		if($value != '')
		{
			$contact_name = getContactName($value);
		}
		elseif(isset($_REQUEST['contact_id']) && $_REQUEST['contact_id'] != '')
		{
			if(isset($_REQUEST['module']) && $_REQUEST['module'] == 'Contacts' && $fieldname = 'contact_id')
			{
				$contact_name = '';	
			}
			else
			{
				$value = $_REQUEST['contact_id'];
				$contact_name = getContactName($value);		
			}

		}

		//Checking for contacts duplicate

		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue[] = $contact_name;
		$fieldvalue[] = $value;
	}

	elseif($uitype == 58)
	{

		if($value != '')
		{
			$campaign_name = getCampaignName($value);
		}
		elseif(isset($_REQUEST['campaignid']) && $_REQUEST['campaignid'] != '')
		{
			if($_REQUEST['module'] == 'Campaigns' && $fieldname = 'campaignid')
			{
				$campaign_name = '';
			}
			else
			{
				$value = $_REQUEST['campaignid'];
				$campaign_name = getCampaignName($value);
			}

		}
		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue[]=$campaign_name;
		$fieldvalue[] = $value;
	}
	
	elseif($uitype == 61)
	{
		global $current_user;
		if($value != '')
		{
			$assigned_user_id = $value;
		}
		else
		{
			$assigned_user_id = $current_user->id;
		}
		if($module_name == 'Emails')
		{
			$attach_result = $adb->query("select * from ec_seattachmentsrel where crmid = ".$col_fields['record_id']);
			for($ii=0;$ii < $adb->num_rows($attach_result);$ii++)
			{
				$attachmentid = $adb->query_result($attach_result,$ii,'attachmentsid');
				if($attachmentid != '')
				{
					$attachquery = "select * from ec_attachments where attachmentsid=".$attachmentid;
					$result = $adb->query($attachquery);
					$attachmentsname = $adb->query_result($result,0,'name');
					if($attachmentsname != '')	
						$fieldvalue[$attachmentid] = '[ '.$attachmentsname.' ]';
				}

			}
		}else
		{
			$filename = '';
			if(isset($col_fields['record_id']) && $col_fields['record_id'] != '')
			{
				$result = $adb->query("select * from ec_seattachmentsrel where crmid = ".$col_fields['record_id']);
				$attachmentid = $adb->query_result($result,0,'attachmentsid');
				if($col_fields[$fieldname] == '' && $attachmentid != '')
				{
					$attachquery = "select * from ec_attachments where attachmentsid=".$attachmentid;
					$result = $adb->query($attachquery);
					$value = $adb->query_result($result,0,'name');
				}
			}
			if($value!='')
				$filename=' [ '.$value. ' ]';
			$fieldvalue[] = $filename;
			$fieldvalue[] = $value;
		}
		$editview_label[]=$mod_strings[$fieldlabel];
	}
	elseif($uitype == 69)
  	{
  		$editview_label[]=$mod_strings[$fieldlabel];
 
 		if(isset($col_fields['record_id']) && $col_fields['record_id'] != "") 
  		{
 		    //This query is for Products only
			$image_id_array = array();
			$image_array = array();
			$image_encode_array = array();
			$image_path_array = array();
 		    if($module_name == 'Products')
 		    {
 			    $query = 'select ec_attachments.path, ec_attachments.attachmentsid, ec_attachments.name from ec_products left join ec_seattachmentsrel on ec_seattachmentsrel.crmid=ec_products.productid inner join ec_attachments on ec_attachments.attachmentsid=ec_seattachmentsrel.attachmentsid where productid='.$col_fields['record_id'];
 		    }
 		    else
		    {
			    $query = "select ec_attachments.* from ec_attachments inner join ec_seattachmentsrel on ec_seattachmentsrel.attachmentsid = ec_attachments.attachmentsid  where ec_seattachmentsrel.crmid=".$col_fields['record_id'];
 		    }
 		    $result_image = $adb->query($query);
 		    for($image_iter=0;$image_iter < $adb->num_rows($result_image);$image_iter++)	
 		    {
 			    $image_id_array[] = $adb->query_result($result_image,$image_iter,'attachmentsid');
 			    $image_array[] = $adb->query_result($result_image,$image_iter,'name');
				$image_encode_array[] = base64_encode_filename($adb->query_result($result_image,$image_iter,'name'));
 			    $image_path_array[] = $adb->query_result($result_image,$image_iter,'path');	
 		    }
 		    if(is_array($image_array))
 			    for($img_itr=0;$img_itr<count($image_array);$img_itr++)
 			    {
 				    $fieldvalue[] = array('name'=>$image_array[$img_itr],'encode_name'=>$image_encode_array[$img_itr],'path'=>$image_path_array[$img_itr].$image_id_array[$img_itr]."_");
 			    }
 		    else
 			    $fieldvalue[] = '';
  		}
  		else
  			$fieldvalue[] = '';
  	}
	elseif($uitype == 62)
	{
		if(isset($_REQUEST['parent_id']) && $_REQUEST['parent_id'] != '')
			$value = $_REQUEST['parent_id'];

		if($value != '')
		{
			$parent_module = getSalesEntityType($value);
			if($parent_module == "Leads")
			{
				$sql = "select * from ec_leaddetails where leadid=".$value;
				$result = $adb->query($sql);
				$first_name = $adb->query_result($result,0,"firstname");
				$last_name = $adb->query_result($result,0,"lastname");
				//change begin
				//$parent_name = $last_name.' '.$first_name;
				//changed by dingjianting on 2006-11-9 for simplized chinese
				$parent_name = $first_name.$last_name;
                //change end
				$lead_selected = "selected";

			}
			elseif($parent_module == "Accounts")
			{
				$sql = "select * from  ec_account where accountid=".$value;
				$result = $adb->query($sql);
				$parent_name = $adb->query_result($result,0,"accountname");
				$account_selected = "selected";

			}
			elseif($parent_module == "Contacts")
			{
				$sql = "select * from  ec_contactdetails where contactid=".$value;
				$result = $adb->query($sql);
				$parent_name = $adb->query_result($result,0,"lastname");
				$contact_selected = "selected";
			}
			elseif($parent_module == "Potentials")
			{
				$sql = "select * from  ec_potential where potentialid=".$value;
				$result = $adb->query($sql);
				$parent_name = $adb->query_result($result,0,"potentialname");
				$potential_selected = "selected";

			}
			elseif($parent_module == "Products")
			{
				$sql = "select * from  ec_products where productid=".$value;
				$result = $adb->query($sql);
				$parent_name= $adb->query_result($result,0,"productname");
				$product_selected = "selected";

			}
			elseif($parent_module == "PurchaseOrder")
			{
				$sql = "select * from  ec_purchaseorder where purchaseorderid=".$value;
				$result = $adb->query($sql);
				$parent_name= $adb->query_result($result,0,"subject");
				$porder_selected = "selected";

			}
			elseif($parent_module == "SalesOrder")
			{
				$sql = "select * from  ec_salesorder where salesorderid=".$value;
				$result = $adb->query($sql);
				$parent_name= $adb->query_result($result,0,"subject");
				$sorder_selected = "selected";

			}
			elseif($parent_module == "Invoice")
			{
				$sql = "select * from  ec_invoice where invoiceid=".$value;
				$result = $adb->query($sql);
				$parent_name= $adb->query_result($result,0,"subject");
				$invoice_selected = "selected";

			}
			elseif($parent_module == "Vendors")
			{
				$sql = "select vendorname from  ec_vendor where vendorid=".$value;
				$result = $adb->query($sql);
				$parent_name= $adb->query_result($result,0,"vendorname");
				$vendor_selected = "selected";

			}


		}
		$editview_label[] = array($app_strings['COMBO_LEADS'],
                                          $app_strings['COMBO_ACCOUNTS'],
                                          $app_strings['COMBO_POTENTIALS'],
                                          $app_strings['COMBO_PRODUCTS'],
                                          $app_strings['COMBO_INVOICES'],
                                          $app_strings['COMBO_PORDER'],
                                          $app_strings['COMBO_SORDER']
                                         );
                $editview_label[] = array($lead_selected,
                                          $account_selected,
										  $potential_selected,
                                          $product_selected,
                                          $invoice_selected,
                                          $porder_selected,
                                          $sorder_selected,
					                      $vendor_selected
                                         );
                $editview_label[] = array("Leads&action=Popup","Accounts&action=Popup","Potentials&action=Popup","Products&action=Popup","Invoice&action=Popup","PurchaseOrder&action=Popup","SalesOrder&action=Popup","Vendors&action=Popup");
		$fieldvalue[] =$parent_name;
		$fieldvalue[] =$value;

	}
	elseif($uitype == 66)
	{
		if(isset($_REQUEST['parent_id']) && $_REQUEST['parent_id'] != '')
			$value = $_REQUEST['parent_id'];
		// Check for ec_activity type if task orders to be added in select option
		$act_mode = $_REQUEST['activity_mode'];
		$parent_name = "";

		if($value != '')
		{
			$parent_module = getSalesEntityType($value);
			if($parent_module == "Accounts")
			{
				$sql = "select * from  ec_account where accountid=".$value;
				$result = $adb->query($sql);
				$parent_name = $adb->query_result($result,0,"accountname");
				$account_selected = "selected";

			}
			elseif($parent_module == "Contacts")
			{
				$sql = "select * from  ec_contactdetails where contactid=".$value;
				$result = $adb->query($sql);
				$first_name = $adb->query_result($result,0,"firstname");
				$last_name = $adb->query_result($result,0,"lastname");
				$parent_name = $first_name.$last_name;
				$contact_selected = "selected";
			}
			elseif($parent_module == "Leads")
			{
				$sql = "select * from ec_leaddetails where leadid=".$value;
				$result = $adb->query($sql);
				$first_name = $adb->query_result($result,0,"firstname");
				$last_name = $adb->query_result($result,0,"lastname");
				//$parent_name = $last_name.' '.$first_name;
				//changed by dingjianting on 2006-11-9 for simplized chinese
				$parent_name = $first_name.$last_name;
				$lead_selected = "selected";

			}
			elseif($parent_module == "Potentials")
			{
				$sql = "select * from  ec_potential where potentialid=".$value;
				$result = $adb->query($sql);
				$parent_name = $adb->query_result($result,0,"potentialname");
				$potential_selected = "selected";

			}
			elseif($parent_module == "Quotes")
			{
				$sql = "select * from  ec_quotes where quoteid=".$value;
				$result = $adb->query($sql);
				$parent_name = $adb->query_result($result,0,"subject");
				$quote_selected = "selected";

			}
			elseif($parent_module == "PurchaseOrder")
			{
				$sql = "select * from ec_purchaseorder where purchaseorderid=".$value;
				$result = $adb->query($sql);
				$parent_name = $adb->query_result($result,0,"subject");
				$purchase_selected = "selected";
			}
			elseif($parent_module == "SalesOrder")
			{
				$sql = "select * from ec_salesorder where salesorderid=".$value;
				$result = $adb->query($sql);
				$parent_name = $adb->query_result($result,0,"subject");
				$sales_selected = "selected";
			}
			elseif($parent_module == "Invoice")
			{
				$sql = "select * from ec_invoice where invoiceid=".$value;
				$result = $adb->query($sql);
				$parent_name = $adb->query_result($result,0,"subject");
				$invoice_selected = "selected";
			}
			elseif($parent_module == "Campaigns")
			{
				$sql = "select campaignname from ec_campaign where campaignid=".$value;
				$result = $adb->query($sql);
				$parent_name = $adb->query_result($result,0,"campaignname");
				$campaign_selected = "selected";
			}
			elseif($parent_module == "HelpDesk")
			{
				$sql = "select title from ec_troubletickets where ticketid=".$value;
				$result = $adb->query($sql);
				$parent_name = $adb->query_result($result,0,"title");
				$ticket_selected = "selected";
			}
			elseif($parent_module == "Vendors")
			{
				$sql = "select vendorname from  ec_vendor where vendorid=".$value;
				$result = $adb->query($sql);
				$parent_name= $adb->query_result($result,0,"vendorname");
				$vendor_selected = "selected";

			} else {
				$tempmodule = strtolower($parent_module);
				$titlename = substr($tempmodule,0,-1)."name";
				$sql = "select ".$titlename." from  ec_".$tempmodule." where ".$tempmodule."id=".$value;
				$result = $adb->query($sql);
				$parent_name= $adb->query_result($result,0,$titlename);
				$vendor_selected = "selected";
			}
			/*
			elseif($act_mode == "Task")
			{
				if($parent_module == "PurchaseOrder")
				{
					$sql = "select * from ec_purchaseorder where purchaseorderid=".$value;
					$result = $adb->query($sql);
					$parent_name = $adb->query_result($result,0,"subject");
					$purchase_selected = "selected";
				}
				if($parent_module == "SalesOrder")
				{
					$sql = "select * from ec_salesorder where salesorderid=".$value;
					$result = $adb->query($sql);
					$parent_name = $adb->query_result($result,0,"subject");
					$sales_selected = "selected";
				}
				if($parent_module == "Invoice")
				{
					$sql = "select * from ec_invoice where invoiceid=".$value;
					$result = $adb->query($sql);
					$parent_name = $adb->query_result($result,0,"subject");
					$invoice_selected = "selected";
				}
				if($parent_module == "Campaigns")
				{
					$sql = "select campaignname from ec_campaign where campaignid=".$value;
					$result = $adb->query($sql);
					$parent_name = $adb->query_result($result,0,"campaignname");
					$campaign_selected = "selected";
				}
				if($parent_module == "HelpDesk")
				{
					$sql = "select title from ec_troubletickets where ticketid=".$value;
					$result = $adb->query($sql);
					$parent_name = $adb->query_result($result,0,"title");
					$ticket_selected = "selected";
				}
			}
			
			elseif($act_mode == "Events")
			{
				if($parent_module == "HelpDesk")
				{
					$sql = "select title from ec_troubletickets where ticketid=".$value;
					$result = $adb->query($sql);
					$parent_name = $adb->query_result($result,0,"title");
					$ticket_selected = "selected";
				}
			}
			*/

		}
		/*
		if($act_mode == "Task")
                {
                        $editview_label[] = array($app_strings['COMBO_LEADS'],
                                $app_strings['COMBO_ACCOUNTS'],
                                $app_strings['COMBO_POTENTIALS'],
                                $app_strings['COMBO_QUOTES'],
                                $app_strings['COMBO_PORDER'],
                                $app_strings['COMBO_SORDER'],
                                $app_strings['COMBO_INVOICES'],
				$app_strings['COMBO_CAMPAIGNS'],
				$app_strings['COMBO_HELPDESK']
                                        );
			$editview_label[] = array($lead_selected,
                                $account_selected,
                                $potential_selected,
                                $quote_selected,
                                $purchase_selected,
                                $sales_selected,
                                $invoice_selected,
				$campaign_selected,
				$ticket_selected
                                        );
                        $editview_label[] = array("Leads&action=Popup","Accounts&action=Popup","Potentials&action=Popup","Quotes&action=Popup","PurchaseOrder&action=Popup","SalesOrder&action=Popup","Invoice&action=Popup","Campaigns&action=Popup","HelpDesk&action=Popup");
                }
		
		elseif($act_mode == "Events")
		{
			$editview_label[] = array($app_strings['COMBO_LEADS'],
				$app_strings['COMBO_ACCOUNTS'],
				$app_strings['COMBO_POTENTIALS'],
				$app_strings['COMBO_HELPDESK']
			);
			$editview_label[] = array($lead_selected,
				$account_selected,
				$potential_selected,
				$ticket_selected
			);
			$editview_label[] = array("Leads&action=Popup","Accounts&action=Popup","Potentials&action=Popup","HelpDesk&action=Popup");
		}
		else
		{
				$editview_label[] = array($app_strings['COMBO_LEADS'],
						$app_strings['COMBO_ACCOUNTS'],
						$app_strings['COMBO_POTENTIALS'],
						);
				$editview_label[] = array($lead_selected,
						$account_selected,
						$potential_selected
						);
				$editview_label[] = array("Leads&action=Popup","Accounts&action=Popup","Potentials&action=Popup");

		}
		*/
		$editview_label[] = array($parent_module);
		$editview_label[] = array("selected");
		$editview_label[] = array($parent_module."&action=Popup");
		/*
		$editview_label[] = array($app_strings['COMBO_LEADS'],
				$app_strings['COMBO_ACCOUNTS'],
				$app_strings['COMBO_POTENTIALS'],
				$app_strings['COMBO_HELPDESK']
			);
			$editview_label[] = array($lead_selected,
				$account_selected,
				$potential_selected,
				$ticket_selected
			);
			$editview_label[] = array("Leads&action=Popup","Accounts&action=Popup","Potentials&action=Popup","HelpDesk&action=Popup");
		*/
		$fieldvalue[] = $parent_name;
		$fieldvalue[] = $value;
	}
	//added by rdhital/Raju for better email support
	elseif($uitype == 357)
	{
		$contact_selected = 'selected';
		$account_selected = '';
		$lead_selected = '';
		if(isset($_REQUEST['emailids']) && $_REQUEST['emailids'] != '')
		{
			$parent_id = $_REQUEST['emailids'];
			$parent_name='';
			$pmodule=$_REQUEST['pmodule'];

			$myids=explode("|",$parent_id);
			for ($i=0;$i<(count($myids)-1);$i++)
			{
				$realid=explode("@",$myids[$i]);
				$entityid=$realid[0];
				$nemail=count($realid);

				if ($pmodule=='Accounts'){
					require_once('modules/Accounts/Accounts.php');
					$myfocus = new Accounts();
					$myfocus->retrieve_entity_info($entityid,"Accounts");
					$fullname=br2nl($myfocus->column_fields['accountname']);
					$account_selected = 'selected';
				}
				elseif ($pmodule=='Contacts'){
					require_once('modules/Contacts/Contacts.php');
					$myfocus = new Contacts();
					$myfocus->retrieve_entity_info($entityid,"Contacts");
					$fname=br2nl($myfocus->column_fields['firstname']);
					$lname=br2nl($myfocus->column_fields['lastname']);
					//changed by dingjianting on 2006-11-9 for simplized chinese
					//$fullname=$lname.' '.$fname;
					$fullname=$fname.$lname;
					$contact_selected = 'selected';
				}
				elseif ($pmodule=='Leads'){
					require_once('modules/Leads/Leads.php');
					$myfocus = new Leads();
					$myfocus->retrieve_entity_info($entityid,"Leads");
					$fname=br2nl($myfocus->column_fields['firstname']);
					$lname=br2nl($myfocus->column_fields['lastname']);
					//changed by dingjianting on 2006-11-9 for simplized chinese
					//$fullname=$lname.' '.$fname;
					$fullname=$fname.$lname;
					$lead_selected = 'selected';
				}
				for ($j=1;$j<$nemail;$j++){
					$querystr='select columnname from ec_field where fieldid='.$realid[$j].';';
					$result=$adb->query($querystr);
					$temp=$adb->query_result($result,0,'columnname');
					$temp1=br2nl($myfocus->column_fields[$temp]);

					//Modified to display the entities in red which don't have email id
					if(strlen($temp_parent_name) > 150)
					{
						$parent_name .= '<br>';
						$temp_parent_name = '';
					}

					if($temp1 != '')
					{
						$parent_name .= $fullname.'&lt;'.$temp1.'&gt;; ';
						$temp_parent_name .= $fullname.'&lt;'.$temp1.'&gt;; ';
					}
					else
					{
						$parent_name .= "<b style='color:red'>".$fullname.'&lt;'.$temp1.'&gt;; '."</b>";
						$temp_parent_name .= "<b style='color:red'>".$fullname.'&lt;'.$temp1.'&gt;; '."</b>";
					}

				}
			}
		}
		else
		{
			$parent_name='';
			$parent_id='';
			$myemailid= $_REQUEST['record'];
			$mysql = "select crmid from ec_seactivityrel where activityid=".$myemailid;
			$myresult = $adb->query($mysql);
			$mycount=$adb->num_rows($myresult);
			if($mycount >0)
			{
				for ($i=0;$i<$mycount;$i++)
				{	
					$mycrmid=$adb->query_result($myresult,$i,'crmid');
					$parent_module = getSalesEntityType($mycrmid);
					if($parent_module == "Leads")
					{
						$sql = "select firstname,lastname,email from ec_leaddetails where leadid=".$mycrmid;
						$result = $adb->query($sql);
						$first_name = $adb->query_result($result,0,"firstname");
						$last_name = $adb->query_result($result,0,"lastname");
						$myemail=$adb->query_result($result,0,"email");
						$parent_id .=$mycrmid.'@0|' ; //make it such that the email adress sent is remebered and only that one is retrived
						//changed by dingjianting on 2006-11-9 for simplized chinese
						//$parent_name .= $last_name.' '.$first_name.'<'.$myemail.'>; ';
						$parent_name .= $first_name.$last_name.'<'.$myemail.'>; ';
						$lead_selected = 'selected';
					}
					elseif($parent_module == "Contacts")
					{
						$sql = "select * from  ec_contactdetails where contactid=".$mycrmid;
						$result = $adb->query($sql);
						$first_name = $adb->query_result($result,0,"firstname");
						$last_name = $adb->query_result($result,0,"lastname");
						$myemail=$adb->query_result($result,0,"email");
						$parent_id .=$mycrmid.'@0|'  ;//make it such that the email adress sent is remebered and only that one is retrived
						//changed by dingjianting on 2006-11-9 for simplized chinese
						//$parent_name .= $last_name.' '.$first_name.'<'.$myemail.'>; ';
						$parent_name .= $first_name.$last_name.'<'.$myemail.'>; ';
						$contact_selected = 'selected';
					}
					elseif($parent_module == "Accounts")
					{
						$sql = "select * from  ec_account where accountid=".$mycrmid;
						$result = $adb->query($sql);
						$account_name = $adb->query_result($result,0,"accountname");
						$myemail=$adb->query_result($result,0,"email1");
						$parent_id .=$mycrmid.'@0|'  ;//make it such that the email adress sent is remebered and only that one is retrived
						$parent_name .= $account_name.'<'.$myemail.'>; ';
						$account_selected = 'selected';
					}elseif($parent_module == "Users")
					{
						$sql = "select user_name,email1 from ec_users where id=".$mycrmid;
						$result = $adb->query($sql);
						$account_name = $adb->query_result($result,0,"user_name");
						$myemail=$adb->query_result($result,0,"email1");
						$parent_id .=$mycrmid.'@0|'  ;//make it such that the email adress sent is remebered and only that one is retrived
						$parent_name .= $account_name.'<'.$myemail.'>; ';
						$user_selected = 'selected';
					}
				}
			}
		}
		$custfld .= '<td width="20%" class="dataLabel">To:&nbsp;</td>';
		$custfld .= '<td width="90%" colspan="3"><input name="parent_id" type="hidden" value="'.$parent_id.'"><textarea readonly name="parent_name" cols="70" rows="2">'.$parent_name.'</textarea>&nbsp;<select name="parent_type" >';
		$custfld .= '<OPTION value="Contacts" selected>'.$app_strings['COMBO_CONTACTS'].'</OPTION>';
		$custfld .= '<OPTION value="Accounts" >'.$app_strings['COMBO_ACCOUNTS'].'</OPTION>';
		$custfld .= '<OPTION value="Leads" >'.$app_strings['COMBO_LEADS'].'</OPTION></select><img src="'.$image_path.'select.gif" alt="Select" title="Select" LANGUAGE=javascript onclick=\'return window.open("index.php?module="+ document.EditView.parent_type.value +"&action=Popup&popuptype=set_return_emails&form=EmailEditView&form_submit=false","test","width=600,height=400,resizable=1,scrollbars=1,top=150,left=200");\' align="absmiddle" style=\'cursor:hand;cursor:pointer\'>&nbsp;<input type="image" src="'.$image_path.'clear_field.gif" alt="Clear" title="Clear" LANGUAGE=javascript onClick="this.form.parent_id.value=\'\';this.form.parent_name.value=\'\';return false;" align="absmiddle" style=\'cursor:hand;cursor:pointer\'></td>';
		$editview_label[] = array(	 
				'Contacts'=>$contact_selected,
				'Accounts'=>$account_selected,
				'Leads'=>$lead_selected,
				'Users'=>$user_selected
				);
		$fieldvalue[] =$parent_name;
		$fieldvalue[] = $parent_id;

	}
	//end of rdhital/Raju
	elseif($uitype == 68)
	{
		if(isset($_REQUEST['parent_id']) && $_REQUEST['parent_id'] != '')
			$value = $_REQUEST['parent_id'];

		if($value != '')
		{
			$parent_module = getSalesEntityType($value);
			if($parent_module == "Contacts")
			{
				$sql = "select * from  ec_contactdetails where contactid=".$value;
				$result = $adb->query($sql);
				$first_name = $adb->query_result($result,0,"firstname");
				$last_name = $adb->query_result($result,0,"lastname");
				//changed by dingjianting on 2006-11-9 for simplized chinese
				//$parent_name = $last_name.' '.$first_name;
				$parent_name .= $first_name.$last_name;				
				$contact_selected = "selected";

			}
			elseif($parent_module == "Accounts")
			{
				$sql = "select * from  ec_account where accountid=".$value;
				$result = $adb->query($sql);
				$parent_name = $adb->query_result($result,0,"accountname");
				$account_selected = "selected";

			}
		}
		$editview_label[] = array($app_strings['COMBO_ACCOUNTS'],$app_strings['COMBO_CONTACTS']);
        $editview_label[] = array($account_selected,$contact_selected);
        $editview_label[] = array("Accounts","Contacts");
		$fieldvalue[] = $parent_name;
		$fieldvalue[] = $value;
	}
	
	elseif($uitype == 71 || $uitype == 72)
	{
		$rate_symbol = getCurrencySymbolandCRate($user_info['currency_id']);
		$rate = $rate_symbol['rate'];
		$currency= $rate_symbol['symbol'];
		$editview_label[]=$mod_strings[$fieldlabel].': ('.$currency.')';
		if($value!='')
		        $fieldvalue[] = getConvertedPriceFromDollar($value,$rate);
		else
		        $fieldvalue[] = $value;
	}
	elseif($uitype == 75 || $uitype ==81)
	{
		$vendor_name = '';
		if($value != '')
		{
			$vendor_name = getVendorName($value);
		}
		elseif(isset($_REQUEST['vendor_id']) && $_REQUEST['vendor_id'] != '')
		{
			$value = $_REQUEST['vendor_id'];
			$vendor_name = getVendorName($value);
		}		 	
		$pop_type = 'specific';
		if($uitype == 81)
		{
			$pop_type = 'specific_vendor_address';
		}
		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue[] = $vendor_name;
		$fieldvalue[] = $value;
	}
	elseif($uitype == 76)
	{
		if($value != '')
		{
			$potential_name = getPotentialName($value);
		}
		elseif(isset($_REQUEST['potential_id']) && $_REQUEST['potential_id'] != '')
		{
			$value = $_REQUEST['potental_id'];
			$potential_name = getPotentialName($value);
		}		 	
		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue[] = $potential_name;
		$fieldvalue[] = $value;
	}
	elseif($uitype == 78)
	{
		if($value != '')
		{
			$quote_name = getQuoteName($value);
		}
		elseif(isset($_REQUEST['quote_id']) && $_REQUEST['quote_id'] != '')
		{
			$value = $_REQUEST['quote_id'];
			$potential_name = getQuoteName($value);
		}		 	
		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue[] = $quote_name;
		$fieldvalue[] = $value;
	}
	elseif($uitype == 79)
	{
		if($value != '')
		{
			$purchaseorder_name = getPoName($value);
		}
		elseif(isset($_REQUEST['purchaseorder_id']) && $_REQUEST['purchaseorder_id'] != '')
		{
			$value = $_REQUEST['purchaseorder_id'];
			$purchaseorder_name = getPoName($value);
		}		 	
		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue[] = $purchaseorder_name;
		$fieldvalue[] = $value;
	}
	elseif($uitype == 80)
	{
		if($value != '')
		{
			$salesorder_name = getSoName($value);
		}
		elseif(isset($_REQUEST['salesorder_id']) && $_REQUEST['salesorder_id'] != '')
		{
			$value = $_REQUEST['salesorder_id'];
			$salesorder_name = getSoName($value);
		}		 	
		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue[] = $salesorder_name;
		$fieldvalue[] = $value;
	}
	elseif($uitype == 1010)
	{
		if($value != '')
		{
			$invoice_name = getInvoiceName($value);
		}
		elseif(isset($_REQUEST['invoice_id']) && $_REQUEST['invoice_id'] != '')
		{
			$value = $_REQUEST['invoice_id'];
			$invoice_name = getInvoiceName($value);
		}		 	
		$editview_label[] = $mod_strings[$fieldlabel];
		$fieldvalue[] = $invoice_name;
		$fieldvalue[] = $value;
	}
	elseif($uitype == 30)
	{
		$rem_days = 0;
		$rem_hrs = 0;
		$rem_min = 0;
		if($value!='')
			$SET_REM = "CHECKED";
		$rem_days = floor($col_fields[$fieldname]/(24*60));
		$rem_hrs = floor(($col_fields[$fieldname]-$rem_days*24*60)/60);
		$rem_min = ($col_fields[$fieldname]-$rem_days*24*60)%60;
		$editview_label[]=$mod_strings[$fieldlabel];
		$day_options = getReminderSelectOption(0,31,'remdays',$rem_days);
		$hr_options = getReminderSelectOption(0,23,'remhrs',$rem_hrs);
		$min_options = getReminderSelectOption(1,59,'remmin',$rem_min);
		$fieldvalue[] = array(array(0,32,'remdays',$mod_strings['LBL_DAYS'],$rem_days),array(0,24,'remhrs',$mod_strings['LBL_HOURS'],$rem_hrs),array(1,60,'remmin',$mod_strings['LBL_MINUTES'].'&nbsp;&nbsp;'.$mod_strings['LBL_BEFORE_EVENT'],$rem_min));
		$fieldvalue[] = array($SET_REM,$mod_strings['LBL_YES'],$mod_strings['LBL_NO']);
		$SET_REM = '';
	}
	elseif($uitype == 115)
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		$pick_query="select * from ec_".$fieldname;
		$pickListResult = $adb->query($pick_query);
		$noofpickrows = $adb->num_rows($pickListResult);

		//Mikecrowe fix to correctly default for custom pick lists
		$options = array();
		$found = false;
		for($j = 0; $j < $noofpickrows; $j++)
		{
			$pickListValue=$adb->query_result($pickListResult,$j,strtolower($fieldname));

			if($value == $pickListValue)
			{
				$chk_val = "selected";	
				$found = true;
			}
			else
			{	
				$chk_val = '';
			}
			$options[] = array($pickListValue=>$chk_val );	
		}
		$fieldvalue [] = $options;
		$fieldvalue [] = $is_admin;
	}
	elseif($uitype == 116)
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		$pick_query="select * from ec_currency_info where currency_status = 'Active'";
		$pickListResult = $adb->query($pick_query);
		$noofpickrows = $adb->num_rows($pickListResult);

		//Mikecrowe fix to correctly default for custom pick lists
		$options = array();
		$found = false;
		for($j = 0; $j < $noofpickrows; $j++)
		{
			$pickListValue=$adb->query_result($pickListResult,$j,'currency_name');
			$currency_id=$adb->query_result($pickListResult,$j,'id');
			if($value == $currency_id)
			{
				$chk_val = "selected";	
				$found = true;
			}
			else
			{	
				$chk_val = '';
			}
			$options[$currency_id] = array($pickListValue=>$chk_val );	
		}
		$fieldvalue [] = $options;
		$fieldvalue [] = $is_admin;
	}
	elseif($uitype ==98)
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue[]=$value;
        	$fieldvalue[]=getRoleName($value);
		$fieldvalue[]=$is_admin;
	}
	elseif($uitype == 105)
	{
		$editview_label[]=$mod_strings[$fieldlabel];
		 if( isset( $col_fields['record_id']) && $col_fields['record_id'] != '') {
			$query = "select ec_attachments.path, ec_attachments.name from ec_contactdetails left join ec_seattachmentsrel on ec_seattachmentsrel.crmid=ec_contactdetails.contactid inner join ec_attachments on ec_attachments.attachmentsid=ec_seattachmentsrel.attachmentsid where ec_contactdetails.imagename=ec_attachments.name and contactid=".$col_fields['record_id'];
			$result_image = $adb->query($query);
			for($image_iter=0;$image_iter < $adb->num_rows($result_image);$image_iter++)	
			{
				$image_array[] = $adb->query_result($result_image,$image_iter,'name');	
				$image_path_array[] = $adb->query_result($result_image,$image_iter,'path');	
			}
		}
		if(is_array($image_array))
			for($img_itr=0;$img_itr<count($image_array);$img_itr++)
			{
				$fieldvalue[] = array('name'=>$image_array[$img_itr],'path'=>$image_path_array[$img_itr]);
			}
		else
			$fieldvalue[] = '';
	}elseif($uitype == 101)
	{
		$editview_label[]=$mod_strings[$fieldlabel];
        $fieldvalue[] = getUserName($value);
        $fieldvalue[] = $value;
	}
	//after 1001 new uitype and module
	//added by dingjianting on 2007-1-27 for new module Exhibitions
	elseif($uitype == 1001)
	{

		if($value != '')
		{
			$exhibition_name = getExhibitionName($value);
		}
		elseif(isset($_REQUEST['exhibitionsid']) && $_REQUEST['exhibitionsid'] != '')
		{
			if($_REQUEST['module'] == 'Exhibitions' && $fieldname = 'exhibitionsid')
			{
				$exhibition_name = '';	
			}
			else
			{
				$value = $_REQUEST['exhibitionsid'];
				$exhibition_name = getExhibitionName($value);		
			}

		}

		//Checking for Exhibitions duplicate

		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue[] = $exhibition_name;
		$fieldvalue[] = $value;
	}
	elseif($uitype == 1002)
	{

		if($value != '')
		{
			$visit_name = getVisitName($value);
		}
		elseif(isset($_REQUEST['visitsid']) && $_REQUEST['visitsid'] != '')
		{
			if($_REQUEST['module'] == 'Visits' && $fieldname = 'visitsid')
			{
				$visit_name = '';	
			}
			else
			{
				$value = $_REQUEST['visitsid'];
				$visit_name = getVisitName($value);		
			}

		}

		//Checking for Exhibitions duplicate

		$editview_label[]=$mod_strings[$fieldlabel];
		$fieldvalue[] = $visit_name;
		$fieldvalue[] = $value;
	}
	elseif($uitype == 1006)
	{
		$catalog_name = "";
		if($value != '')
		{
			$catalog_name = getCatalogName($value);
		}
		elseif(isset($_REQUEST['catalogid']) && $_REQUEST['catalogid'] != '')
		{
			if($_REQUEST['module'] == 'Catalogs' && $fieldname = 'catalogid')
			{
				$catalog_name = '';	
			}
			else
			{
				$value = $_REQUEST['catalogid'];
				$catalog_name = getCatalogName($value);		
			}

		}

		//Checking for Exhibitions duplicate

		$editview_label[] = $mod_strings[$fieldlabel];
		$fieldvalue[] = $catalog_name;
		$fieldvalue[] = $value;
	}
	elseif($uitype == 1009)
	{
		$vcontact_name = "";
		if($value != '')
		{
			$vcontact_name = getVcontactName($value);
		}
		elseif(isset($_REQUEST['vcontactsid']) && $_REQUEST['vcontactsid'] != '')
		{
			if($_REQUEST['module'] == 'Vcontacts' && $fieldname = 'vcontactsid')
			{
				$vcontact_name = '';	
			}
			else
			{
				$value = $_REQUEST['vcontactsid'];
				$vcontact_name = getVcontactName($value);		
			}

		}

		//Checking for Exhibitions duplicate

		$editview_label[] = $mod_strings[$fieldlabel];
		$fieldvalue[] = $vcontact_name;
		$fieldvalue[] = $value;
	}
	elseif($uitype == 1012)
	{
		$projectname = "";
		if($value != '')
		{
			$projectname = getProjectName($value);
		}
		elseif(isset($_REQUEST['projectsid']) && $_REQUEST['projectsid'] != '')
		{
			if($_REQUEST['module'] == 'Projects' && $fieldname = 'projectsid')
			{
				$projectname = '';	
			}
			else
			{
				$value = $_REQUEST['projectsid'];
				$projectname = getProjectName($value);		
			}

		}
		$editview_label[] = $mod_strings[$fieldlabel];
		$fieldvalue[] = $projectname;
		$fieldvalue[] = $value;
	}
	elseif($uitype == 1011)
	{
		$projecttemplatename = "";
		if($value != '')
		{
			$projecttemplatename = getProjecttemplateName($value);
		}
		elseif(isset($_REQUEST['projecttemplatesid']) && $_REQUEST['projecttemplatesid'] != '')
		{
			if($_REQUEST['module'] == 'Projecttemplates' && $fieldname = 'projecttemplatesid')
			{
				$projecttemplatename = '';	
			}
			else
			{
				$value = $_REQUEST['projecttemplatesid'];
				$projecttemplatename = getProjecttemplateName($value);		
			}

		}
		$editview_label[] = $mod_strings[$fieldlabel];
		$fieldvalue[] = $projecttemplatename;
		$fieldvalue[] = $value;
	}
	elseif($uitype == 1013)
	{
		$faqcategory_name = "";
		if($value != '')
		{
			$faqcategory_name = getFaqcategoryName($value);
		}
		elseif(isset($_REQUEST['faqcategoryid']) && $_REQUEST['faqcategoryid'] != '')
		{
			if($_REQUEST['module'] == 'Faqcategorys' && $fieldname = 'faqcategoryid')
			{
				$faqcategory_name = '';	
			}
			else
			{
				$value = $_REQUEST['faqcategoryid'];
				$faqcategory_name = getFaqcategoryName($value);		
			}

		}


		$editview_label[] = $mod_strings[$fieldlabel];
		$fieldvalue[] = $faqcategory_name;
		$fieldvalue[] = $value;
	}
	else
	{
		//Added condition to set the subject if click Reply All from web mail
		if($_REQUEST['module'] == 'Emails' && $_REQUEST['mg_subject'] != '')
		{
			$value = $_REQUEST['mg_subject'];
		}
		$editview_label[]=$mod_strings[$fieldlabel];
		if($uitype == 1 && ($fieldname=='expectedrevenue' || $fieldname=='budgetcost' || $fieldname=='actualcost' || $fieldname=='expectedroi' || $fieldname=='actualroi' ) && ($module_name=='Campaigns'))
		{
			//$rate_symbol = getCurrencySymbolandCRate($user_info['currency_id']);
			$fieldvalue[] = getConvertedPrice($value,true);
		}
		else
			$fieldvalue[] = $value;
	}

	// Mike Crowe Mod --------------------------------------------------------force numerics right justified.
	if ( !eregi("id=",$custfld) )
		$custfld = preg_replace("/<input/iS","<input id='$fieldname' ",$custfld);

	if ( in_array($uitype,array(71,72,7,9,90)) )
	{
		$custfld = preg_replace("/<input/iS","<input align=right ",$custfld);
	}
	$final_arr[]=$ui_type;
	$final_arr[]=$editview_label;
	$final_arr[]=$editview_fldname;
	$final_arr[]=$fieldvalue;
	$log->debug("Exiting getOutputHtml method ...");
	return $final_arr;
}

/** This function returns the ec_invoice object populated with the details from sales order object.
* Param $focus - Invoice object
* Param $so_focus - Sales order focus
* Param $soid - sales order id
* Return type is an object array
*/

function getConvertSoToInvoice($focus,$so_focus,$soid)
{
	global $log;
	//changed by dingjianting on 2007-11-05 for php5.2.x
	$log->debug("Entering getConvertSoToInvoice() method ...");
	$focus->column_fields['salesorder_id'] = $soid;
	//$focus->column_fields['subject'] = $so_focus->column_fields['subject'];
	$focus->column_fields['customerno'] = $so_focus->column_fields['customerno'];
	$focus->column_fields['duedate'] = $so_focus->column_fields['duedate'];
	$focus->column_fields['contact_id'] = $so_focus->column_fields['contact_id'];//to include contact name in Invoice
	$focus->column_fields['account_id'] = $so_focus->column_fields['account_id'];
	$focus->column_fields['exciseduty'] = $so_focus->column_fields['exciseduty'];
	$focus->column_fields['salescommission'] = $so_focus->column_fields['salescommission'];
	$focus->column_fields['purchaseorder'] = $so_focus->column_fields['purchaseorder'];
	//added by dingjianting on 2006-12-28 for gloso project
	//begin
	$focus->column_fields['currency'] = $so_focus->column_fields['currency'];
	//end
	/*
	$focus->column_fields['bill_street'] = $so_focus->column_fields['bill_street'];
	$focus->column_fields['ship_street'] = $so_focus->column_fields['ship_street'];
	$focus->column_fields['bill_city'] = $so_focus->column_fields['bill_city'];
	$focus->column_fields['ship_city'] = $so_focus->column_fields['ship_city'];
	$focus->column_fields['bill_state'] = $so_focus->column_fields['bill_state'];
	$focus->column_fields['ship_state'] = $so_focus->column_fields['ship_state'];
	$focus->column_fields['bill_code'] = $so_focus->column_fields['bill_code'];
	$focus->column_fields['ship_code'] = $so_focus->column_fields['ship_code'];
	$focus->column_fields['bill_country'] = $so_focus->column_fields['bill_country'];
	$focus->column_fields['ship_country'] = $so_focus->column_fields['ship_country'];
	$focus->column_fields['bill_pobox'] = $so_focus->column_fields['bill_pobox'];
	$focus->column_fields['ship_pobox'] = $so_focus->column_fields['ship_pobox'];
	*/
	$focus->column_fields['description'] = $so_focus->column_fields['description'];
	$focus->column_fields['terms_conditions'] = $so_focus->column_fields['terms_conditions'];

	$log->debug("Exiting getConvertSoToInvoice method ...");
	return $focus;

}

/** This function returns the ec_invoice object populated with the details from quote object.
* Param $focus - Invoice object
* Param $quote_focus - Quote order focus
* Param $quoteid - quote id
* Return type is an object array
*/


function getConvertQuoteToInvoice($focus,$quote_focus,$quoteid)
{
	global $log;
	//changed by dingjianting on 2007-11-05 for php5.2.x
	$log->debug("Entering getConvertQuoteToInvoice() method ...");

	//$focus->column_fields['subject'] = $quote_focus->column_fields['subject'];
	$focus->column_fields['account_id'] = $quote_focus->column_fields['account_id'];
	//added by dingjianting on 2006-12-28 for gloso project
	//begin
	$focus->column_fields['currency'] = $quote_focus->column_fields['currency'];
	//end
	/*
	$focus->column_fields['bill_street'] = $quote_focus->column_fields['bill_street'];
	$focus->column_fields['ship_street'] = $quote_focus->column_fields['ship_street'];
	$focus->column_fields['bill_city'] = $quote_focus->column_fields['bill_city'];
	$focus->column_fields['ship_city'] = $quote_focus->column_fields['ship_city'];
	$focus->column_fields['bill_state'] = $quote_focus->column_fields['bill_state'];
	$focus->column_fields['ship_state'] = $quote_focus->column_fields['ship_state'];
	$focus->column_fields['bill_code'] = $quote_focus->column_fields['bill_code'];
	$focus->column_fields['ship_code'] = $quote_focus->column_fields['ship_code'];
	$focus->column_fields['bill_country'] = $quote_focus->column_fields['bill_country'];
	$focus->column_fields['ship_country'] = $quote_focus->column_fields['ship_country'];
	$focus->column_fields['bill_pobox'] = $quote_focus->column_fields['bill_pobox'];
	$focus->column_fields['ship_pobox'] = $quote_focus->column_fields['ship_pobox'];
	*/
	$focus->column_fields['description'] = $quote_focus->column_fields['description'];
	$focus->column_fields['terms_conditions'] = $quote_focus->column_fields['terms_conditions'];

	$log->debug("Exiting getConvertQuoteToInvoice method ...");
	return $focus;

}

/** This function returns the sales order object populated with the details from quote object.
* Param $focus - Sales order object
* Param $quote_focus - Quote order focus
* Param $quoteid - quote id
* Return type is an object array
*/

function getConvertQuoteToSoObject($focus,$quote_focus,$quoteid)
{
	global $log;
	//changed by dingjianting on 2007-11-05 for php5.2.x
	$log->debug("Entering getConvertQuoteToSoObject() method ...");
        $focus->column_fields['quote_id'] = $quoteid;
        //$focus->column_fields['subject'] = $quote_focus->column_fields['subject'];
        $focus->column_fields['contact_id'] = $quote_focus->column_fields['contact_id'];
        $focus->column_fields['potential_id'] = $quote_focus->column_fields['potential_id'];
        $focus->column_fields['account_id'] = $quote_focus->column_fields['account_id'];
        $focus->column_fields['carrier'] = $quote_focus->column_fields['carrier'];
		//added by dingjianting on 2006-12-28 for gloso project
		//begin
		$focus->column_fields['currency'] = $quote_focus->column_fields['currency'];
		//end
		/*
        $focus->column_fields['bill_street'] = $quote_focus->column_fields['bill_street'];
        $focus->column_fields['ship_street'] = $quote_focus->column_fields['ship_street'];
        $focus->column_fields['bill_city'] = $quote_focus->column_fields['bill_city'];
        $focus->column_fields['ship_city'] = $quote_focus->column_fields['ship_city'];
        $focus->column_fields['bill_state'] = $quote_focus->column_fields['bill_state'];
        $focus->column_fields['ship_state'] = $quote_focus->column_fields['ship_state'];
        $focus->column_fields['bill_code'] = $quote_focus->column_fields['bill_code'];
        $focus->column_fields['ship_code'] = $quote_focus->column_fields['ship_code'];
        $focus->column_fields['bill_country'] = $quote_focus->column_fields['bill_country'];
        $focus->column_fields['ship_country'] = $quote_focus->column_fields['ship_country'];
        $focus->column_fields['bill_pobox'] = $quote_focus->column_fields['bill_pobox'];
        $focus->column_fields['ship_pobox'] = $quote_focus->column_fields['ship_pobox'];
		*/
		$focus->column_fields['description'] = $quote_focus->column_fields['description'];
        $focus->column_fields['terms_conditions'] = $quote_focus->column_fields['terms_conditions'];

	$log->debug("Exiting getConvertQuoteToSoObject method ...");
        return $focus;

}

/** This function returns the detailed list of ec_products associated to a given entity or a record.
* Param $module - module name
* Param $focus - module object
* Param $seid - sales entity id
* Return type is an object array
*/


function getAssociatedProducts($module,$focus,$seid='')
{
	global $log;
	$log->debug("Entering getAssociatedProducts() method ...");
	global $adb;
	$output = '';
	global $theme,$current_user;
	
	$theme_path="themes/".$theme."/";
	$image_path=$theme_path."images/";
	$product_Detail = Array();
	
	// DG 15 Aug 2006
	// Add "ORDER BY sequence_no" to retain add order on all inventoryproductrel items
	
	if($module == 'Quotes')
	{
		$query="select ec_products.productname, ec_products.product_description, ec_products.unit_price,ec_products.serialno, ec_products.qtyinstock,ec_products.usageunit,ec_products.productcode,ec_products.imagename,ec_inventoryproductrel.* from ec_inventoryproductrel inner join ec_products on ec_products.productid=ec_inventoryproductrel.productid where id=".$focus->id." ORDER BY sequence_no";
	}
	elseif($module == 'PurchaseOrder')
	{
		$query="select ec_products.productname, ec_products.product_description, ec_products.unit_price,ec_products.serialno, ec_products.qtyinstock,ec_products.usageunit,ec_products.productcode,ec_products.imagename,ec_inventoryproductrel.* from ec_inventoryproductrel inner join ec_products on ec_products.productid=ec_inventoryproductrel.productid where id=".$focus->id." ORDER BY sequence_no";
	}
	elseif($module == 'SalesOrder')
	{
		$query="select ec_products.productname, ec_products.product_description, ec_products.unit_price,ec_products.serialno, ec_products.qtyinstock,ec_products.usageunit,ec_products.productcode,ec_products.imagename,ec_inventoryproductrel.* from ec_inventoryproductrel inner join ec_products on ec_products.productid=ec_inventoryproductrel.productid where id=".$focus->id." ORDER BY sequence_no";
	}
	elseif($module == 'Invoice')
	{
		$query="select ec_products.productname, ec_products.product_description, ec_products.unit_price,ec_products.serialno, ec_products.qtyinstock,ec_products.usageunit,ec_products.productcode,ec_products.imagename,ec_inventoryproductrel.* from ec_inventoryproductrel inner join ec_products on ec_products.productid=ec_inventoryproductrel.productid where id=".$focus->id." ORDER BY sequence_no";
	}
	elseif($module == 'Potentials')
	{
		$query="select ec_products.productname, ec_products.product_description, ec_products.serialno,ec_products.unit_price,ec_products.qtyinstock,ec_products.usageunit,ec_products.productcode,ec_products.imagename,ec_seproductsrel.* from ec_products inner join ec_seproductsrel on ec_seproductsrel.productid=ec_products.productid where crmid=".$seid;
	}
	elseif($module == 'Products')
	{
		$query="select ec_products.productid, ec_products.productname, ec_products.product_description,ec_products.serialno, ec_products.unit_price,ec_products.qtyinstock,ec_products.usageunit,ec_products.productcode,ec_products.imagename,ec_crmentity.* from ec_products inner join ec_crmentity on ec_crmentity.crmid=ec_products.productid where ec_crmentity.deleted=0 and productid=".$seid;
	}

	$result = $adb->query($query);
	$num_rows=$adb->num_rows($result);
	for($i=1;$i<=$num_rows;$i++)
	{
		$hdnProductId = $adb->query_result($result,$i-1,'productid');
		$productname=$adb->query_result($result,$i-1,'productname');
		$productdescription=$adb->query_result($result,$i-1,'product_description');
		$comment=$adb->query_result($result,$i-1,'comment');
		$qtyinstock=$adb->query_result($result,$i-1,'qtyinstock');
		$qty=$adb->query_result($result,$i-1,'quantity');
		$unitprice=$adb->query_result($result,$i-1,'unit_price');
		$listprice=$adb->query_result($result,$i-1,'listprice');
		$usageunit=$adb->query_result($result,$i-1,'usageunit');
		$productcode=$adb->query_result($result,$i-1,'productcode');
		$image_query = 'select ec_attachments.path, ec_attachments.attachmentsid, ec_attachments.name from ec_products left join ec_seattachmentsrel on ec_seattachmentsrel.crmid=ec_products.productid inner join ec_attachments on ec_attachments.attachmentsid=ec_seattachmentsrel.attachmentsid where productid='.$hdnProductId;
		$result_image = $adb->query($image_query);
		$nums = $adb->num_rows($result_image);
		if($nums > 0) {
			$image_id = $adb->query_result($result_image,0,'attachmentsid');	
			$image_name = $adb->query_result($result_image,0,'name');	
			$image_path = $adb->query_result($result_image,0,'path');
			$imagename = $image_path.$image_id."_".base64_encode_filename($image_name);
		} else {
			$imagename = "";
		}
		//$imagename = $adb->query_result($result,$i-1,'imagename');
		$serial_no = $adb->query_result($result,$i-1,'serialno');

		if($listprice == '')
			$listprice = $unitprice;
		if($qty =='')
			$qty = 1;

		//calculate productTotal
		$productTotal = $qty*$listprice;

		//Delete link in First column
		if($i != 1)
		{
			$product_Detail[$i]['delRow'.$i]="Del";
		}

		$product_Detail[$i]['hdnProductId'.$i] = $hdnProductId;
		$product_Detail[$i]['productName'.$i]= $productname;
		$product_Detail[$i]['productDescription'.$i]= $productdescription;
		$product_Detail[$i]['comment'.$i]= $comment;

		if($module != 'PurchaseOrder' && $focus->object_name != 'Order')
		{
			$product_Detail[$i]['qtyInStock'.$i]=$qtyinstock;
		}
		$listprice = getConvertedPriceFromDollar($listprice);
		$productTotal = getConvertedPriceFromDollar($productTotal);
		$product_Detail[$i]['qty'.$i]=$qty;
		$product_Detail[$i]['listPrice'.$i]=$listprice;
		$product_Detail[$i]['unitPrice'.$i]=$unitprice;
		$product_Detail[$i]['productTotal'.$i]=$productTotal;
		//changed by dingjianting on 2007-2-1 for banner project
		$product_Detail[$i]['usageunit'.$i]= $usageunit;
		$product_Detail[$i]['productcode'.$i]= $productcode;
		$product_Detail[$i]['imagename'.$i]= $imagename;		
		$product_Detail[$i]['netPrice'.$i] = $productTotal;
		$product_Detail[$i]['serial_no'.$i] = $serial_no;
	}


	//Get the Final Discount, S&H charge, Tax for S&H and Adjustment values
	//To set the Final Discount details
	$finalDiscount = '0.00';
	$product_Detail[1]['final_details']['discount_type_final'] = 'zero';

	$subTotal = ($focus->column_fields['hdnSubTotal'] != '')?$focus->column_fields['hdnSubTotal']:'0.00';
	$subTotal = getConvertedPriceFromDollar($subTotal);

	$discountPercent = ($focus->column_fields['hdnDiscountPercent'] != '')?$focus->column_fields['hdnDiscountPercent']:'0.00';
	$discountAmount = ($focus->column_fields['hdnDiscountAmount'] != '')?$focus->column_fields['hdnDiscountAmount']:'0.00';

	if($focus->column_fields['hdnDiscountPercent'] != '' && $focus->column_fields['hdnDiscountPercent'] != '0.0')
	{
		$finalDiscount = ($subTotal*$discountPercent/100);
		$product_Detail[1]['final_details']['discount_type_final'] = 'percentage';
		$product_Detail[1]['final_details']['discount_percentage_final'] = $discountPercent;
		$product_Detail[1]['final_details']['checked_discount_percentage_final'] = ' checked';
		$product_Detail[1]['final_details']['style_discount_percentage_final'] = ' style="visibility:visible"';
		$product_Detail[1]['final_details']['style_discount_amount_final'] = ' style="visibility:hidden"';
	}
	elseif($focus->column_fields['hdnDiscountAmount'] != '')
	{
		$finalDiscount = $focus->column_fields['hdnDiscountAmount'];
		$finalDiscount = getConvertedPriceFromDollar($finalDiscount);
		$discountAmount = getConvertedPriceFromDollar($discountAmount);

		$product_Detail[1]['final_details']['discount_type_final'] = 'amount';
		$product_Detail[1]['final_details']['discount_amount_final'] = $discountAmount;
		$product_Detail[1]['final_details']['checked_discount_amount_final'] = ' checked';
		$product_Detail[1]['final_details']['style_discount_amount_final'] = ' style="visibility:visible"';
		$product_Detail[1]['final_details']['style_discount_percentage_final'] = ' style="visibility:hidden"';
	}
	$product_Detail[1]['final_details']['discountTotal_final'] = $finalDiscount;


	//To set the Shipping & Handling charge
	$shCharge = ($focus->column_fields['hdnS_H_Amount'] != '')?$focus->column_fields['hdnS_H_Amount']:'0.00';
	$shCharge = getConvertedPriceFromDollar($shCharge);
	$product_Detail[1]['final_details']['shipping_handling_charge'] = $shCharge;

	//To set the Adjustment value
	$adjustment = ($focus->column_fields['txtAdjustment'] != '')?$focus->column_fields['txtAdjustment']:'0.00';
	$adjustment = getConvertedPriceFromDollar($adjustment);
	$product_Detail[1]['final_details']['adjustment'] = $adjustment;

	//To set the grand total
	$grandTotal = ($focus->column_fields['hdnGrandTotal'] != '')?$focus->column_fields['hdnGrandTotal']:'0.00';
	$grandTotal = getConvertedPriceFromDollar($grandTotal);
	$product_Detail[1]['final_details']['grandTotal'] = $grandTotal;

	$log->debug("Exiting getAssociatedProducts method ...");

	return $product_Detail;

}

/** This function returns the no of ec_products associated to the given entity or a record.
* Param $module - module name
* Param $focus - module object
* Param $seid - sales entity id
* Return type is an object array
*/

function getNoOfAssocProducts($module,$focus,$seid='')
{
	global $log;
	//changed by dingjianting on 2007-11-05 for php5.2.x
	$log->debug("Entering getNoOfAssocProducts() method ...");
	global $adb;
	$output = '';
	if($module == 'Quotes')
	{
		$query="select ec_products.productname, ec_products.unit_price, ec_inventoryproductrel.* from ec_inventoryproductrel inner join ec_products on ec_products.productid=ec_inventoryproductrel.productid where id=".$focus->id;
	}
	elseif($module == 'PurchaseOrder')
	{
		$query="select ec_products.productname, ec_products.unit_price, ec_inventoryproductrel.* from ec_inventoryproductrel inner join ec_products on ec_products.productid=ec_inventoryproductrel.productid where id=".$focus->id;
	}
	elseif($module == 'SalesOrder')
	{
		$query="select ec_products.productname, ec_products.unit_price, ec_inventoryproductrel.* from ec_inventoryproductrel inner join ec_products on ec_products.productid=ec_inventoryproductrel.productid where id=".$focus->id;
	}
	elseif($module == 'Invoice')
	{
		$query="select ec_products.productname, ec_products.unit_price, ec_inventoryproductrel.* from ec_inventoryproductrel inner join ec_products on ec_products.productid=ec_inventoryproductrel.productid where id=".$focus->id;
	}
	elseif($module == 'Potentials')
	{
		$query="select ec_products.productname,ec_products.unit_price,ec_seproductsrel.* from ec_products inner join ec_seproductsrel on ec_seproductsrel.productid=ec_products.productid where crmid=".$seid;
	}	
	elseif($module == 'Products')
	{
		$query="select ec_products.productname,ec_products.unit_price, ec_crmentity.* from ec_products inner join ec_crmentity on ec_crmentity.crmid=ec_products.productid where ec_crmentity.deleted=0 and productid=".$seid;
	}


	$result = $adb->query($query);
	$num_rows=$adb->num_rows($result);
	$log->debug("Exiting getNoOfAssocProducts method ...");
	return $num_rows;
}

/** This function returns the detail block information of a record for given block id.
* Param $module - module name
* Param $block - block name
* Param $mode - view type (detail/edit/create)
* Param $col_fields - ec_fields array
* Param $tabid - ec_tab id
* Param $info_type - information type (basic/advance) default ""
* Return type is an object array
*/

function getBlockInformation($module, $result, $col_fields,$tabid,$block_label,$mode)
{
	global $log;
	//changed by dingjianting on 2007-11-05 for php5.2.x
	$log->debug("Entering getBlockInformation() method ...");
	global $adb;
	$editview_arr = Array();
	$returndata = Array();

	global $current_user,$mod_strings;
	
	$noofrows = $adb->num_rows($result);
	/*
	//changed by dingjianting on 2007-12-12 for php notice error
	if (($module == 'Accounts' || $module == 'Contacts' || $module == 'Quotes' || $module == 'PurchaseOrder' || $module == 'SalesOrder'|| $module == 'Invoice') && $block == 2)
	{
            $log->info("module is ".$module);

			$mvAdd_flag = true;
			$moveAddress = "<td rowspan='6' valign='middle' align='center'><input title='Copy billing address to shipping address'  class='button' onclick='return copyAddressRight(EditView)'  type='button' name='copyright' value='&raquo;' style='padding:0px 2px 0px 2px;font-size:12px'><br><br>
				<input title='Copy shipping address to billing address'  class='button' onclick='return copyAddressLeft(EditView)'  type='button' name='copyleft' value='&laquo;' style='padding:0px 2px 0px 2px;font-size:12px'></td>";
	}
	*/
	

	for($i=0; $i<$noofrows; $i++)
	{
		$fieldtablename = $adb->query_result($result,$i,"tablename");	
		$fieldcolname = $adb->query_result($result,$i,"columnname");	
		$uitype = $adb->query_result($result,$i,"uitype");	
		$fieldname = $adb->query_result($result,$i,"fieldname");	
		$fieldlabel = $adb->query_result($result,$i,"fieldlabel");
		$block = $adb->query_result($result,$i,"block");
		$maxlength = $adb->query_result($result,$i,"maximumlength");
		$generatedtype = $adb->query_result($result,$i,"generatedtype");
		$typeofdata = $adb->query_result($result,$i,"typeofdata");
		$mandatory = 0;
		if(substr_count($typeofdata,"~M") > 0) {
			$mandatory = 1;
		}
		//added by dingjianting on 2007-2-5 for approve function by read/write permittion
		$readonly = 1;
		if(!is_admin($current_user)) {
			$readonly = $adb->query_result($result,$i,"profile_readonly");
		}
		//$readonly = $adb->query_result($result,$i,"profile_readonly");
		//if($readonly == '') $readonly = 1;

		$custfld = getOutputHtml($uitype, $fieldname, $fieldlabel, $maxlength, $col_fields,$generatedtype,$module,$mode);
		$custfld[0][1] = $readonly;
		$custfld[0][2] = $mandatory;
		$editview_arr[$block][]=$custfld;
		if (isset($mvAdd_flag) && $mvAdd_flag == true) {
			$mvAdd_flag = false;
		}
		$i++;
		if($i<$noofrows)
		{
			$fieldtablename = $adb->query_result($result,$i,"tablename");	
			$fieldcolname = $adb->query_result($result,$i,"columnname");	
			$uitype = $adb->query_result($result,$i,"uitype");	
			$fieldname = $adb->query_result($result,$i,"fieldname");	
			$fieldlabel = $adb->query_result($result,$i,"fieldlabel");
			$block = $adb->query_result($result,$i,"block");
			$maxlength = $adb->query_result($result,$i,"maximumlength");
			$generatedtype = $adb->query_result($result,$i,"generatedtype");
			$typeofdata = $adb->query_result($result,$i,"typeofdata");
			$mandatory = 0;
			if(substr_count($typeofdata,"~M") > 0) {
				$mandatory = 1;
			}
			//added by dingjianting on 2007-2-5 for approve function by read/write permittion
			$readonly = 1;
			if(!is_admin($current_user)) {
				$readonly = $adb->query_result($result,$i,"profile_readonly");
			}
		    //$readonly = $adb->query_result($result,$i,"profile_readonly");
			//if($readonly == '') $readonly = 1;
			$custfld = getOutputHtml($uitype, $fieldname, $fieldlabel, $maxlength, $col_fields,$generatedtype,$module,$mode);
		    $custfld[0][1] = $readonly;
			$custfld[0][2] = $mandatory;
			
			
			$editview_arr[$block][]=$custfld;
		}
	}
	foreach($editview_arr as $headerid=>$editview_value)
	{
		$editview_data = Array();
		for ($i=0,$j=0;$i<count($editview_value);$i=$i+2,$j++)
		{
			$key1=$editview_value[$i];
			$key2 = null;
			if(isset($editview_value[$i+1]) && is_array($editview_value[$i+1]))
			{
				$key2 = $editview_value[$i+1];
			}
			else
			{
				$key2 = array();
			}
			$editview_data[$j]=array(0 => $key1,1 => $key2);
		}
		$editview_arr[$headerid] = $editview_data;
	}
	foreach($block_label as $blockid=>$label)
	{
		if($label == '')
		{
			if(isset($mod_strings[$curBlock])) {
				$curBlock = $mod_strings[$curBlock];
			}			$returndata[$curBlock]=array_merge((array)$returndata[$curBlock],(array)$editview_arr[$blockid]);
		}
		else
		{
			$curBlock = $label;
			if(isset($mod_strings[$label])) {
				$label = $mod_strings[$label];
			}
			if(isset($returndata[$label]) && is_array($returndata[$label])) {
				$returndata_arr = $returndata[$label];
			} else {
				$returndata_arr = array();
			}
			if(isset($editview_arr[$blockid]) && is_array($editview_arr[$blockid])) {
				//$returndata[$label]=array_merge((array)$returndata[$label],(array)$editview_arr[$blockid]);
				$returndata[$label] = array_merge((array)$returndata_arr,(array)$editview_arr[$blockid]);
			}
		}
	}
	$log->debug("Exiting getBlockInformation method ...");
	return $returndata;	
	
}

/** This function returns the data type of the ec_fields, with ec_field label, which is used for javascript validation.
* Param $validationData - array of ec_fieldnames with datatype
* Return type array 
*/


function split_validationdataArray($validationData)
{
	global $log;
	$log->debug("Entering split_validationdataArray() method ...");
	$fieldName = '';
	$fieldLabel = '';
	$fldDataType = '';
	$rows = count($validationData);
	foreach($validationData as $fldName => $fldLabel_array)
	{
		if($fieldName == '')
		{
			$fieldName="'".$fldName."'";
		}
		else
		{
			$fieldName .= ",'".$fldName ."'";
		}
		foreach($fldLabel_array as $fldLabel => $datatype)
		{
			if($fieldLabel == '')
			{
				$fieldLabel = "'".$fldLabel ."'";
			}
			else
			{
				$fieldLabel .= ",'".$fldLabel ."'";
			}
			if($fldDataType == '')
			{
				$fldDataType = "'".$datatype ."'";
			}
			else
			{
				$fldDataType .= ",'".$datatype ."'";
			}
		}
	}
	$data['fieldname'] = $fieldName;
	$data['fieldlabel'] = $fieldLabel;
	$data['datatype'] = $fldDataType;
	$log->debug("Exiting split_validationdataArray method ...");
	return $data;
}


?>
