<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version 1.1.2
 * ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an  "AS IS"  basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************
 * $Header: /advent/projects/wesat/ec_crm/sugarcrm/install/5createTables.php,v 1.58 2005/04/19 16:57:08 ray Exp $
 * Description:  Executes a step in the installation process.
 ********************************************************************************/

$new_tables = 0;

require_once('config.php');
require_once('include/database/PearDatabase.php');
require_once('include/logging.php');
require_once('modules/Contacts/Contacts.php');
require_once('modules/Accounts/Accounts.php');
require_once('modules/Potentials/Potentials.php');
require_once('modules/Calendar/Activity.php');
require_once('modules/Notes/Notes.php');
require_once('modules/Emails/Emails.php');
require_once('modules/Users/Users.php');
require_once('modules/Import/ImportMap.php');
require_once('modules/Import/UsersLastImport.php');
require_once('modules/Users/LoginHistory.php');
require_once('data/Tracker.php');
require_once('include/utils/utils.php');
require_once('install/DefaultDataPopulator.php');
require_once('modules/Users/CreateUserPrivilegeFile.php');

require_once('modules/Balances/BalancesDataPopulator.php');
require_once('modules/Cares/CaresDataPopulator.php');
require_once('modules/Checks/ChecksDataPopulator.php');
require_once('modules/Deliverys/DeliverysDataPopulator.php');
require_once('modules/Funnels/FunnelsDataPopulator.php');
require_once('modules/Maillists/MaillistsDataPopulator.php');
require_once('modules/Prdtnums/PrdtnumsDataPopulator.php');
require_once('modules/Qunfas/QunfasDataPopulator.php');
require_once('modules/Warehouses/WarehousesDataPopulator.php');

require_once('modules/Bsteps/BstepsDataPopulator.php');
require_once('modules/Fsteps/FstepsDataPopulator.php');
require_once('modules/Isteps/IstepsDataPopulator.php');
require_once('modules/Ssteps/SstepsDataPopulator.php');
require_once('modules/Catalogs/CatalogsDataPopulator.php');
require_once('modules/Ureports/UreportsDataPopulator.php');
require_once('modules/Vcontacts/VcontactsDataPopulator.php');

require_once('modules/Tuihuos/TuihuosDataPopulator.php');
require_once('modules/Performances/PerformancesDataPopulator.php');

require_once('modules/Faqcategorys/FaqcategorysDataPopulator.php');
//require_once('modules/Projects/ProjectsDataPopulator.php');
//require_once('modules/Projecttasks/ProjecttasksDataPopulator.php');
require_once('modules/Vnotes/VnotesDataPopulator.php');
require_once('modules/Salesobjects/SalesobjectsDataPopulator.php');




// load the config_override.php file to provide default user settings
if (is_file("config_override.php")) {
	require_once("config_override.php");
}

global $adb;

$log =& LoggerManager::getLogger('INSTALL');

function eecho($msg = FALSE) {
	if ($useHtmlEntities) {
		echo htmlentities(nl2br($msg));
	}
	else {
		echo $msg;
	}
}


function create_default_users() {
	global $log, $adb;
	global $admin_email;
	global $admin_password;
	global $create_default_user;
	global $default_user_name;
	global $default_password;
	global $default_user_is_admin;
	global $site_URL;

	// create default admin user
	$user = new Users();
	$user->column_fields["last_name"] = 'Administrator';
	$user->column_fields["user_name"] = 'admin';
	$user->column_fields["status"] = 'Active';
	$user->column_fields["is_admin"] = 'on';
	$user->column_fields["user_password"] = $admin_password;
	$user->column_fields["tz"] = 'Europe/Berlin';
	$user->column_fields["holidays"] = 'de,en_uk,fr,it,us,';
	$user->column_fields["workdays"] = '0,1,2,3,4,5,6,';
	$user->column_fields["weekstart"] = '1';
	$user->column_fields["namedays"] = '';
	$user->column_fields["currency_id"] = 1;
	$user->column_fields["date_format"] = 'yyyy-mm-dd';
	$user->column_fields["hour_format"] = '24';
	$user->column_fields["start_hour"] = '08:00';
	$user->column_fields["end_hour"] = '23:00';
	$user->column_fields["imagename"] = '';
	$user->column_fields["activity_view"] = 'This Year';	
	$user->column_fields["lead_view"] = 'Today';
	$user->column_fields["defhomeview"] = 'home_metrics';
	//added by philip for default default admin emailid
	if($admin_email == '')
	$admin_email ="admin@c3crm.com";
	$user->column_fields["email1"] = $admin_email;
	//to get the role id for standard_user	
	$role_query = "select roleid from ec_role where rolename='总经理'";
	$adb->checkConnection();
	$adb->database->SetFetchMode(ADODB_FETCH_ASSOC);
	$role_result = $adb->query($role_query);
	$role_id = $adb->query_result($role_result,0,"roleid");
	$user->column_fields["roleid"] = $role_id;
	//$user->column_fields["homeorder"] = "CVLVT,ALVT,PLVT,QLTQ,HLT,OLV,GRT,OLTSO,ILTI,OLTPO,LTFAQ,Notes,Charges,Gathers,Expenses,Documents";

	$user->save("Users");

	//Inserting Entries into ec_groups table
	$result = $adb->query("select groupid from ec_groups where groupname='销售组';");
	$group1_id = $adb->query_result($result,0,"groupid");
	$result = $adb->query("select groupid from ec_groups where groupname='市场组';");
	$group2_id = $adb->query_result($result,0,"groupid");
	$result = $adb->query("select groupid from ec_groups where groupname='支持组';");
	$group3_id = $adb->query_result($result,0,"groupid");

	$adb->query("insert into ec_users2group values ('".$group2_id."',".$user->id.")");

	$homeorder = "CVLVT,HDB,ALVT,PLVT,QLTQ,HLT,OLV,OLTSO,ILTI,OLTPO,LTFAQ,Notes,Charges,Gathers,Expenses,Documents";
	$query = "update ec_users set homeorder ='$homeorder' where id=$user->id";
	$adb->query($query);

	// we need to change the admin user to a fixed id of 1.
	//$query = "update ec_users set id='1' where user_name='$user->user_name'";
	//$result = $adb->query($query, true, "Error updating admin user ID: ");

	$log->info("Created ".$user->table_name." ec_table. for user $user->id");

	//Creating the flat files
	createUserPrivilegesfile($user->id);
	createUserSharingPrivilegesfile($user->id);
}


//$startTime = microtime();			
// tables creation
//eecho("Creating Core tables: ");
//$adb->setDebug(true);
$success = $adb->createTables("schema/DatabaseSchema.xml");

$table_messages = "CREATE TABLE `ajaxim_messages` ( `recipient` text, `sender` text, `message` text, `type` text, `stamp` text, `id` bigint(20) unsigned NOT NULL auto_increment,received int(1) default '0',deleted_sender int(1) default '0',deleted_recipient int(1) default '0', UNIQUE KEY `id` (`id`) ) ;";
$adb->query($table_messages);

//$table_chats = 'CREATE TABLE `ajaxim_chats` ( `room` text, `user` text, `id` bigint(20) unsigned NOT NULL auto_increment, UNIQUE KEY `id` (`id`) ) ;';
//$adb->query($table_chats);

$query = "CREATE TABLE IF NOT EXISTS ec_homedefault (
  stuffid int(19) NOT NULL default '0',
  stuffsequence int(19) NOT NULL default '0',
  stufftype varchar(100) default NULL,
  PRIMARY KEY  (stuffid),
  KEY stuff_stuffid_idx (stuffid)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";
$adb->query($query);


$query = "CREATE TABLE IF NOT EXISTS ec_homestuff (
  stuffid int(19) NOT NULL default '0',
  stuffsequence int(19) NOT NULL default '0',
  stufftype varchar(100) default NULL,
  userid int(19) NOT NULL,
  visible int(10) NOT NULL default '0',
  stufftitle varchar(100) default NULL,
  PRIMARY KEY  (stuffid),
  KEY stuff_stuffid_idx (stuffid),
  KEY fk_1_ec_homestuff (userid)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";
$adb->query($query);

$query = "INSERT INTO ec_homedefault (stuffid, stuffsequence, stufftype) VALUES
(1, 1, 'key_customview'),
(2, 2, 'top_salesbymonth'),
(3, 3, 'top_account'),
(4, 4, 'top_calendar'),
(5, 5, 'top_performance'),
(6, 6, 'note_pad');";
$adb->query($query);


//Postgres8 fix - create sequences. 
//   This should be a part of "createTables" however ...
 if( $adb->dbType == "pgsql" ) {
     $sequences = array(
 	"ec_leadsource_seq",
 	"ec_accounttype_seq",
 	"ec_industry_seq",
 	"ec_leadstatus_seq",
 	"ec_rating_seq",
 	"ec_opportunity_type_seq",
 	"ec_salutationtype_seq",
 	"ec_sales_stage_seq",
 	"ec_ticketstatus_seq",
 	"ec_ticketpriorities_seq",
 	"ec_ticketseverities_seq",
 	"ec_ticketcategories_seq",
 	"ec_duration_minutes_seq",
 	"ec_eventstatus_seq",
 	"ec_taskstatus_seq",
 	"ec_taskpriority_seq",
 	"ec_manufacturer_seq",
 	"ec_productcategory_seq",
 	"ec_activitytype_seq",
 	"ec_currency_seq",
 	"ec_faqcategories_seq",
 	"ec_usageunit_seq",
 	"ec_quotestage_seq",
 	"ec_carrier_seq",
 	"ec_taxclass_seq",
 	"ec_recurringtype_seq",
 	"ec_faqstatus_seq",
 	"ec_invoicestatus_seq",
 	"ec_postatus_seq",
 	"ec_sostatus_seq",
 	"ec_visibility_seq",
 	"ec_campaigntype_seq",
 	"ec_campaignstatus_seq",
 	"ec_expectedresponse_seq",
 	"ec_status_seq",
 	"ec_activity_view_seq",
 	"ec_lead_view_seq",
 	"ec_date_format_seq",
 	"ec_users_seq",
 	"ec_role_seq",
 	"ec_profile_seq",
 	"ec_field_seq",
 	"ec_def_org_share_seq",
 	"ec_datashare_relatedmodules_seq",
 	"ec_relatedlists_seq",
 	"ec_notificationscheduler_seq",
 	"ec_inventorynotification_seq",
 	"ec_currency_info_seq",
 	"ec_emailtemplates_seq",
 	"ec_inventory_tandc_seq",
 	"ec_selectquery_seq",
 	"ec_customview_seq",
 	"ec_crmentity_seq",
 	"ec_seactivityrel_seq",
 	"ec_freetags_seq",
 	"ec_shippingtaxinfo_seq",
 	"ec_inventorytaxinfo_seq"
 	);
 
    foreach ($sequences as $sequence ) {
		$log->info( "Creating sequence ".$sequence);
		$adb->query( "CREATE SEQUENCE ".$sequence." INCREMENT BY 1 NO MAXVALUE NO MINVALUE CACHE 1;");
    }
 }


// TODO HTML
if($success==0)
	die("Error: 创建数据库表失败.\n");
elseif ($success==1)
	die("Error: 部分表创建成功。创建数据库表失败.\n");
	//eecho("Tables Successfully created.\n");
$modules = array("DefaultDataPopulator","BalancesDataPopulator","CaresDataPopulator","ChecksDataPopulator","DeliverysDataPopulator","FunnelsDataPopulator","MaillistsDataPopulator","PrdtnumsDataPopulator","QunfasDataPopulator","WarehousesDataPopulator","BstepsDataPopulator","FstepsDataPopulator","IstepsDataPopulator","SstepsDataPopulator","CatalogsDataPopulator","UreportsDataPopulator","VcontactsDataPopulator","TuihuosDataPopulator","PerformancesDataPopulator","FaqcategorysDataPopulator","VnotesDataPopulator","SalesobjectsDataPopulator");
//"ProjectsDataPopulator","ProjecttasksDataPopulator",
$focus=0;
foreach ($modules as $module ) 
{
	$focus = new $module();
	$focus->create_tables();
	$focus->create_defautdata();
}
			

// create and populate combo tables
require_once('install/PopulateComboValues.php');
$combo = new PopulateComboValues();
$combo->create_tables();

//Writing tab data in flat file
create_tab_data_file();
create_parenttab_data_file();

create_default_users();

// default report population
require_once('install/PopulateReports.php');

// default customview population
require_once('install/PopulateCustomView.php');


// ensure required sequences are created (adodb creates them as needed, but if
// creation occurs within a transaction we get problems
$adb->getUniqueID("ec_crmentity");
$adb->getUniqueID("ec_seactivityrel");
$adb->getUniqueID("ec_freetags");

//Master currency population
//Insert into ec_currency ec_table
$adb->query("insert into ec_currency_info values(".$adb->getUniqueID("ec_currency_info").",'$currency_name','$currency_code','$currency_symbol',1,'Active','-11')");

?>