<?php
/*********************************************************************************
** The contents of this file are subject to the vtiger CRM Public License Version 1.0
 * ("License"); You may not use this file except in compliance with the License
 * The Original Code is:  vtiger CRM Open Source
 * The Initial Developer of the Original Code is vtiger.
 * Portions created by vtiger are Copyright (C) vtiger.
 * All Rights Reserved.
 ********************************************************************************/

include_once('config.php');
require_once('include/logging.php');
require_once('include/language/zh_cn.lang.php');
require_once('include/database/PearDatabase.php');
require_once('install/ComboStrings.php');
/**
 *  Class which handles the population of the combo values
 * 
 *
 */
class PopulateComboValues
{
	var $app_list_strings;


	/** 
	 * To populate the default combo values for the combo ec_tables
	 * @param $values -- values:: Type string array
	 * @param $tableName -- tablename:: Type string 
	 */
	function insertComboValues($values, $tableName)
	{
		global $log;
		$log->debug("Entering insertComboValues(".$values.", ".$tableName.") method ...");
		global $adb;
		$i=0;
		foreach ($values as $val => $cal)
		{
			$id = $adb->getUniqueID('ec_'.$tableName);
			//changed by dingjianting on 2006-10-2 for dropdown list in simplized chinese
			if($cal != '')
			{
				//$adb->query("insert into ec_".$tableName. " values(".$id.",'".$val."',".$i.",1)");
				$adb->query("insert into ec_".$tableName. " values(".$id.",'".$cal."',".$i.",0)");
			}
			else
			{
				//changed by dingjianting on 2006-10-2 for dropdown list in simplized chinese
				$adb->query("insert into ec_".$tableName. " values(".$id.",".$app_strings['LBL_NONE'].",".$i.",0)");
			}
			$i++;
		}
		$log->debug("Exiting insertComboValues method ...");
	}


	/** 
	 * To populate the combo ec_tables at startup time
	 */

	function create_tables () 
	{
		global $log;
		$log->debug("Entering create_tables () method ...");
				
		global $app_list_strings,$adb;
		global $combo_strings;
		$comboTables = Array('leadsource','accounttype','industry','leadstatus','rating','opportunity_type','salutationtype','sales_stage','ticketstatus','ticketpriorities','ticketseverities','ticketcategories','duration_minutes','eventstatus','eventtype','taskstatus','taskpriority','manufacturer','productcategory','activitytype','currency','faqcategories','usageunit','quotestage','carrier','taxclass','recurringtype','faqstatus','invoicestatus','postatus','sostatus','visibility','campaigntype','campaignstatus','expectedresponse','status','activity_view','lead_view','date_format','calendartype','notetype','paymenttype','gatherstatus','isinvoice','gathertimes','chargestatus','chargetimes','expensestatus','expensecategory','expensebill','grade','employees','annualrevenue','ownership','documentcategory','probability');

		foreach ($comboTables as $comTab)
		{
			$this->insertComboValues($combo_strings[$comTab."_dom"],$comTab);
		}
		$log->debug("Exiting create_tables () method ...");

		//some items in picklist can not be changed such as close win
		//$sql = "update ec_sales_stage set presence=1 where sales_stage in ('谈成结束','未成结束')";
		//$adb->query($sql);
		$sql = "update ec_eventstatus set presence=1";
		$adb->query($sql);
		$sql = "update ec_ticketstatus set presence=1";
		$adb->query($sql);
		$sql = "update ec_ticketpriorities set presence=1";
		$adb->query($sql);
		$sql = "update ec_ticketseverities set presence=1";
		$adb->query($sql);
		$sql = "update ec_faqstatus set presence=1";
		$adb->query($sql);
		//$sql = "update ec_quotestage set presence=1 where quotestage in ('已接受','已拒绝')";
		//$adb->query($sql);
		//$sql = "update ec_postatus set presence=1 where postatus in ('已取消','已入库','货已到')";
		//$adb->query($sql);
		//$sql = "update ec_sostatus set presence=1 where sostatus in ('已取消','已出库','已发送')";
		//$adb->query($sql);
		//$sql = "update ec_invoicestatus set presence=1 where invoicestatus in ('已付款')";
		//$adb->query($sql);
		$sql = "update ec_gatherstatus set presence=1 where gatherstatus in ('未收','已收')";
		$adb->query($sql);
		$sql = "update ec_chargestatus set presence=1 where chargestatus in ('未收','已收')";
		$adb->query($sql);
		$sql = "update ec_expensestatus set presence=1";
		$adb->query($sql);
	}
}
?>
