<?php
/*********************************************************************************
** The contents of this file are subject to the vtiger CRM Public License Version 1.0
 * ("License"); You may not use this file except in compliance with the License
 * The Original Code is:  vtiger CRM Open Source
 * The Initial Developer of the Original Code is vtiger.
 * Portions created by vtiger are Copyright (C) vtiger.
 * All Rights Reserved.
*
 ********************************************************************************/
require_once('include/database/PearDatabase.php');
//require_once('modules/Reports/CannedReports.php');
global $adb;
global $mod_strings;
global $app_strings;

$rptfolder = Array(Array('Account and Contact Reports'=>$mod_strings['Account and Contact Reports']),
	           Array('Potential Reports'=>$mod_strings['Potential Reports']),
		   Array('Activity Reports'=>$mod_strings['Activity Reports']),
		   Array('HelpDesk Reports'=>$mod_strings['HelpDesk Reports']),
		   Array('Product Reports'=>$mod_strings['Product Reports']),
		   Array('Quote Reports' =>$mod_strings['Quote Reports']),
		   Array('PurchaseOrder Reports'=>$mod_strings['PurchaseOrder Reports']),
		   Array('Invoice Reports'=>$mod_strings['Invoice Reports']),
		   Array('SalesOrder Reports'=>$mod_strings['SalesOrder Reports']),
		   Array('Campaign Reports'=>$mod_strings['Campaign Reports']),
		   Array('Gathers Reports'=>$mod_strings['Gathers Reports']),
		   Array('Charges Reports'=>$mod_strings['Charges Reports']),
		   Array('Expenses Reports'=>$mod_strings['Expenses Reports']),
		   Array('Documents Reports'=>$mod_strings['Documents Reports'])
                  );

$reportmodules = Array(Array('primarymodule'=>'Contacts','secondarymodule'=>'Accounts'),
		       Array('primarymodule'=>'Contacts','secondarymodule'=>'Accounts'),
		       Array('primarymodule'=>'Contacts','secondarymodule'=>'Potentials'),
		       Array('primarymodule'=>'Potentials','secondarymodule'=>''),
		       Array('primarymodule'=>'Potentials','secondarymodule'=>''),
		       Array('primarymodule'=>'Calendar','secondarymodule'=>''),
		       Array('primarymodule'=>'Calendar','secondarymodule'=>''),
		       Array('primarymodule'=>'HelpDesk','secondarymodule'=>'Products'),
		       Array('primarymodule'=>'HelpDesk','secondarymodule'=>''),
  		       Array('primarymodule'=>'HelpDesk','secondarymodule'=>''),
		       Array('primarymodule'=>'Products','secondarymodule'=>''),
		       Array('primarymodule'=>'Quotes','secondarymodule'=>''),
		       Array('primarymodule'=>'Quotes','secondarymodule'=>''),
		       Array('primarymodule'=>'PurchaseOrder','secondarymodule'=>'Contacts'),
		       Array('primarymodule'=>'PurchaseOrder','secondarymodule'=>''),
		       Array('primarymodule'=>'Invoice','secondarymodule'=>''),
		       Array('primarymodule'=>'SalesOrder','secondarymodule'=>''),
		       Array('primarymodule'=>'Campaigns','secondarymodule'=>''),
			   Array('primarymodule'=>'Gathers','secondarymodule'=>''),
			   Array('primarymodule'=>'Charges','secondarymodule'=>''),
			   Array('primarymodule'=>'Expenses','secondarymodule'=>''),
			   Array('primarymodule'=>'Documents','secondarymodule'=>''),
		      );

$selectcolumns = Array(Array('ec_contactdetails:lastname:Contacts_Last_Name:lastname:V',
                             'ec_contactsubdetails:leadsource:Contacts_Lead_Source:leadsource:V',
                             'ec_accountContacts:accountname:Contacts_Account_Name:account_id:I',
			     'ec_account:industry:Accounts_industry:industry:V',
			     'ec_contactdetails:email:Contacts_Email:email:V'),

		       Array(        'ec_contactdetails:lastname:Contacts_Last_Name:lastname:V',
                             'ec_contactsubdetails:leadsource:Contacts_Lead_Source:leadsource:V',
                             'ec_accountContacts:accountname:Contacts_Account_Name:account_id:I',
                             'ec_account:industry:Accounts_industry:industry:V',
                             'ec_contactdetails:email:Contacts_Email:email:V'),

		       Array(        'ec_contactdetails:lastname:Contacts_Last_Name:lastname:V',
                             'ec_accountContacts:accountname:Contacts_Account_Name:account_id:I',
                             'ec_contactdetails:email:Contacts_Email:email:V',
                             'ec_potential:potentialname:Potentials_Potential_Name:potentialname:V',
                             'ec_potential:sales_stage:Potentials_Sales_Stage:sales_stage:V'),

		       Array('ec_potential:potentialname:Potentials_Potential_Name:potentialname:V',
                             'ec_potential:amount:Potentials_Amount:amount:N',
                             'ec_potential:potentialtype:Potentials_Type:opportunity_type:V',
                             'ec_potential:leadsource:Potentials_Lead_Source:leadsource:V',
                             'ec_potential:sales_stage:Potentials_Sales_Stage:sales_stage:V'),
  
		       Array('ec_potential:potentialname:Potentials_Potential_Name:potentialname:V',
                             'ec_potential:amount:Potentials_Amount:amount:N',
                             'ec_potential:potentialtype:Potentials_Type:opportunity_type:V',
                             'ec_potential:leadsource:Potentials_Lead_Source:leadsource:V',
			     'ec_potential:sales_stage:Potentials_Sales_Stage:sales_stage:V'),

		       Array('ec_activity:subject:Calendar_Subject:subject:V',
			     'ec_contactdetailsCalendar:lastname:Calendar_Contact_Name:contact_id:I',
                             'ec_activity:status:Calendar_Status:taskstatus:V',
                             'ec_activity:priority:Calendar_Priority:taskpriority:V',
                             'ec_usersCalendar:user_name:Calendar_Assigned_To:assigned_user_id:V'),

		       Array('ec_activity:subject:Calendar_Subject:subject:V',
                             'ec_contactdetailsCalendar:lastname:Calendar_Contact_Name:contact_id:I',
                             'ec_activity:status:Calendar_Status:taskstatus:V',
                             'ec_activity:priority:Calendar_Priority:taskpriority:V',
                             'ec_usersCalendar:user_name:Calendar_Assigned_To:assigned_user_id:V'),

        	       Array('ec_troubletickets:title:HelpDesk_Title:ticket_title:V',
                             'ec_troubletickets:status:HelpDesk_Status:ticketstatus:V',
                             'ec_products:productname:Products_Product_Name:productname:V',
			     'ec_products:manufacturer:Products_Manufacturer:manufacturer:V'),

 		       Array('ec_troubletickets:title:HelpDesk_Title:ticket_title:V',
                             'ec_troubletickets:priority:HelpDesk_Priority:ticketpriorities:V',
                             'ec_troubletickets:severity:HelpDesk_Severity:ticketseverities:V',
                             'ec_troubletickets:status:HelpDesk_Status:ticketstatus:V',
                             'ec_troubletickets:category:HelpDesk_Category:ticketcategories:V',
                             'ec_usersHelpDesk:user_name:HelpDesk_Assigned_To:assigned_user_id:V'),

		       Array('ec_troubletickets:title:HelpDesk_Title:ticket_title:V',
                             'ec_troubletickets:priority:HelpDesk_Priority:ticketpriorities:V',
                             'ec_troubletickets:severity:HelpDesk_Severity:ticketseverities:V',
                             'ec_troubletickets:status:HelpDesk_Status:ticketstatus:V',
                             'ec_troubletickets:category:HelpDesk_Category:ticketcategories:V',
                             'ec_usersHelpDesk:user_name:HelpDesk_Assigned_To:assigned_user_id:V'),
		      
 		       Array('ec_products:productname:Products_Product_Name:productname:V',
                             'ec_products:productcode:Products_Product_Code:productcode:V',                         
                             'ec_products:website:Products_Website:website:V',
			     'ec_vendorRel:vendorname:Products_Vendor_Name:vendor_id:I',
			     'ec_products:mfr_part_no:Products_Mfr_PartNo:mfr_part_no:V'),

		       

		       Array('ec_quotes:subject:Quotes_Subject:subject:V',                             
                             'ec_quotes:quotestage:Quotes_Quote_Stage:quotestage:V',
                             'ec_accountQuotes:accountname:Quotes_Account_Name:account_id:I'),

		       Array('ec_quotes:subject:Quotes_Subject:subject:V',
                             'ec_quotes:quotestage:Quotes_Quote_Stage:quotestage:V',
                             'ec_accountQuotes:accountname:Quotes_Account_Name:account_id:I',
			     'ec_quotes:carrier:Quotes_Carrier:carrier:V',
			     'ec_quotes:shipping:Quotes_Shipping:shipping:V'),

		       Array('ec_purchaseorder:subject:PurchaseOrder_Subject:subject:V',
			     'ec_vendorRel:vendorname:PurchaseOrder_Vendor_Name:vendor_id:I',
			     'ec_purchaseorder:tracking_no:PurchaseOrder_Tracking_Number:tracking_no:V',),

		       Array('ec_purchaseorder:subject:PurchaseOrder_Subject:subject:V',
			     'ec_vendorRel:vendorname:PurchaseOrder_Vendor_Name:vendor_id:I',
			     'ec_purchaseorder:requisition_no:PurchaseOrder_Requisition_No:requisition_no:V',
                             'ec_purchaseorder:tracking_no:PurchaseOrder_Tracking_Number:tracking_no:V',
			     'ec_contactdetailsPurchaseOrder:lastname:PurchaseOrder_Contact_Name:contact_id:I',
			     'ec_purchaseorder:carrier:PurchaseOrder_Carrier:carrier:V',
			     'ec_purchaseorder:salescommission:PurchaseOrder_Sales_Commission:salescommission:N',
			     'ec_purchaseorder:exciseduty:PurchaseOrder_Excise_Duty:exciseduty:N',
                             'ec_usersPurchaseOrder:user_name:PurchaseOrder_Assigned_To:assigned_user_id:V'),

		       Array('ec_invoice:subject:Invoice_Subject:subject:V',
			     'ec_invoice:salesorderid:Invoice_Sales_Order:salesorder_id:I',
			     'ec_invoice:exciseduty:Invoice_Excise_Duty:exciseduty:N',
			     'ec_invoice:salescommission:Invoice_Sales_Commission:salescommission:N',
			     'ec_accountInvoice:accountname:Invoice_Account_Name:account_id:I'),

		       Array('ec_salesorder:subject:SalesOrder_Subject:subject:V',
			     'ec_quotesSalesOrder:subject:SalesOrder_Quote_Name:quote_id:I',
			     'ec_contactdetailsSalesOrder:lastname:SalesOrder_Contact_Name:contact_id:I',
			     'ec_salesorder:duedate:SalesOrder_Due_Date:duedate:D',
			     'ec_salesorder:carrier:SalesOrder_Carrier:carrier:V',                  
			     'ec_salesorder:sostatus:SalesOrder_Status:sostatus:V',
			     'ec_accountSalesOrder:accountname:SalesOrder_Account_Name:account_id:I',
			     'ec_salesorder:salescommission:SalesOrder_Sales_Commission:salescommission:N',
			     'ec_salesorder:exciseduty:SalesOrder_Excise_Duty:exciseduty:N',
			     'ec_usersSalesOrder:user_name:SalesOrder_Assigned_To:assigned_user_id:V'),

		       Array('ec_campaign:campaignname:Campaigns_Campaign_Name:campaignname:V',
			     'ec_campaign:campaigntype:Campaigns_Campaign_Type:campaigntype:V',
			     'ec_campaign:targetaudience:Campaigns_Target_Audience:targetaudience:V',
			     'ec_campaign:budgetcost:Campaigns_Budget_Cost:budgetcost:I',
			     'ec_campaign:actualcost:Campaigns_Actual_Cost:actualcost:I',
			     'ec_campaign:expectedrevenue:Campaigns_Expected_Revenue:expectedrevenue:I',
			     'ec_campaign:expectedsalescount:Campaigns_Expected_Sales_Count:expectedsalescount:N',
			     'ec_campaign:actualsalescount:Campaigns_Actual_Sales_Count:actualsalescount:N',
			     'ec_usersCampaigns:user_name:Campaigns_Assigned_To:assigned_user_id:V'),
			   Array('ec_gathers:gathertimes:Gathers_Gather_Times:gathertimes:V',
			     'ec_gathers:gathername:Gathers_Gather_Name:gathername:V',
			     'ec_accountGathers:accountname:Gathers_Account_Name:account_id:V',
			     'ec_gathers:planamount:Gathers_Plan_Amount:planamount:N',
			     'ec_gathers:plandate:Gathers_Plan_Date:plandate:D',
			     'ec_gathers:gatherstatus:Gathers_Gather_Status:gatherstatus:V'),
			   Array('ec_charges:chargetimes:Charges_Charge_Times:chargetimes:V',
			     'ec_charges:chargename:Charges_Charge_Name:chargename:V',
			     'ec_vendorRel:vendorname:Charges_Vendor_Name:vendor_id:I',
			     'ec_charges:planamount:Charges_Plan_Amount:planamount:N',
			     'ec_charges:plandate:Charges_Plan_Date:plandate:D',
			     'ec_charges:chargestatus:Charges_Charge_Status:chargestatus:V'),
			   Array('ec_expenses:expensename:Expenses_Expense_Name:expensename:V',
			     'ec_expenses:total:Expenses_Total:total:N',
			     'ec_expenses:expensedate:Expenses_Expense_Date:expensedate:D',
			     'ec_expenses:expensecategory:Expenses_Expense_Category:expensecategory:V',
			     'ec_expenses:expensebill:Expenses_Expense_Bill:expensebill:V',
			     'ec_expenses:expensestatus:Expenses_Expense_Status:expensestatus:V',
				 'ec_accountExpenses:accountname:Expenses_Account_Name:account_id:V'
				 ),
			);

$reports = Array(Array('reportname'=>'Contacts by Accounts',
                       'reportfolder'=>'Account and Contact Reports',
                       'description'=>'Contacts related to Accounts',
                       'reporttype'=>'tabular',
		       'sortid'=>'','stdfilterid'=>'','advfilterid'=>'0'),

		 Array('reportname'=>'Contacts without Accounts',
                       'reportfolder'=>'Account and Contact Reports',
                       'description'=>'Contacts not related to Accounts',
                       'reporttype'=>'tabular',
		       'sortid'=>'','stdfilterid'=>'','advfilterid'=>'1'),

		 Array('reportname'=>'Contacts by Potentials',
                       'reportfolder'=>'Account and Contact Reports',
                       'description'=>'Contacts related to Potentials',
                       'reporttype'=>'tabular',
		       'sortid'=>'','stdfilterid'=>'','advfilterid'=>'2'),


		 Array('reportname'=>'Potential Pipeline',
                       'reportfolder'=>'Potential Reports',
                       'description'=>'Potential Pipeline',
                       'reporttype'=>'tabular',
                       'sortid'=>'2','stdfilterid'=>'','advfilterid'=>''),

		 Array('reportname'=>'Closed Potentials',
                       'reportfolder'=>'Potential Reports',
                       'description'=>'Potential that have Won',
                       'reporttype'=>'tabular',
                       'sortid'=>'','stdfilterid'=>'','advfilterid'=>'3'),

		 Array('reportname'=>'Last Month Activities',
                       'reportfolder'=>'Activity Reports',
                       'description'=>'Last Month Activities',
                       'reporttype'=>'tabular',
                       'sortid'=>'','stdfilterid'=>'0','advfilterid'=>''),

		 Array('reportname'=>'This Month Activities',
                       'reportfolder'=>'Activity Reports',
                       'description'=>'This Month Activities',
                       'reporttype'=>'tabular',
                       'sortid'=>'','stdfilterid'=>'1','advfilterid'=>''),

		 Array('reportname'=>'Tickets by Products',
                       'reportfolder'=>'HelpDesk Reports',
                       'description'=>'Tickets related to Products',
                       'reporttype'=>'tabular',
                       'sortid'=>'','stdfilterid'=>'','advfilterid'=>''),

		 Array('reportname'=>'Tickets by Priority',
                       'reportfolder'=>'HelpDesk Reports',
                       'description'=>'Tickets by Priority',
                       'reporttype'=>'tabular',
                       'sortid'=>'3','stdfilterid'=>'','advfilterid'=>''),

 		 Array('reportname'=>'Open Tickets',
                       'reportfolder'=>'HelpDesk Reports',
                       'description'=>'Tickets that are Open',
                       'reporttype'=>'tabular',
                       'sortid'=>'','stdfilterid'=>'','advfilterid'=>'4'),

		 Array('reportname'=>'Product Details',
                       'reportfolder'=>'Product Reports',
                       'description'=>'Product Detailed Report',
                       'reporttype'=>'tabular',
                       'sortid'=>'','stdfilterid'=>'','advfilterid'=>''),

		

		 Array('reportname'=>'Open Quotes',
                       'reportfolder'=>'Quote Reports',
                       'description'=>'Quotes that are Open',
                       'reporttype'=>'tabular',
                       'sortid'=>'','stdfilterid'=>'','advfilterid'=>'5'),

		 Array('reportname'=>'Quotes Detailed Report',
                       'reportfolder'=>'Quote Reports',
                       'description'=>'Quotes Detailed Report',
                       'reporttype'=>'tabular',
                       'sortid'=>'','stdfilterid'=>'','advfilterid'=>''),

		 Array('reportname'=>'PurchaseOrder by Contacts',
                       'reportfolder'=>'PurchaseOrder Reports',
                       'description'=>'PurchaseOrder related to Contacts',
                       'reporttype'=>'tabular',
                       'sortid'=>'','stdfilterid'=>'','advfilterid'=>''),

		 Array('reportname'=>'PurchaseOrder Detailed Report',
                       'reportfolder'=>'PurchaseOrder Reports',
                       'description'=>'PurchaseOrder Detailed Report',
                       'reporttype'=>'tabular',
                       'sortid'=>'','stdfilterid'=>'','advfilterid'=>''),

		 Array('reportname'=>'Invoice Detailed Report',
                       'reportfolder'=>'Invoice Reports',
                       'description'=>'Invoice Detailed Report',
                       'reporttype'=>'tabular',
		       'sortid'=>'','stdfilterid'=>'','advfilterid'=>''),
		 
		 Array('reportname'=>'SalesOrder Detailed Report',
                       'reportfolder'=>'SalesOrder Reports',
                       'description'=>'SalesOrder Detailed Report',
                       'reporttype'=>'tabular',
                       'sortid'=>'','stdfilterid'=>'','advfilterid'=>''),

	    Array('reportname'=>'Campaign Expectations and Actuals',
		       'reportfolder'=>'Campaign Reports',
		       'description'=>'Campaign Expectations and Actuals',
		       'reporttype'=>'tabular',
		       'sortid'=>'','stdfilterid'=>'','advfilterid'=>''),
	   Array('reportname'=>'应收款报表',
		       'reportfolder'=>'Gathers Reports',
		       'description'=>'应收款报表',
		       'reporttype'=>'tabular',
		       'sortid'=>'','stdfilterid'=>'','advfilterid'=>''),
	   Array('reportname'=>'应付款报表',
		       'reportfolder'=>'Charges Reports',
		       'description'=>'应付款报表',
		       'reporttype'=>'tabular',
		       'sortid'=>'','stdfilterid'=>'','advfilterid'=>''),
	  Array('reportname'=>'费用报销报表',
		       'reportfolder'=>'Expenses Reports',
		       'description'=>'费用报销报表',
		       'reporttype'=>'tabular',
		       'sortid'=>'','stdfilterid'=>'','advfilterid'=>'')

		);

$sortorder = Array(
		   Array(
                         Array('columnname'=>'ec_potential:sales_stage:Potentials_Sales_Stage:sales_stage:V',
                               'sortorder'=>'Ascending'
                              )
                        ),
		   Array(
                         Array('columnname'=>'ec_troubletickets:priority:HelpDesk_Priority:ticketpriorities:V',
                               'sortorder'=>'Ascending'
                              )
                        )
                  );

$stdfilters = Array(Array('columnname'=>'ec_crmentityCalendar:modifiedtime:Calendar_Modified_Time',
			  'datefilter'=>'lastmonth',
			  'startdate'=>'2005-05-01',
			  'enddate'=>'2005-05-31'),

		    Array('columnname'=>'ec_crmentityCalendar:modifiedtime:Calendar_Modified_Time',
                          'datefilter'=>'thismonth',
                          'startdate'=>'2005-06-01',
                          'enddate'=>'2005-06-30')
		   );

$advfilters = Array(
                      Array(
                            Array('columnname'=>'ec_accountContacts:accountname:Contacts_Account_Name:account_id:I',
                                  'comparator'=>'n',
                                  'value'=>''
                                 )
                           ),
		      Array(
                            Array('columnname'=>'ec_accountContacts:accountname:Contacts_Account_Name:account_id:I',
                                  'comparator'=>'e',
                                  'value'=>''
                                 )
                           ),
		      Array(
                            Array('columnname'=>'ec_potential:potentialname:Potentials_Potential_Name:potentialname:V',
                                  'comparator'=>'n',
                                  'value'=>''
                                 )
                           ),
		      Array(
                            Array('columnname'=>'ec_potential:sales_stage:Potentials_Sales_Stage:sales_stage:V',
                                  'comparator'=>'e',
                                  'value'=>$app_strings['Closed Won']
                                 )
                           ),
		      Array(
                            Array('columnname'=>'ec_troubletickets:status:HelpDesk_Status:ticketstatus:V',
                                  'comparator'=>'n',
                                  'value'=>$app_strings['Closed']
                                 )
                           ),
		      Array(
                            Array('columnname'=>'ec_quotes:quotestage:Quotes_Quote_Stage:quotestage:V',
                                  'comparator'=>'n',
                                  'value'=>$app_strings['Accepted']
                                 ),
			    Array('columnname'=>'ec_quotes:quotestage:Quotes_Quote_Stage:quotestage:V',
                                  'comparator'=>'n',
                                  'value'=>$app_strings['Rejected']
                                 )
                           )
                     );
//quotes:quotestage:Quotes_Quote_Stage:quotestage:V
foreach($rptfolder as $key=>$rptarray)
{
        foreach($rptarray as $foldername=>$folderdescription)
        {
                PopulateReportFolder($foldername,$folderdescription);
                $reportid[$foldername] = $key+1;
        }
}

foreach($reports as $key=>$report)
{
        $queryid = insertSelectQuery();
        insertReports($queryid,$reportid[$report['reportfolder']],$report['reportname'],$report['description'],$report['reporttype']);
        insertSelectColumns($queryid,$selectcolumns[$key]);
        insertReportModules($queryid,$reportmodules[$key]['primarymodule'],$reportmodules[$key]['secondarymodule']);
	
	if(isset($stdfilters[$report['stdfilterid']]))
	{
		$i = $report['stdfilterid'];
		insertStdFilter($queryid,$stdfilters[$i]['columnname'],$stdfilters[$i]['datefilter'],$stdfilters[$i]['startdate'],$stdfilters[$i]['enddate']);
	}

	if(isset($advfilters[$report['advfilterid']]))
	{
		insertAdvFilter($queryid,$advfilters[$report['advfilterid']]);
	}

	if($report['reporttype'] == "summary")
	{
		insertSortColumns($queryid,$sortorder[$report['sortid']]);
	}
}

/** Function to store the foldername and folderdescription to database
 *  This function accepts the given folder name and description
 *  ans store it in db as SAVED
 */

function PopulateReportFolder($fldrname,$fldrdescription)
{
	global $adb;
	$sql = "INSERT INTO ec_reportfolder ";
	$sql .= "(FOLDERNAME,DESCRIPTION,STATE) ";
	$sql .= "VALUES ('".$fldrname."','".$fldrdescription."','SAVED')";
	$result = $adb->query($sql);
}

/** Function to add an entry in selestquery ec_table 
 *
 */

function insertSelectQuery()
{
	global $adb;
	$genQueryId = $adb->getUniqueID("ec_selectquery");
        if($genQueryId != "")
        {
		$iquerysql = "insert into ec_selectquery (QUERYID,STARTINDEX,NUMOFOBJECTS) values (".$genQueryId.",0,0)";
		$iquerysqlresult = $adb->query($iquerysql);
	}

	return $genQueryId;
}

/** Function to store the ec_field names selected for a ec_report to a database
 *  
 *  
 */

function insertSelectColumns($queryid,$columnname)
{
	global $adb;
	if($queryid != "")
	{
		for($i=0;$i < count($columnname);$i++)
		{
			$icolumnsql = "insert into ec_selectcolumn (QUERYID,COLUMNINDEX,COLUMNNAME) values (".$queryid.",".$i.",'".$columnname[$i]."')";
			$icolumnsqlresult = $adb->query($icolumnsql);	
		}
	}
}


/** Function to store the ec_report details to database
 *  This function accepts queryid,folderid,reportname,description,reporttype
 *  as arguments and store the informations in ec_report ec_table
 */

function insertReports($queryid,$folderid,$reportname,$description,$reporttype)
{
	global $adb;
	if($queryid != "")
	{
		$ireportsql = "insert into ec_report (REPORTID,FOLDERID,REPORTNAME,DESCRIPTION,REPORTTYPE,QUERYID,STATE)";
                $ireportsql .= " values (".$queryid.",".$folderid.",'".$reportname."','".$description."','".$reporttype."',".$queryid.",'SAVED')";
		$ireportresult = $adb->query($ireportsql);
	}
}

/** Function to store the ec_report modules to database
 *  This function accepts queryid,primary module and secondary module
 *  as arguments and store the informations in ec_reportmodules ec_table
 */


function insertReportModules($queryid,$primarymodule,$secondarymodule)
{
	global $adb;
	if($queryid != "")
	{
		$ireportmodulesql = "insert into ec_reportmodules (REPORTMODULESID,PRIMARYMODULE,SECONDARYMODULES) values (".$queryid.",'".$primarymodule."','".$secondarymodule."')";
		$ireportmoduleresult = $adb->query($ireportmodulesql);
	}
}


/** Function to store the ec_report sortorder to database
 *  This function accepts queryid,sortlists
 *  as arguments and store the informations sort columns and
 *  and sortorder in ec_reportsortcol ec_table
 */


function insertSortColumns($queryid,$sortlists)
{
	global $adb;
	if($queryid != "")
	{
		foreach($sortlists as $i=>$sort)
                {
			$sort_bysql = "insert into ec_reportsortcol (SORTCOLID,REPORTID,COLUMNNAME,SORTORDER) 
					values (".($i+1).",".$queryid.",'".$sort['columnname']."','".$sort['sortorder']."')";
			$sort_byresult = $adb->query($sort_bysql);
		}
	}

}


/** Function to store the ec_report sort date details to database
 *  This function accepts queryid,filtercolumn,datefilter,startdate,enddate
 *  as arguments and store the informations in ec_reportdatefilter ec_table
 */


function insertStdFilter($queryid,$filtercolumn,$datefilter,$startdate,$enddate)
{
	global $adb;
	if($queryid != "")
	{
		$ireportmodulesql = "insert into ec_reportdatefilter (DATEFILTERID,DATECOLUMNNAME,DATEFILTER,STARTDATE,ENDDATE) values (".$queryid.",'".$filtercolumn."','".$datefilter."','".$startdate."','".$enddate."')";
		$ireportmoduleresult = $adb->query($ireportmodulesql);
	}

}

/** Function to store the ec_report conditions to database
 *  This function accepts queryid,filters
 *  as arguments and store the informations in ec_relcriteria ec_table
 */


function insertAdvFilter($queryid,$filters)
{
	global $adb;
	if($queryid != "")
	{
		foreach($filters as $i=>$filter)
		{
		      $irelcriteriasql = "insert into ec_relcriteria(QUERYID,COLUMNINDEX,COLUMNNAME,COMPARATOR,VALUE) 
		      values (".$queryid.",".$i.",'".$filter['columnname']."','".$filter['comparator']."','".$filter['value']."')";
		      $irelcriteriaresult = $adb->query($irelcriteriasql);
		}
	}
}
?>
