<?php
/*********************************************************************************
** The contents of this file are subject to the vtiger CRM Public License Version 1.0
 * ("License"); You may not use this file except in compliance with the License
 * The Original Code is:  vtiger CRM Open Source
 * The Initial Developer of the Original Code is vtiger.
 * Portions created by vtiger are Copyright (C) vtiger.
 * All Rights Reserved.
*
 ********************************************************************************/
require_once('Smarty_setup.php');
require_once('include/database/PearDatabase.php');
require_once('include/utils/utils.php');
require_once('themes/'.$theme.'/layout_utils.php');
global $mod_strings;
global $app_strings;
global $app_list_strings;
global $current_language, $currentModule, $current_userid;

$smarty = new vtigerCRM_Smarty;
$focus=new Accounts();

$parenttab = getParenttab();
$req_module=$_REQUEST['module'];
$return_module=$_REQUEST['module'];
$delete_idstring=$_REQUEST['idlist'];
if(isset($_REQUEST['del_rec']))
{
	$delete_id_array=explode(",",$delete_idstring,-1);
	foreach ($delete_id_array as $val)
	{
		DeleteEntity($req_module,$return_module,$focus,$val,"");	
	}
}

$ret_arr = getDuplicateRecordsArr($req_module);

$fld_values=$ret_arr[0];
$total_num_group=count($fld_values);
$fld_name=$ret_arr[1];
$ui_type=$ret_arr[2];

$smarty->assign("NAVIGATION",$ret_arr["navigation"]);//Added for page navigation
$smarty->assign("MODULE",$req_module);
$smarty->assign("NUM_GROUP",$total_num_group);
$smarty->assign("FIELD_NAMES",$fld_name);
$smarty->assign("GROUP_COUNT",$count_group);
$smarty->assign("CATEGORY",$parenttab);
$smarty->assign("ALL_VALUES",$fld_values);

$check_button = Button_Check($module); 
$smarty->assign("CHECK", $check_button);

if(isPermitted($req_module,'Delete','') == 'yes')
	//$button_del = $app_strings[LBL_MASS_DELETE];
$smarty->assign("DELETE","Delete");

$smarty->assign("MOD", return_module_language($current_language,'Accounts'));
$smarty->assign("IMAGE_PATH",$image_path);
$smarty->assign("APP", $app_strings);
$smarty->assign("CMOD", $mod_strings);
$smarty->assign("MODE",'view');
if(isset($_REQUEST['button_view']))
{	
	$smarty->assign("VIEW",'true');
}

if(isset($_REQUEST['ajax']) && $_REQUEST['ajax'] != '')
	$smarty->display("Accounts/FindDuplicateAjax.tpl");
else
	$smarty->display('Accounts/FindDuplicateDisplay.tpl');


/** Function to return the duplicate records data as a formatted array */
function getDuplicateRecordsArr($module)
{
	global $adb,$app_strings,$list_max_entries_per_page,$theme,$mod_strings;
	$field_values_array=getFieldValues($module);
	$field_values=$field_values_array['fieldnames_list'];
	$fld_arr=$field_values_array['fieldnames_array'];
	$col_arr=$field_values_array['columnnames_array'];
	$fld_labl_arr=$field_values_array['fieldlabels_array'];
	$ui_type=$field_values_array['fieldname_uitype'];

	$dup_query = getDuplicateQuery();
	// added for page navigation
	$dup_count_query = substr($dup_query, strpos($dup_query,'FROM'),strlen($dup_query));
	$dup_count_query = "Select count(*) as count ".$dup_count_query;
	$count_res = $adb->query($dup_count_query);
	$no_of_rows = $adb->query_result($count_res,0,"count");

	if($no_of_rows <= $list_max_entries_per_page)
		$_SESSION['dup_nav_start'.$module] = 1;
	else if(isset($_REQUEST["start"]) && $_REQUEST["start"] != "" && $_SESSION['dup_nav_start'.$module] != $_REQUEST["start"])
		$_SESSION['dup_nav_start'.$module] = $_REQUEST["start"];
	$start = ($_SESSION['dup_nav_start'.$module] != "")?$_SESSION['dup_nav_start'.$module]:1;
	$navigation_array = getNavigationValues($start, $no_of_rows, $list_max_entries_per_page);
	$start_rec = $navigation_array['start'];
	$end_rec = $navigation_array['end_val'];
	$navigationOutput = getTableHeaderNavigation($navigation_array, "",$module,"FindDuplicate","");
	if ($start_rec == 0)
		$limit_start_rec = 0;
	else
		$limit_start_rec = $start_rec -1;
	$dup_query .= " LIMIT $limit_start_rec, $list_max_entries_per_page";
	//ends
	
	$nresult=$adb->query($dup_query);
	$no_rows=$adb->num_rows($nresult);
	$theme_path="themes/".$theme."/";
	$image_path=$theme_path."images/";
	require_once($theme_path.'layout_utils.php');	
	if($no_rows == 0)
	{
		if ($_REQUEST['action'] == 'FindDuplicate'.$module)
		{
			echo "<link rel='stylesheet' type='text/css' href='themes/$theme/style.css'>";	
			echo "<table border='0' cellpadding='5' cellspacing='0' width='100%' height='450px'><tr><td align='center'>";
			echo "<div style='border: 3px solid rgb(153, 153, 153); background-color: rgb(255, 255, 255); width: 55%; position: relative; z-index: 10000000;'>
		
				<table border='0' cellpadding='5' cellspacing='0' width='98%'>
				<tbody><tr>
				<td rowspan='2' width='11%'><img src='themes/$theme/images/empty.jpg' ></td>
				<td style='border-bottom: 1px solid rgb(204, 204, 204);' nowrap='nowrap' width='70%'><span class='genHeaderSmall'>$mod_strings[LBL_NO_DUPLICATE]</span></td>
				</tr>
				<tr>
				<td class='small' align='right' nowrap='nowrap'>			   	
				<a href='javascript:window.history.back();'>$app_strings[LBL_GO_BACK]</a><br>     </td>
				</tr>
				</tbody></table> 
				</div>";
			echo "</td></tr></table>";
			exit();
		}
		else
		{
			echo "<br><br><table align='center' class='reportCreateBottom big' width='95%'><tr><td align='center'>".$app_strings['LBL_NO_DUPLICATE']."</td></tr></table>";
			die;
		}
	}	

	$rec_cnt = 0;
	$temp = Array();
	$sl_arr = Array();
	$grp = "group0";
	$gcnt = 0;
	$ii = 0; //ii'th record in group 
	while ( $rec_cnt < $no_rows )
	{			
		$result = $adb->fetchByAssoc($nresult);
		//echo '<pre>';print_r($result);echo '</pre>';	
		if($rec_cnt != 0)
		{
			$sl_arr = array_slice($result,1);
			array_walk($temp,'lower_array');
			array_walk($sl_arr,'lower_array');
			$arr_diff = array_diff($temp,$sl_arr);
			if(count($arr_diff) > 0)
			{
				$gcnt++;	
				$temp = $sl_arr;
				$ii = 0;
			}
			$grp = "group".$gcnt;
		}
		$fld_values[$grp][$ii]['recordid'] = $result['recordid'];	
		for($k=0;$k<count($col_arr);$k++)
		{
			if($rec_cnt == 0)
			{
				$temp[$fld_labl_arr[$k]] = $result[$col_arr[$k]];
			}
			if($ui_type[$fld_arr[$k]] == 56)
			{
				if($result[$col_arr[$k]] == 0)
				{
					$result[$col_arr[$k]]=$app_strings['no'];
				}
				else
					$result[$col_arr[$k]]=$app_strings['yes'];
			}
			if($ui_type[$fld_arr[$k]] ==75 || $ui_type[$fld_arr[$k]] ==81)
			{
				$vendor_id=$result[$col_arr[$k]];
				if($vendor_id != '')
					{
						$vendor_name=getVendorName($vendor_id);
					}	
				$result[$col_arr[$k]]=$vendor_name;	
			}
			if($ui_type[$fld_arr[$k]] ==57)
			{
				$contact_id= $result[$col_arr[$k]];
				if($contact_id != '')
				{
					$contactname=getContactName($contact_id);
				}
						
				$result[$col_arr[$k]]=$contactname;
			}	
			if($ui_type[$fld_arr[$k]] ==68)
			{
				$parent_id= $result[$col_arr[$k]];
				if($parent_id != '')
				{
					$parentname=getParentName($parent_id);
				}
						
				$result[$col_arr[$k]]=$parentname;
			}
			if($ui_type[$fld_arr[$k]] ==53 || $ui_type[$fld_arr[$k]] ==52)
			{
				$assigned_to= $result[$col_arr[$k]];
				if($assigned_to != '')
				{
					$user=getUserName($assigned_to);
				}
				if($assigned_to == 0 and $module != 'Products')
				{
					$group_info = Array();
					$sql_group="select setype from ec_crmentity where crmid='".$result['recordid']."'";
					$result_group=$adb->query($sql_group,array($fld_values[$grp][$ii]['recordid']));
					$group_info=getGroupName($fld_values[$grp][$ii]['recordid'],$adb->query_result($result_group,'setype'));
					$user=$group_info[0];
				}
				$result[$col_arr[$k]]=$user;
			}	
			if($ui_type[$fld_arr[$k]] ==50 or $ui_type[$fld_arr[$k]] ==51)
			{
				$account_name=getAccountName($result[$col_arr[$k]]);
				if($account_name != '')
					$result[$col_arr[$k]]=$account_name;
				else $result[$col_arr[$k]]='';
			}
			if($ui_type[$fld_arr[$k]] ==58)
			{
				$campaign_name=getCampaignName($result[$col_arr[$k]]);
				if($campaign_name != '')
					$result[$col_arr[$k]]=$campaign_name;
				else $result[$col_arr[$k]]='';
			}
			if($ui_type[$fld_arr[$k]] == 59)
			{
				$product_name=getProductName($result[$col_arr[$k]]);
				if($product_name != '')
					$result[$col_arr[$k]]=$product_name;
				else $result[$col_arr[$k]]='';
			}
			$fld_values[$grp][$ii][$fld_labl_arr[$k]] = $result[$col_arr[$k]];
			
		}
		//$fld_values[$grp][$ii]['Entity Type'] = $result['deleted'];
		//$fld_values[$grp][$ii]['accountname'] = $result['accountname'];
		$ii++;	
		$rec_cnt++;
	}

	$gro="group";
	for($i=0;$i<$no_rows;$i++)
	{
		$ii=0;
		$dis_group[]=$fld_values[$gro.$i][$ii];
		$count_group[$i]=count($fld_values[$gro.$i]);
		$ii++;
		$new_group[]=$dis_group[$i];
	}
	$fld_nam=$new_group[0];
	$ret_arr[0]=$fld_values;
	$ret_arr[1]=$fld_nam;
	$ret_arr[2]=$ui_type;
	$ret_arr["navigation"]=$navigationOutput;
	return $ret_arr;
}

/** Function to get a to find duplicates in a particular module*/
function getDuplicateQuery()
{
	global $current_user;
	$table_cols = "phone,email1";
	//$sec_parameter = getListViewSecurityParameter($module);
	if(is_admin($current_user)) {
		$sec_parameter = "";
	} else {
		$subuserids = getUserIDS("sub_user");
		if($subuserids != "()") {
			$sec_parameter = " and (ec_crmentity.smownerid='".$current_user->id."' or ec_crmentity.smownerid in ".$subuserids.")";
		} else {
			$sec_parameter = " and ec_crmentity.smownerid='".$current_user->id."'";
		}
	}
	
	
	$nquery="SELECT ec_account.accountid AS recordid,ec_account.phone,ec_account.email1 
		FROM ec_account
		INNER JOIN ec_crmentity
			ON ec_crmentity.crmid=ec_account.accountid
		INNER JOIN ec_accountbillads
			ON ec_account.accountid = ec_accountbillads.accountaddressid
		INNER JOIN ec_accountshipads
			ON ec_account.accountid = ec_accountshipads.accountaddressid 		
		LEFT JOIN ec_accountgrouprelation
			ON ec_account.accountid = ec_accountgrouprelation.accountid
		LEFT JOIN ec_groups
			ON ec_groups.groupname = ec_accountgrouprelation.groupname
		LEFT JOIN ec_users
			ON ec_users.id = ec_crmentity.smownerid
		INNER JOIN (SELECT ec_account.phone,ec_account.email1   
			FROM ec_account
			INNER JOIN ec_crmentity
				ON ec_crmentity.crmid = ec_account.accountid
			INNER JOIN ec_accountbillads
			ON ec_account.accountid = ec_accountbillads.accountaddressid
			INNER JOIN ec_accountshipads
				ON ec_account.accountid = ec_accountshipads.accountaddressid 
			LEFT JOIN ec_accountgrouprelation
				ON ec_account.accountid = ec_accountgrouprelation.accountid
			LEFT JOIN ec_groups
				ON ec_groups.groupname = ec_accountgrouprelation.groupname
			LEFT JOIN ec_users
				ON ec_users.id = ec_crmentity.smownerid
			WHERE ec_crmentity.deleted=0 $sec_parameter
			GROUP BY phone,email1 HAVING COUNT(*)>1) as temp
		ON ec_account.phone = temp.phone and temp.phone!=''   
						WHERE ec_crmentity.deleted=0 $sec_parameter ORDER BY ec_account.phone,ec_account.email1,ec_account.accountid ASC";
	//echo $nquery;
	return $nquery;
}

/** Function to get tablename, columnname, fieldname, fieldlabel and uitypes of fields of merge criteria for a particular module*/
function getFieldValues($module)
{
	global $adb,$current_user;

	//In future if we want to change a id mapping to name or other string then we can add that elements in this array.
	//$fld_table_arr = Array("ec_contactdetails.account_id"=>"ec_account.accountname");
	//$special_fld_arr = Array("account_id"=>"accountname");
	$fld_table_arr = Array();
	$special_fld_arr = Array();
	$tabid=getTabid($module);
	/*
	$sql="select distinct(userid) from ec_user2mergefields where tabid=?";
	$sql_result=$adb->pquery($sql,array($tabid));
	$num_rows=$adb->num_rows($sql_result);
	for($i=0; $i<$num_rows;$i++)
	{
		if($adb->query_result($sql_result,$i,"userid") == $current_user->id)
		{
			$user_id=$current_user->id;
			break;
		}
		$user_id=0;
	}
	$query="select fieldid from ec_user2mergefields where tabid=? and userid=? and visible=?";
	$result= $adb->pquery($query,array($tabid,$user_id,1));
	$num_rows=$adb->num_rows($result);
	for($i=0; $i<$num_rows;$i++)
	{
		$field_id = $adb->query_result($result,$i,"fieldid");
		$res_val.=$field_id.",";
				
	}
	*/
	//$res_val=rtrim($res_val,",");
	$res_val="'phone','email1'";
	$fieldname_query="select fieldname,fieldlabel,uitype,tablename,columnname from ec_field where tabid=6 and fieldname in (".$res_val.")";
	$fieldname_result = $adb->query($fieldname_query);
	$field_num_rows = $adb->num_rows($fieldname_result);
	$fld_arr = array();
	$col_arr = array();
	for($j=0;$j< $field_num_rows;$j ++)
	{
		$tablename = $adb->query_result($fieldname_result,$j,'tablename');
		$column_name = $adb->query_result($fieldname_result,$j,'columnname');
		$field_name = $adb->query_result($fieldname_result,$j,'fieldname');
		$field_lbl = $adb->query_result($fieldname_result,$j,'fieldlabel');
		$ui_type = $adb->query_result($fieldname_result,$j,'uitype');
		$table_col = $tablename.".".$column_name;
		//if(getFieldVisibilityPermission($module,$current_user->id,$field_name) == 0)
		//{
			$fld_name = ($special_fld_arr[$field_name] != '')?$special_fld_arr[$field_name]:$field_name;			 
			
			$fld_arr[] = $fld_name;
			$col_arr[] = $column_name;
			if($fld_table_arr[$table_col] != '')
				$table_col = $fld_table_arr[$table_col];
			
			$field_values_array['fieldnames_list'][] = $table_col . "." . $fld_name;
			$fld_labl_arr[]=$field_lbl;
			$uitype[$field_name]=$ui_type;
		//}
	}
	$field_values_array['fieldnames_list']=implode(",",$field_values_array['fieldnames_list']);
	$field_values=implode(",",$fld_arr);
	$field_values_array['fieldnames']=$field_values;
	$field_values_array["fieldnames_array"]=$fld_arr;
	$field_values_array["columnnames_array"]=$col_arr;
	$field_values_array['fieldlabels_array']=$fld_labl_arr;
	$field_values_array['fieldname_uitype']=$uitype;

	//echo "<pre>";print_r($field_values_array);echo "</pre>";
	return $field_values_array;	
}

?>

