<?php
/*********************************************************************************
** The contents of this file are subject to the vtiger CRM Public License Version 1.0
 * ("License"); You may not use this file except in compliance with the License
 * The Original Code is:  vtiger CRM Open Source
 * The Initial Developer of the Original Code is vtiger.
 * Portions created by vtiger are Copyright (C) vtiger.
 * All Rights Reserved.
 *
 ********************************************************************************/

set_time_limit(0);
require_once('modules/PurchaseOrder/PurchaseOrder.php');
require_once('modules/Vendors/Vendors.php');
require_once('modules/Vcontacts/Vcontacts.php');
require_once('modules/Products/Products.php');
require_once('modules/Users/Users.php');
include('include/excel/tbs_class.php');

global $app_strings;
global $mod_strings;
global $currentModule;
global $adb;
$focus = new PurchaseOrder();
$focus->retrieve_entity_info($_REQUEST['record'],"PurchaseOrder");
foreach($focus->column_fields as $key=>$value) {
	$upperKey = strtoupper($key);
	$$upperKey = $value;
}

// Company information
$add_query = "select * from ec_organizationdetails";
$result = $adb->query($add_query);
$num_rows = $adb->num_rows($result);

if($num_rows == 1)
{
		$COMPANY_NAME = $adb->query_result($result,0,"organizationname");
		$COMPANY_ADDRESS = $adb->query_result($result,0,"address");
		$COMPANY_CITY = $adb->query_result($result,0,"city");
		$COMPANY_STATE = $adb->query_result($result,0,"state");
		$COMPANY_COUNTRY = $adb->query_result($result,0,"country");
		$COMPANY_CODE = $adb->query_result($result,0,"code");
		$COMPANY_PHONE = $adb->query_result($result,0,"phone");
		$COMPANY_FAX = $adb->query_result($result,0,"fax");
		$COMPANY_WEBSITE = $adb->query_result($result,0,"website");
		$COMPANY_LOGO = $adb->query_result($result,0,"logoname");

		$COMPANY_PERSON = $adb->query_result($result,0,"person");
		$COMPANY_BANKNAME = $adb->query_result($result,0,"bankname");
		$COMPANY_BANKACCOUNT = $adb->query_result($result,0,"bankaccount");
		$COMPANY_TAXNO = $adb->query_result($result,0,"taxno");
}

$sql="select currency_symbol from ec_currency_info";
$result = $adb->query($sql);
$currency_symbol = $adb->query_result($result,0,'currency_symbol');

$id = $_REQUEST['record'];

$vendor_id = $focus->column_fields["vendor_id"];
if(!empty($vendor_id)) {
	$vendor_focus = new Vendors();
	$vendor_focus->retrieve_entity_info($vendor_id,"Vendors");
	$ACCOUNT_PHONE = $vendor_focus->column_fields["phone"];
	$ACCOUNT_FAX = $vendor_focus->column_fields["fax"];
	$ACCOUNT_NAME = $vendor_focus->column_fields["vendorname"];
	$ACCOUNT_STREET = $vendor_focus->column_fields["street"];
	$ACCOUNT_CITY = $vendor_focus->column_fields["city"];
	$ACCOUNT_STATE = $vendor_focus->column_fields["state"];
	$ACCOUNT_CODE = $vendor_focus->column_fields["code"];
	$ACCOUNT_EMAIL = $vendor_focus->column_fields["email"];
	foreach($vendor_focus->column_fields as $key=>$value) {
		$upperKey = "ACCOUNT_".strtoupper($key);
		$$upperKey = $value;
	}
} else {
	$ACCOUNT_PHONE = "";
	$ACCOUNT_NAME = "";
	$ACCOUNT_FAX = "";
	$ACCOUNT_STREET = "";
	$ACCOUNT_CITY = "";
	$ACCOUNT_STATE = "";
	$ACCOUNT_CODE = "";
	$ACCOUNT_EMAIL = "";
}
$vcontactsid = $focus->column_fields['vcontactsid'];
if(!empty($vcontactsid)) {
	$contact_focus = new Vcontacts();
	$contact_focus->retrieve_entity_info($vcontactsid,"Vcontacts");
	$CONTACT_MOBILE = $contact_focus->column_fields["mobile"];
	$CONTACT_PHONE = $contact_focus->column_fields["phone"];
	$CONTACT_NAME = $contact_focus->column_fields["vcontactname"];
	$CONTACT_EMAIL = $contact_focus->column_fields["email"];
	foreach($contact_focus->column_fields as $key=>$value) {
		$upperKey = "CONTACT_".strtoupper($key);
		$$upperKey = $value;
	}
} else {
	$CONTACT_NAME = "";//getContactName($contact_id);
	$CONTACT_EMAIL = "";//getContactPhone($contact_id);
	$CONTACT_MOBILE = "";//getContactMBPhone($contact_id);
	$CONTACT_PHONE = "";//getContactMBPhone($contact_id);
}

$user_id = $focus->column_fields['assigned_user_id'];
if(!empty($user_id)) {
	$user_focus = new Users();
	$user_focus->retrieve_entity_info($user_id,"Users");
	foreach($user_focus->column_fields as $key=>$value) {
		$upperKey = "USER_".strtoupper($key);
		$$upperKey = $value;
	}
	$USER_MOBILE = $user_focus->column_fields["phone_mobile"];
	$USER_NAME = $user_focus->column_fields["last_name"];
	$USER_EMAIL = $user_focus->column_fields["email1"];
} else {
	$USER_NAME = "";
	$USER_EMAIL = "";
	$USER_MOBILE = "";
}
$currency = $focus->column_fields["currency"];


// **************** BEGIN POPULATE DATA ********************

$price_subtotal = ec_number_format($focus->column_fields["hdnSubTotal"]);
//调整
$price_adjustment = ec_number_format($focus->column_fields["txtAdjustment"]);
//总计
$price_total = ec_number_format($focus->column_fields["hdnGrandTotal"]);
//运费
$shipping_charge = ec_number_format($focus->column_fields["hdnS_H_Amount"]);
//S&H amount 税率
$sh_amount = $shipping_charge;
$price_shipping = ec_number_format($sh_amount);
//折扣
$discount_amount = $focus->column_fields["hdnDiscountAmount"];
$discount_percent = $focus->column_fields["hdnDiscountPercent"];

//get the Associated Products for this PurchaseOrder
$focus->id = $focus->column_fields["record_id"];
$associated_products = getAssociatedProducts("PurchaseOrder",$focus);
$num_products = count($associated_products);

//This $final_details array will contain the final total, discount, Group Tax, S&H charge, S&H taxes and adjustment
$final_details = $associated_products[1]['final_details'];

//This is to get all prodcut details as row basis
for($i=1,$j=$i-1;$i<=$num_products;$i++,$j++)
{
	$product_name[$i] = $associated_products[$i]['productName'.$i];
	$imagename[$i] = $associated_products[$i]['imagename'.$i];
	$prod_description[$i] = $associated_products[$i]['comment'.$i];
	$product_id[$i] = $associated_products[$i]['hdnProductId'.$i];
	$qty[$i] = $associated_products[$i]['qty'.$i];
	$unit_price[$i] = ec_number_format($associated_products[$i]['unitPrice'.$i]);
	$list_price[$i] = ec_number_format($associated_products[$i]['listPrice'.$i]);
	$list_pricet[$i] = $associated_products[$i]['listPrice'.$i];
	$usageunit[$i] = $associated_products[$i]['usageunit'.$i];
	$serial_no[$i] = $associated_products[$i]['serial_no'.$i];
	$productcode[$i] = $associated_products[$i]['productcode'.$i];	
	$producttotal = $qty[$i]*$list_pricet[$i];
	$prod_total[$i] = ec_number_format($producttotal);

	$product_line[$j]["name"] = $product_name[$i];
	$product_line[$j]["spec"] = $serial_no[$i];
	$product_line[$j]["code"] = $productcode[$i];
	$product_line[$j]["imagename"] = $imagename[$i];
	$product_line[$j]["unit"] = $usageunit[$i];
	$product_line[$j]["qty"] = $qty[$i].$usageunit[$i];
	$product_line[$j]["num"] = $qty[$i];
	$product_line[$j]["num"] = $qty[$i];
	$product_line[$j]["price"] = "￥".$list_price[$i];
	$product_line[$j]["total"] = "￥".$prod_total[$i];
	$product_line[$j]["description"] = $prod_description[$i];
	$product_focus = new Products();
	$product_focus->retrieve_entity_info($product_id[$i],"Products");
	foreach($product_focus->column_fields as $key=>$value) {		 
		$product_line[$j][$key] = $value;
	}
	$Total_total = $Total_total +$producttotal;
}
if($discount_amount != "" && $discount_amount != 0)
	$price_discount = ec_number_format($discount_amount);
else if($discount_percent != "" && $discount_percent != 0)
	$price_discount = ec_number_format(($discount_percent/100)*$Total_total);
else
	$price_discount = "0.00";
//税金
$price_tax = (($Total_total-$price_discount)*$sh_amount)/100;


//模板所用的变量
$DATE = $focus->column_fields["duedate"];//日期
$NO = $focus->column_fields["subject"];//编号
$TERMS = $focus->column_fields["terms_conditions"];//条件条款
$DESCRIPTION = br2nl($focus->column_fields["description"]);//描述

$TAX = ec_number_format($price_tax);//税
$DISCOUNT = $price_discount;//折扣
$TAXRATE = $price_shipping;//税率
$ADJUSTMENT = $price_adjustment;//调整
$TOTAL = $price_total;//金额
$price_total = str_replace(",","",$price_total);
$TOTAL_BIG = toCNcap($price_total);//大写金额
$TOTAL_BIG = iconv_ec("GBK","UTF-8",$TOTAL_BIG);

$filename = "PurchaseOrder-".date("Ymd");


$TBS = new clsTinyButStrong;
$TBS->NoErr = true; // no more error message displayed.

// Load the Excel template
$TBS->LoadTemplate('modules/PurchaseOrder/PurchaseOrderHtmlTemplate.html','UTF-8');

$TBS->MergeBlock('product',$product_line);


// Final merge and download file
$TBS->Show();

?>