<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version 1.1.2
 * ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an  "AS IS"  basis,
 * WITHWAREHOUSE WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 * The Original Code is:  SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________..
 ********************************************************************************/
/*********************************************************************************
 * $Header: /advent/projects/wesat/ec_crm/sugarcrm/modules/Warehouses/Warehouses.php,v 1.15 2005/03/15 10:01:08 shaw Exp $
 * Description:  TODO: To be written.
 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc.
 * All Rights Reserved.
 * Contributor(s): ______________________________________..
 ********************************************************************************/

include_once('config.php');
require_once('include/logging.php');
require_once('include/database/PearDatabase.php');
require_once('data/SugarBean.php');
require_once('data/CRMEntity.php');
require_once('include/upload_file.php');


// Note is used to store customer information.
class Warehouses extends CRMEntity {
	var $log;
	var $db;

	var $default_note_name_dom = array('Meeting ec_warehouses', 'Reminder');

	var $tab_name = Array('ec_crmentity','ec_warehouses','ec_warehousescf');
	var $tab_name_index = Array('ec_crmentity'=>'crmid','ec_warehouses'=>'warehousesid','ec_warehousescf'=>'warehousesid');

	var $column_fields = Array();

	var $sortby_fields = Array('warehousename');

	// This is used to retrieve related ec_fields from form posts.
	var $additional_column_fields = Array('', '', '', '');

	// This is the list of ec_fields that are in the lists.
	var $list_fields = Array(
				'Warehouse Name'=>Array('warehouses'=>'warehousename'),
		        'Assigned To'=>Array('ec_crmentity'=>'smownerid')
				);
	var $list_fields_name = Array(
					'Warehouse Name'=>'warehousename',
		            'Assigned To'=>'assigned_user_id'
				     );
	var $required_fields =  array("warehousename"=>1);
	var $list_link_field= 'warehousename';

	var $search_fields = Array(
					'Warehouse Name'=>Array('warehouses'=>'warehousename'),
					'Assigned To'=>Array('ec_crmentity'=>'smownerid')
		);
	
	var $search_fields_name = Array(
					'Warehouse Name'=>'warehousename',
		            'Assigned To'=>'assigned_user_id'
		);

	//Added these variables which are used as default order by and sortorder in ListView
	var $default_order_by = 'modifiedtime';
	var $default_sort_order = 'DESC';

	function Warehouses() {
		$this->log = LoggerManager::getLogger('notes');
		$this->log->debug("Entering Warehouses() method ...");
		$this->db = & getSingleDBInstance();
		$this->column_fields = getColumnFields('Warehouses');
		$this->log->debug("Exiting Warehouses method ...");
	}

		/** Function to insert values in the specifed table for the specified module
  	  * @param $table_name -- table name:: Type varchar
  	  * @param $module -- module:: Type varchar
 	 */
  function insertIntoEntityTable($table_name, $module)
  {
	  global $log;
  	  global $current_user;	  
	  $log->info("function insertIntoEntityTable ".$module.' ec_table name ' .$table_name);
	  global $adb;
	  $insertion_mode = $this->mode;

	  //Checkin whether an entry is already is present in the ec_table to update
	  if($insertion_mode == 'edit')
	  {
		  $check_query = "select * from ".$table_name." where ".$this->tab_name_index[$table_name]."=".$this->id;
		  $check_result=$adb->query($check_query);

		  $num_rows = $adb->num_rows($check_result);

		  if($num_rows <= 0)
		  {
			  $insertion_mode = '';
		  }	 
	  }

	  if($insertion_mode == 'edit')
	  {
		  $update = '';
		  $tabid= getTabid($module);
		  require('user_privileges/user_privileges_'.$current_user->id.'.php');
		  if($is_admin == true || $profileGlobalPermission[1] == 0 || $profileGlobalPermission[2] ==0)
		  {

			  $sql = "select * from ec_field where tabid=".$tabid." and tablename='".$table_name."' and displaytype in (1,3)"; 
		  }
		  else
		  {
			  $profileList = getCurrentUserProfileList();
			  $sql = "SELECT *
			  FROM ec_field
			  INNER JOIN ec_profile2field
			  ON ec_profile2field.fieldid = ec_field.fieldid
			  INNER JOIN ec_def_org_field
			  ON ec_def_org_field.fieldid = ec_field.fieldid
			  WHERE ec_field.tabid = ".$tabid."
			  AND ec_profile2field.visible = 0 
			  AND ec_profile2field.readonly = 1  
			  AND ec_profile2field.profileid IN ".$profileList."
			  AND ec_def_org_field.visible = 0 and ec_field.tablename='".$table_name."' and ec_field.displaytype in (1,3)";
		  }	   

	  }
	  else
	  {
		  $column = $this->tab_name_index[$table_name];
		  $value = $this->id;
	  	  $tabid= getTabid($module);	
		  $sql = "select * from ec_field where tabid=".$tabid." and tablename='".$table_name."' and displaytype in (1,3,4)"; 
	  }

	  $result = $adb->query($sql);
	  $noofrows = $adb->num_rows($result);
	  for($i=0; $i<$noofrows; $i++)
	  {
		  $fieldname=$adb->query_result($result,$i,"fieldname");
		  $columname=$adb->query_result($result,$i,"columnname");
		  $uitype=$adb->query_result($result,$i,"uitype");
		  if(isset($this->column_fields[$fieldname]))
		  {
			  if($uitype == 56)
			  {
				  if($this->column_fields[$fieldname] == 'on' || $this->column_fields[$fieldname] == 1)
				  {
					  $fldvalue = 1;
				  }
				  else
				  {
					  $fldvalue = 0;
				  }

			  }
			  elseif($uitype == 33)
			  {
  				if(is_array($this->column_fields[$fieldname]))
  				{
  				  $field_list = implode(' |##| ',$this->column_fields[$fieldname]);
  				}else
  				{
  				  $field_list = $this->column_fields[$fieldname];
          		}
  				$fldvalue = $field_list;
			  }
			  elseif($uitype == 5 || $uitype == 6 || $uitype ==23)
			  {
				  if($_REQUEST['action'] == 'Import')
				  {
					  $fldvalue = $this->column_fields[$fieldname];
				  }
				  else
				  {
					  $fldvalue = getDBInsertDateValue($this->column_fields[$fieldname]);
				  }
			  }
			  elseif($uitype == 7)
			  {
				  //strip warehouse the spaces and commas in numbers if given ie., in amounts there may be ,
				  $fldvalue = str_replace(",","",$this->column_fields[$fieldname]);//trim($this->column_fields[$fieldname],",");

			  }
			  else
			  {
				  $fldvalue = $this->column_fields[$fieldname]; 
				  $fldvalue = stripslashes($fldvalue);
			  }
			  ////$fldvalue = from_html($adb->formatString($table_name,$columname,$fldvalue),($insertion_mode == 'edit')?true:false);
			  $fldvalue = $adb->formatString($table_name,$columname,$fldvalue);
		  }
		  else
		  {
			  $fldvalue = '';
		  }
		  if($fldvalue=='') $fldvalue ="NULL";
		  if($insertion_mode == 'edit')
		  {	
			  if($i == 0)
			  {
				  $update = $columname."=".$fldvalue."";
			  }
			  else
			  {
				  $update .= ', '.$columname."=".$fldvalue."";
			  }
		  }
		  else
		  {
			  $column .= ", ".$columname;
			  $value .= ", ".$fldvalue."";
		  }
	  }

	  if($insertion_mode == 'edit')
	  {
		  //if necessary history can be added here 
		  //Check done by Don. If update is empty the the query fails
		  if(trim($update) != '')
          {
			$sql1 = "update ".$table_name." set ".$update." where ".$this->tab_name_index[$table_name]."=".$this->id;
			$adb->query($sql1); 
		  }
		  
		  //to disable the update of groupentity relation in ajax edit for the fields except assigned_user_id field
		  if($_REQUEST['ajxaction'] != 'DETAILVIEW' || ($_REQUEST['ajxaction'] == 'DETAILVIEW' && $_REQUEST['fldName'] == 'assigned_user_id'))
		  {	  
			  if($_REQUEST['assigntype'] == 'T')
			  {
				  $groupname = $_REQUEST['assigned_group_name'];
				  $this->updateWarehousesGroupRelation($this->id,$groupname);
			  }
			  else
			  {
				  //group name is null
				  $this->updateWarehousesGroupRelation($this->id,'');
			  }
		  }
		 

	  }
	  else
	  {	
		  $sql1 = "insert into ".$table_name." (".$column.") values(".$value.")";
		  $adb->query($sql1); 
		  $groupname = $_REQUEST['assigned_group_name'];
		  if($_REQUEST['assigntype'] == 'T')
		  {
			  $this->insert2WarehousesGroupRelation($this->id,$groupname);
		  }
		 

	  }

  }

	function save_module($module)
	{
		global $mod_strings;
		global $app_strings;
		if($_REQUEST['action'] != 'WarehousesAjax' && $_REQUEST['ajxaction'] != 'DETAILVIEW')
		{
			if($this->column_fields['warehousestatus'] == $app_strings["WAREHOUSED"]) {
				$this->saveProductDetails(true);				
				if($this->column_fields["purchaseorder_id"] != '')
				{
						$po_id = $this->column_fields["purchaseorder_id"];
						//$query1 = "update ec_purchaseorder set postatus='".$app_strings["WAREHOUSED"]."' where purchaseorderid=".$po_id;
						//$this->db->query($query1);
						$_REQUEST['ajxaction'] = 'DETAILVIEW';
						include_once("modules/PurchaseOrder/PurchaseOrder.php");
						$purchaseorder_focus = new PurchaseOrder();
						$purchaseorder_focus->retrieve_entity_info($po_id,"PurchaseOrder");
						$purchaseorder_focus->column_fields['postatus'] = $app_strings["WAREHOUSED"];
						$purchaseorder_focus->id = $po_id;
						$purchaseorder_focus->mode = "edit";
						$purchaseorder_focus->save("PurchaseOrder");
				}
			} else {
				$this->saveProductDetails();
			}
			
		}
	}

	function updateQtyAndStatus()
	{
		global $app_strings;
		$this->updateQtyInStock();
		//$query = "update ec_warehouses set warehousestatus='".$app_strings["WAREHOUSED"]."' where warehousesid=".$this->id;
		//$this->db->query($query);
		$_REQUEST['ajxaction'] = 'DETAILVIEW';
		$this->column_fields["warehousestatus"] = $app_strings["WAREHOUSED"];
		$this->mode = "edit";
		$this->save("Warehouses");

		if($this->column_fields["purchaseorder_id"] != '')
		{
				$po_id = $this->column_fields["purchaseorder_id"];
				//$query = "update ec_purchaseorder set postatus='".$app_strings["WAREHOUSED"]."' where purchaseorderid=".$po_id;
				//$this->db->query($query);
				include_once("modules/PurchaseOrder/PurchaseOrder.php");
				$purchaseorder_focus = new PurchaseOrder();
				$purchaseorder_focus->retrieve_entity_info($po_id,"PurchaseOrder");
				$purchaseorder_focus->column_fields['postatus'] = $app_strings["WAREHOUSED"];
				$purchaseorder_focus->id = $po_id;
				$purchaseorder_focus->mode = "edit";
				$purchaseorder_focus->save("PurchaseOrder");
		}
	}


	/**
	 *      This function is used to add the ec_attachments. This will call the function uploadAndSaveFile which will upload the attachment into the server and save that attachment information in the database.
	 *      @param int $id  - entity id to which the ec_files to be uploaded
	 *      @param string $module  - the current module name
	*/
	function insertIntoAttachment($id,$module)
	{
		global $log, $adb;
		$log->debug("Entering into insertIntoAttachment($id,$module) method.");
		
		$file_saved = false;

		foreach($_FILES as $fileindex => $files)
		{
			if($files['name'] != '' && $files['size'] > 0)
			{
				$file_saved = $this->uploadAndSaveFile($id,$module,$files);
			}
		}

		$log->debug("Exiting from insertIntoAttachment($id,$module) method.");
	}


	/** Function to export the notes in CSV Format
	* @param reference variable - order by is passed when the query is executed
	* @param reference variable - where condition is passed when the query is executed
	* Returns Export Warehouses Query.
	*/
	function create_export_query(&$order_by, &$where)
	{
		global $log;
		$log->debug("Entering create_export_query(".$order_by.",". $where.") method ...");

		include("include/utils/ExportUtils.php");

		//To get the Permitted fields query and the permitted fields list
		$sql = getPermittedFieldsQuery("Warehouses", "detail_view");
		global $mod_strings;
		global $current_language;
		if(empty($mod_strings)) {
			$mod_strings = return_module_language($current_language,"Warehouses");
		}
		$fields_list = getFieldsListFromQuery($sql,$mod_strings);

		$query = "SELECT $fields_list FROM ec_warehouses
				inner join ec_crmentity 
					on ec_crmentity.crmid=ec_warehouses.notesid 
				LEFT JOIN ec_warehousesgrouprelation
                	                ON ec_warehouses.notesid = ec_warehousesgrouprelation.notesid
	                        LEFT JOIN ec_groups
                        	        ON ec_groups.groupname = ec_warehousesgrouprelation.groupname
				LEFT JOIN ec_users
					ON ec_crmentity.smownerid = ec_users.id 
				WHERE ec_crmentity.deleted=0 ".$where;

				$log->debug("Exiting create_export_query method ...");
                return $query;
        }

		function getListQuery($where,$isSearchAll=false){
			global $current_user;
			$module = "Warehouses";
			$viewscope = get_viewscope($module);
			$key = "listquery_".$module."_".$viewscope."_".$isSearchAll."_".$current_user->id;
			$query = getSqlCacheData($key);
			if(!$query) {
				require('user_privileges/user_privileges_'.$current_user->id.'.php');		
		        require('user_privileges/sharing_privileges_'.$current_user->id.'.php');
				
				$query = "SELECT ec_crmentity.crmid, ec_crmentity.modifiedtime,ec_crmentity.smownerid,case when (ec_users.user_name not like '') then ec_users.user_name else ec_groups.groupname end as user_name,			
				ec_warehouses.* FROM ec_warehouses
				INNER JOIN ec_crmentity
					ON ec_crmentity.crmid = ec_warehouses.warehousesid
				INNER JOIN ec_warehousescf
					ON ec_warehouses.warehousesid = ec_warehousescf.warehousesid 
				LEFT JOIN ec_warehousesgrouprelation
					ON ec_warehouses.warehousesid = ec_warehousesgrouprelation.warehousesid
				LEFT JOIN ec_groups
					ON ec_groups.groupname = ec_warehousesgrouprelation.groupname
				LEFT JOIN ec_users
					ON ec_users.id = ec_crmentity.smownerid 
				LEFT JOIN ec_purchaseorder
					ON ec_warehouses.purchaseorderid = ec_purchaseorder.purchaseorderid 
				WHERE ec_crmentity.deleted = 0 ";
				
				
				$tab_id = getTabid($module);
				if(($is_admin==false && $profileGlobalPermission[1] == 1 && $profileGlobalPermission[2] == 1 && $defaultOrgSharingPermission[$tab_id] == 3) || isset($_REQUEST['viewscope']) || isset($_SESSION[$module.'_viewscope']))
				{
					$sec_parameter=getListViewSecurityParameter($module,$isSearchAll);
					$query .= $sec_parameter;
				}
				setSqlCacheData($key,$query);
			}
			$query = $query.$where;
			return $query;
		}

		 /** Function to add lead group relation 
		  * @param $leadid -- Lead Id:: Type integer
		  * @param $groupname -- Group Name:: Type varchar
		  *
		 */
		function insert2WarehousesGroupRelation($warehousesid,$groupname)
		{
			global $log;
			$log->debug("Entering insert2WarehousesGroupRelation(".$warehousesid.",".$groupname.") method ...");
			global $adb;
			$sql = "insert into ec_warehousesgrouprelation values (" .$warehousesid .",'".$groupname."')";
			$adb->query($sql);
			$log->debug("Exiting insert2WarehousesGroupRelation method ...");
		}

		/** Function to update lead group relation 
		  * @param $leadid -- Lead Id:: Type integer
		  * @param $groupname -- Group Name:: Type varchar
		  *
		 */
		function updateWarehousesGroupRelation($warehousesid,$groupname)
		{
			global $log;
			$log->debug("Entering updateLeadGroupRelation(".$warehousesid.",".$groupname.") method ...");
			global $adb;
			$sqldelete = "delete from ec_warehousesgrouprelation where warehousesid=".$warehousesid;
			$adb->query($sqldelete);
			$sql = "insert into ec_warehousesgrouprelation values (".$warehousesid .",'" .$groupname ."')";  
			$adb->query($sql);
			$log->debug("Exiting updateLeadGroupRelation method ...");
		}

	/**
	* Function to get Warehouse related Accounts 
	* @param  integer   $id      - warehousesid
	* returns related visits record in array format
	*/
	function get_accounts($id)
	{
		global $log, $singlepane_view;
        $log->debug("Entering get_visits(".$id.") method ...");
		require_once('modules/Accounts/Accounts.php');
		global $app_strings;

		$focus = new Accounts();

		$button = '';

		if(isPermitted("Accounts",1,"") == 'yes')
		{
			$button .= '<input title="New Product" accessyKey="F" class="button" onclick="this.form.action.value=\'EditView\';this.form.module.value=\'Products\';this.form.return_module.value=\'Accounts\';this.form.return_action.value=\'DetailView\'" type="submit" name="button" value="'.$app_strings['LBL_NEW_PRODUCT'].'">&nbsp;';
		}
		if($singlepane_view == 'true')
			$returnset = '&return_module=Warehouses&return_action=DetailView&return_id='.$id;
		else
			$returnset = '&return_module=Warehouses&return_action=CallRelatedList&return_id='.$id;

		$query = "SELECT ec_account.*,
			ec_crmentity.crmid, ec_crmentity.smownerid
			FROM ec_account
			INNER JOIN ec_crmentity
				ON ec_crmentity.crmid = ec_account.accountid
			INNER JOIN ec_warehouses
				ON ec_warehouses.warehousesid = ec_potential.warehousesid
			INNER JOIN ec_potential
				ON ec_potential.warehousesid = ec_warehouses.warehousesid and ec_potential.accountid=ec_account.accountid 
			WHERE ec_warehouses.warehousesid = ".$id."
			AND ec_crmentity.deleted = 0";
		$log->debug("Exiting get_accounts method ...");
		return GetRelatedList('Warehouses','Accounts',$focus,$query,$button,$returnset);
	}

	//get next salesorder id
	function get_next_id() {
		//$query = "select count(*) as num from ec_warehouses";
		//$result = $this->db->query($query);		
		//$num = $this->db->query_result($result,0,'num') + 1;
		$num = $this->db->getUniqueID("ec_warehouses");
		if($num > 99) return $num;
		elseif($num > 9) return "0".$num;
		else return "00".$num;
	}

	function getReportQuery() {
		 $query = "from ec_warehouses inner join ec_crmentity as ec_crmentityWarehouses on ec_crmentityWarehouses.crmid=ec_warehouses.warehousesid 
		 left join ec_warehousesgrouprelation ON ec_warehouses.warehousesid = ec_warehousesgrouprelation.warehousesid 
		 left join ec_groups	ON ec_groups.groupname = ec_warehousesgrouprelation.groupname
		 left join ec_users as ec_usersWarehouses on ec_usersWarehouses.id = ec_crmentityWarehouses.smownerid where ec_crmentityWarehouses.deleted=0 ";
		 return $query;
	}
	function getWorkflowQuery() {
		 $query = "select ec_warehouses.warehousesid from ec_warehouses inner join ec_crmentity as ec_crmentityWarehouses on   ec_crmentityWarehouses.crmid=ec_warehouses.warehousesid 
		 left join ec_warehousesgrouprelation ON ec_warehouses.warehousesid = ec_warehousesgrouprelation.warehousesid 
		 left join ec_groups	ON ec_groups.groupname = ec_warehousesgrouprelation.groupname
		 left join ec_users as ec_usersWarehouses on ec_usersWarehouses.id = ec_crmentityWarehouses.smownerid where ec_crmentityWarehouses.deleted=0 ";
		 return $query;
	}
	/**	Function used to save the Inventory product details for the passed entity
	 *	@param object reference $focus - object reference to which we want to save the product details from REQUEST values where as the entity will be out,in
	 *	@param string $module - module name
	 *	@param $update_prod_stock - true or false (default), if true we have to update the stock for PO only
	 *	@return void
	 */
	function saveProductDetails($update_prod_stock=false)
	{
		global $log, $adb;
		$log->debug("Entering into function saveProductDetails().");
		$ext_prod_arr = Array();
		if($this->mode == 'edit')
		{
			$return_old_values = 'return_old_values';
			//we will retrieve the existing product details and store it in a array and then delete all the existing product details and save new values, retrieve the old value and update stock only for SO, Quotes and Invoice not for PO
			$ext_prod_arr = deleteInventoryProductDetails($this->id,$return_old_values);
		}
		$tot_no_prod = $_REQUEST['totalProductCount'];
		$prod_seq=1;
		for($i=1; $i<=$tot_no_prod; $i++)
		{
			$prod_id = $_REQUEST['hdnProductId'.$i];
			$qty = $_REQUEST['qty'.$i];
			$comment = addslashes($_REQUEST['comment'.$i]);
			//if the product is deleted then we should avoid saving the deleted products
			if(isset($_REQUEST["deleted".$i]) && $_REQUEST["deleted".$i] == 1)
				continue;
			$query ="insert into ec_inventoryproductrel(id, productid, sequence_no, quantity, comment) values($this->id, $prod_id , $prod_seq, $qty, '$comment')";
			$prod_seq ++;
			$adb->query($query);
			if($update_prod_stock) {
				$qtyinstock = getPrdQtyInStck($prod_id);
				$lates_qty = $qtyinstock+$qty;
				updateProductQty($prod_id,$lates_qty);
			}
		}
		$query ="update ec_warehouses set total='".$_REQUEST['total']."' where warehousesid='".$this->id."'";
		$this->db->query($query);
		$log->debug("Exit from function saveProductDetails().");
	}

	/**	Function used to save the Inventory product details for the passed entity
	 *	@param object reference $focus - object reference to which we want to save the product details from REQUEST values where as the entity will be out,in
	 *	@param string $module - module name
	 *	@param $update_prod_stock - true or false (default), if true we have to update the stock for PO only
	 *	@return void
	 */
	function updateQtyInStock()
	{
		global $log, $adb;
		$log->debug("Entering into function updateQtyInStock().");
		$query = "select productid, quantity from ec_inventoryproductrel where id='".$this->id."'";
		$result = $adb->query($query);
		while($row = $adb->fetch_array($result)) {
			$productid = $row['productid'];
			$quantity = $row['quantity'];
			$qtyinstock = getPrdQtyInStck($productid);
			$lates_qty = $qtyinstock+$quantity;
			updateProductQty($productid,$lates_qty);
		}
		$log->debug("Exit from function updateQtyInStock().");
	}

	/**	Function used to get the sort order for WAREHOUSES listview
	 *	@return string	$sorder	- first check the $_REQUEST['sorder'] if request value is empty then check in the $_SESSION['WAREHOUSES_SORT_ORDER'] if this session value is empty then default sort order will be returned. 
	 */
	function getSortOrder()
	{
		global $log;
        $log->debug("Entering getSortOrder() method ...");	
		if(isset($_REQUEST['sorder'])) 
			$sorder = $_REQUEST['sorder'];
		else
			$sorder = (isset($_SESSION['WAREHOUSES_SORT_ORDER'])?($_SESSION['WAREHOUSES_SORT_ORDER']):($this->default_sort_order));
		$log->debug("Exiting getSortOrder() method ...");
		return $sorder;
	}

	/**	Function used to get the order by value for Sales Order listview
	 *	@return string	$order_by  - first check the $_REQUEST['order_by'] if request value is empty then check in the $_SESSION['WAREHOUSES_ORDER_BY'] if this session value is empty then default order by will be returned. 
	 */
	function getOrderBy()
	{
		global $log;
        $log->debug("Entering getOrderBy() method ...");
		if (isset($_REQUEST['order_by'])) 
			$order_by = $_REQUEST['order_by'];
		else
			$order_by = (isset($_SESSION['WAREHOUSES_ORDER_BY'])?($_SESSION['WAREHOUSES_ORDER_BY']):($this->default_order_by));
		$log->debug("Exiting getOrderBy method ...");
		return $order_by;
	}

}
?>
