<?php

/*********************************************************************************
** The contents of this file are subject to the vtiger CRM Public License Version 1.0
 * ("License"); You may not use this file except in compliance with the License
 * The Original Code is:  vtiger CRM Open Source
 * The Initial Developer of the Original Code is vtiger.
 * Portions created by vtiger are Copyright (C) vtiger.
 * All Rights Reserved.
 ********************************************************************************/

include_once('config.php');
require_once('include/logging.php');
require_once('include/database/PearDatabase.php');
require_once('data/SugarBean.php');
require_once('data/CRMEntity.php');
require_once('include/utils/utils.php');

/** Class to populate the default required data during installation  
 */

class DefaultDataPopulator extends CRMEntity {
		
	function DefaultDataPopulator() {
		$this->log = LoggerManager::getLogger('DefaultDataPopulator');
		$this->db = & getSingleDBInstance();
	}

	var $new_schema = true;

	function create_defautdata($is_upgrade=false) {
	}


	/** Function to populate the default required data during installation  
 	*/
	function create_tables ($is_upgrade=false) {
		//global $app_strings;

		$role1_id = $this->db->getUniqueID("ec_role");
		$role2_id = $this->db->getUniqueID("ec_role");
		$role3_id = $this->db->getUniqueID("ec_role");
		$role4_id = $this->db->getUniqueID("ec_role");
		$role5_id = $this->db->getUniqueID("ec_role");

		//$profile1_id = $this->db->getUniqueID("ec_profile");
		$profile1_id = 1;
		//$profile2_id = $this->db->getUniqueID("ec_profile");
		$profile2_id = 2;
		//$profile3_id = $this->db->getUniqueID("ec_profile");
		$profile3_id = 3;
		//$profile4_id = $this->db->getUniqueID("ec_profile");
		$profile4_id = 4;
		if(!$is_upgrade) {
			$this->db->query("insert into ec_role values('H".$role1_id."','总公司','H".$role1_id."',0)");
			$this->db->query("insert into ec_role values('H".$role2_id."','总经理','H".$role1_id."::H".$role2_id."',1)");
			$this->db->query("insert into ec_role values('H".$role3_id."','副总经理','H".$role1_id."::H".$role2_id."::H".$role3_id."',2)");
			$this->db->query("insert into ec_role values('H".$role4_id."','销售经理','H".$role1_id."::H".$role2_id."::H".$role3_id."::H".$role4_id."',3)");
			$this->db->query("insert into ec_role values('H".$role5_id."','销售人员','H".$role1_id."::H".$role2_id."::H".$role3_id."::H".$role4_id."::H".$role5_id."',4)");
		}

		//if($is_upgrade) {
		//	$this->db->query("delete from ec_tab");
		//}
		if(!$is_upgrade) {
			$this->db->query("INSERT INTO ec_tab VALUES (3,'Home',0,1,'Home',null,null,1,0)");
			$this->db->query("INSERT INTO ec_tab VALUES (7,'Leads',0,4,'Leads',null,null,1,0)");
			$this->db->query("INSERT INTO ec_tab VALUES (6,'Accounts',0,5,'Accounts',null,null,1,1)");
			$this->db->query("INSERT INTO ec_tab VALUES (4,'Contacts',0,6,'Contacts',null,null,1,1)");
			$this->db->query("INSERT INTO ec_tab VALUES (2,'Potentials',0,7,'Potentials',null,null,1,1)");
			$this->db->query("INSERT INTO ec_tab VALUES (8,'Notes',0,9,'Notes',null,null,1,1)");
			$this->db->query("INSERT INTO ec_tab VALUES (9,'Calendar',0,3,'Calendar',null,null,1,1)");
			$this->db->query("INSERT INTO ec_tab VALUES (10,'Emails',0,10,'Emails',null,null,1,0)");
			$this->db->query("INSERT INTO ec_tab VALUES (13,'HelpDesk',0,11,'HelpDesk',null,null,1,1)");
			$this->db->query("INSERT INTO ec_tab VALUES (14,'Products',0,8,'Products',null,null,1,1)");
			$this->db->query("INSERT INTO ec_tab VALUES (1,'Dashboard',0,12,'Dashboards',null,null,1,0)");
			$this->db->query("INSERT INTO ec_tab VALUES (15,'Faq',0,14,'Faq',null,null,1,1)");
			$this->db->query("INSERT INTO ec_tab VALUES (16,'Events',2,13,'Events',null,null,1,1)");
			$this->db->query("INSERT INTO ec_tab VALUES (18,'Vendors',0,15,'Vendors',null,null,1,1)");
			$this->db->query("INSERT INTO ec_tab VALUES (19,'PriceBooks',0,16,'PriceBooks',null,null,1,1)");
			$this->db->query("INSERT INTO ec_tab VALUES (20,'Quotes',0,17,'Quotes',null,null,1,1)");
			$this->db->query("INSERT INTO ec_tab VALUES (21,'PurchaseOrder',0,18,'PurchaseOrder',null,null,1,1)");
			$this->db->query("INSERT INTO ec_tab VALUES (22,'SalesOrder',0,19,'SalesOrder',null,null,1,1)");
			$this->db->query("INSERT INTO ec_tab VALUES (23,'Invoice',0,20,'Invoice',null,null,1,1)");
			$this->db->query("INSERT INTO ec_tab VALUES (24,'Rss',0,21,'Rss',null,null,1,0)");
			$this->db->query("INSERT INTO ec_tab VALUES (25,'Reports',0,22,'Reports',null,null,1,0)");
			$this->db->query("INSERT INTO ec_tab VALUES (26,'Campaigns',0,23,'Campaigns',null,null,1,1)");
			$this->db->query("INSERT INTO ec_tab VALUES (27,'Portal',0,24,'Portal',null,null,1,0)");
			$this->db->query("INSERT INTO ec_tab VALUES (28,'Webmails',0,25,'Webmails',null,null,1,0)");
			$this->db->query("insert into ec_tab values (29,'Users',0,26,'Users',null,null,1,0)");
			//add exhibition module
			//$this->db->query("insert into ec_tab values (30,'Exhibitions',0,30,'Exhibitions',null,null,1)");
			//add messages module
			$this->db->query("insert into ec_tab values (32,'Messages',0,32,'Messages',null,null,1,1)");
			//add gathers module
			$this->db->query("insert into ec_tab values (33,'Gathers',0,33,'Gathers',null,null,1,1)");
			//add charge module
			$this->db->query("insert into ec_tab values (34,'Charges',0,34,'Charges',null,null,1,1)");
			//add expense module
			$this->db->query("insert into ec_tab values (35,'Expenses',0,35,'Expenses',null,null,1,1)");
			//add Workflow module
			$this->db->query("insert into ec_tab values (36,'Workflows',0,36,'Workflows',null,null,1,0)");
			//add Documents module
			$this->db->query("insert into ec_tab values (37,'Documents',0,37,'Documents',null,null,1,1)");
		}
		// Populate the ec_blocks ec_table
		//if($is_upgrade) {
		//	$this->db->query("delete from ec_blocks");
		//}
		if(!$is_upgrade) {
			$this->db->query("insert into ec_blocks values (1,2,'LBL_OPPORTUNITY_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (2,2,'LBL_CUSTOM_INFORMATION',2,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (3,2,'LBL_DESCRIPTION_INFORMATION',3,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (4,4,'LBL_CONTACT_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (5,4,'LBL_CUSTOM_INFORMATION',2,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (6,4,'LBL_CUSTOMER_PORTAL_INFORMATION',3,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (7,4,'LBL_ADDRESS_INFORMATION',4,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (8,4,'LBL_DESCRIPTION_INFORMATION',6,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (9,6,'LBL_ACCOUNT_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (10,6,'LBL_CUSTOM_INFORMATION',2,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (11,6,'LBL_ADDRESS_INFORMATION',3,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (12,6,'LBL_DESCRIPTION_INFORMATION',5,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (13,7,'LBL_LEAD_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (14,7,'LBL_CUSTOM_INFORMATION',2,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (15,7,'LBL_ADDRESS_INFORMATION',3,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (16,7,'LBL_DESCRIPTION_INFORMATION',4,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (17,8,'LBL_NOTE_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (18,8,'',2,1,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (19,9,'LBL_TASK_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (20,9,'',2,1,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (21,10,'LBL_EMAIL_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (22,10,'',2,1,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (23,10,'',3,1,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (24,10,'',4,1,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (25,13,'LBL_TICKET_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (26,13,'',2,1,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (27,13,'LBL_CUSTOM_INFORMATION',3,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (28,13,'LBL_DESCRIPTION_INFORMATION',4,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (29,13,'LBL_TICKET_RESOLUTION',5,0,0,1,0,0)");
			$this->db->query("insert into ec_blocks values (30,13,'LBL_COMMENTS',6,0,0,1,0,0)");
			$this->db->query("insert into ec_blocks values (31,14,'LBL_PRODUCT_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (32,14,'LBL_PRICING_INFORMATION',2,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (33,14,'LBL_STOCK_INFORMATION',3,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (34,14,'LBL_CUSTOM_INFORMATION',4,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (35,14,'LBL_IMAGE_INFORMATION',5,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (36,14,'LBL_DESCRIPTION_INFORMATION',6,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (37,15,'LBL_FAQ_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (38,15,'',2,1,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (39,15,'',3,1,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (40,15,'LBL_COMMENT_INFORMATION',4,0,0,1,0,0)");
			$this->db->query("insert into ec_blocks values (41,16,'LBL_EVENT_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (42,16,'',2,1,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (43,16,'',3,1,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (44,18,'LBL_VENDOR_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (45,18,'LBL_CUSTOM_INFORMATION',2,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (46,18,'LBL_VENDOR_ADDRESS_INFORMATION',3,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (47,18,'LBL_DESCRIPTION_INFORMATION',4,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (48,19,'LBL_PRICEBOOK_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (49,19,'LBL_CUSTOM_INFORMATION',2,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (50,19,'LBL_DESCRIPTION_INFORMATION',3,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (51,20,'LBL_QUOTE_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (52,20,'LBL_CUSTOM_INFORMATION',2,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (53,20,'LBL_ADDRESS_INFORMATION',3,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (54,20,'LBL_RELATED_PRODUCTS',4,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (55,20,'LBL_TERMS_INFORMATION',5,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (56,20,'LBL_DESCRIPTION_INFORMATION',6,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (57,21,'LBL_PO_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (58,21,'LBL_CUSTOM_INFORMATION',2,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (59,21,'LBL_ADDRESS_INFORMATION',3,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (60,21,'LBL_RELATED_PRODUCTS',4,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (61,21,'LBL_TERMS_INFORMATION',5,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (62,21,'LBL_DESCRIPTION_INFORMATION',6,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (63,22,'LBL_SO_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (64,22,'LBL_CUSTOM_INFORMATION',2,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (65,22,'LBL_ADDRESS_INFORMATION',3,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (66,22,'LBL_RELATED_PRODUCTS',4,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (67,22,'LBL_TERMS_INFORMATION',5,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (68,22,'LBL_DESCRIPTION_INFORMATION',6,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (69,23,'LBL_INVOICE_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (70,23,'LBL_CUSTOM_INFORMATION',2,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (71,23,'LBL_ADDRESS_INFORMATION',3,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (72,23,'LBL_RELATED_PRODUCTS',4,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (73,23,'LBL_TERMS_INFORMATION',5,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (74,23,'LBL_DESCRIPTION_INFORMATION',6,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (75,4,'LBL_IMAGE_INFORMATION',5,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (76,26,'LBL_CAMPAIGN_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (77,26,'LBL_CUSTOM_INFORMATION',2,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (78,26,'LBL_EXPECTATIONS_AND_ACTUALS',3,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (79,29,'LBL_USERLOGIN_ROLE',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (80,29,'LBL_MORE_INFORMATION',2,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (81,29,'LBL_ADDRESS_INFORMATION',3,0,0,0,0,0)");
			//Added an extra block for new UI Settings in Campaigns module 
			$this->db->query("insert into ec_blocks values (82,26,'LBL_DESCRIPTION_INFORMATION',4,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (83,29,'LBL_USER_IMAGE_INFORMATION',4,0,0,0,0,0)"); //Added a New Block User Image Info in Users Module

			//Added an extra block for new UI Settings in Accounts module 
			$this->db->query("insert into ec_blocks values (84,6,'LBL_BANK_INFORMATION',4,0,0,0,0,0)");

			//Added an extra block for new UI Settings in Exhibition module 
			//$this->db->query("insert into ec_blocks values (85,30,'LBL_EXHIBITION_INFORMATION',1,0,0,0,0,0)");
			//$this->db->query("insert into ec_blocks values (86,30,'LBL_CUSTOM_INFORMATION',2,0,0,0,0,0)");

			//Added an extra block for new UI Settings in Messages module 
			$this->db->query("insert into ec_blocks values (90,32,'LBL_MESSAGE_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (91,32,'LBL_PHONES_INFORMATION',2,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (92,32,'LBL_BASIC_INFORMATION',3,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (93,32,'LBL_CUSTOM_INFORMATION',4,0,0,0,0,0)");

			//Added an extra block for new UI Settings in Gathers module 
			$this->db->query("insert into ec_blocks values (94,33,'LBL_GATHER_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (95,33,'LBL_CUSTOM_INFORMATION',2,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (96,33,'LBL_DESCRIPTION_INFORMATION',3,0,0,0,0,0)");

			//Added an extra block for new UI Settings in Charges module 
			$this->db->query("insert into ec_blocks values (97,34,'LBL_CHARGE_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (98,34,'LBL_CUSTOM_INFORMATION',2,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (99,34,'LBL_DESCRIPTION_INFORMATION',3,0,0,0,0,0)");

			//Added an extra block for new UI Settings in Expense module 
			$this->db->query("insert into ec_blocks values (100,35,'LBL_EXPENSE_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (101,35,'LBL_CUSTOM_INFORMATION',2,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (102,35,'LBL_DESCRIPTION_INFORMATION',3,0,0,0,0,0)");

			//Added an extra block for new UI Settings in Documents module 
			$this->db->query("insert into ec_blocks values (103,37,'LBL_DOCUMENT_INFORMATION',1,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (104,37,'LBL_CUSTOM_INFORMATION',2,0,0,0,0,0)");
			$this->db->query("insert into ec_blocks values (105,37,'LBL_DESCRIPTION_INFORMATION',3,0,0,0,0,0)");
		}

		//

		//Account Details -- START
		//Block9
		if($is_upgrade) {
			$this->db->query("delete from ec_field WHERE tablename NOT LIKE '%cf'");
		}
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'accountname','ec_account',1,'2','accountname','Account Name',1,0,0,100,1,9,1,'V~M',0,1,'BAS')");	
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'customernum','ec_account',1,'1','customernum','Account NO',1,0,0,100,2,9,1,'V~O',1,null,'BAS')");	
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'phone','ec_account',1,'11','phone','Phone',1,0,0,100,3,9,1,'V~O',0,2,'BAS')");	
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'website','ec_account',1,'17','website','Website',1,0,0,100,4,9,1,'V~O',0,3,'BAS')");	

		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'fax','ec_account',1,'1','fax','Fax',1,0,0,100,5,9,1,'V~O',1,null,'BAS')");	
		//delete tickersymbol field for china sme by dingjianting on 2006-12-25 
		//$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'tickersymbol','ec_account',1,'1','tickersymbol','Ticker Symbol',1,0,0,100,5,9,1,'V~O',1,null,'BAS')");	
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'otherphone','ec_account',1,'11','otherphone','Other Phone',1,0,0,100,6,9,1,'V~O',1,null,'ADV')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'parentid','ec_account',1,'51','account_id','Member Of',1,0,0,100,7,9,1,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'email1','ec_account',1,'13','email1','Email',1,0,0,100,8,9,1,'E~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'employees','ec_account',1,'15','employees','Employees',1,0,0,100,9,9,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'email2','ec_account',1,'13','email2','Other Email',1,0,0,100,10,9,1,'E~O',1,null,'ADV')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'leadsource','ec_account',1,'15','leadsource','Lead Source',1,0,0,100,11,9,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'grade','ec_account',1,'15','grade','Grade',1,0,0,100,12,9,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'rating','ec_account',1,'15','rating','Rating',1,0,0,100,13,9,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'industry','ec_account',1,'15','industry','industry',1,0,0,100,14,9,1,'V~O',1,null,'BAS')");
		//delete tickersymbol field for china sme by dingjianting on 2006-12-25 
        $this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'ownership','ec_account',1,'15','ownership','Ownership',1,0,0,100,15,9,1,'V~O',1,null,'ADV')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'account_type','ec_account',1,'15','accounttype','Type',1,0,0,100,16,9,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'annualrevenue','ec_account',1,'15','annualrevenue','Annual Revenue',1,0,0,100,17,9,1,'V~O',1,null,'ADV')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'build_date','ec_account',1,'5','build_date','Build Date',1,0,0,100,18,9,1,'D~O',1,null,'ADV')");
		//Added ec_field emailoptout for ec_accounts -- after 4.2 patch2 
		//delete tickersymbol field for china sme by dingjianting on 2006-12-25 
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'contact_date','ec_account',1,'5','contact_date','Contact Date',1,0,0,100,19,9,1,'D~O',1,null,'BAS')");
		
		//$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'notify_owner','ec_account',1,56,'notify_owner','Notify Owner',1,0,0,10,19,9,1,'C~O',1,NULL,'ADV')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'smownerid','ec_crmentity',1,'53','assigned_user_id','Assigned To',1,0,0,100,20,9,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,21,9,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,22,9,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'viewedtime','ec_crmentity',1,'1005','viewedtime','Viewed Time',1,0,0,100,23,9,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'lastcontacttime','ec_account',1,'70','lastcontacttime','lastcontacttime',1,0,0,100,24,9,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'contacttimes','ec_account',1,'1','contacttimes','contacttimes',1,0,0,100,25,9,2,'I~O',1,null,'BAS')");

		//add bank info for accounts
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'bankname','ec_account',1,'1','bankname','Bank Name',1,0,0,100,23,84,1,'V~O',1,null,'BAS')");	
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'bank_accountname','ec_account',1,'1','bank_accountname','Bank Account Name',1,0,0,100,24,84,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'bank_accountid','ec_account',1,'1','bank_accountid','Bank Account ID',1,0,0,100,25,84,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'bank_taxid','ec_account',1,'1','bank_taxid','Bank TAX ID',1,0,0,100,26,84,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'payment_type','ec_account',1,'15','paymenttype','Payment Type',1,0,0,100,27,84,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'payment_credit','ec_account',1,'1','payment_credit','Payment Credit',1,0,0,100,28,84,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'ordernum','ec_account',1,'1','ordernum','ordernum',1,0,0,100,29,84,1,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'ordertotal','ec_account',1,'1','ordertotal','ordertotal',1,0,0,100,30,84,1,'N~O',1,null,'BAS')");





		//Block 11
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'country','ec_accountbillads',1,'1','bill_country','Billing Country',1,0,0,100,1,11,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'country','ec_accountshipads',1,'1','ship_country','Shipping Country',1,0,0,100,2,11,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'state','ec_accountbillads',1,'1','bill_state','Billing State',1,0,0,100,3,11,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'state','ec_accountshipads',1,'1','ship_state','Shipping State',1,0,0,100,4,11,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'city','ec_accountbillads',1,'1','bill_city','Billing City',1,0,0,100,5,11,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'city','ec_accountshipads',1,'1','ship_city','Shipping City',1,0,0,100,6,11,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'street','ec_accountbillads',1,'21','bill_street','Billing Address',1,0,0,100,7,11,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'street','ec_accountshipads',1,'21','ship_street','Shipping Address',1,0,0,100,8,11,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'pobox','ec_accountbillads',1,'1','bill_pobox','Billing Po Box',1,0,0,100,9,11,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'pobox','ec_accountshipads',1,'1','ship_pobox','Shipping Po Box',1,0,0,100,10,11,1,'V~O',1,null,'BAS')");		

		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'code','ec_accountbillads',1,'1','bill_code','Billing Code',1,0,0,100,11,11,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'code','ec_accountshipads',1,'1','ship_code','Shipping Code',1,0,0,100,12,11,1,'V~O',1,null,'BAS')");
		//Block12
		$this->db->query("insert into ec_field values (6,".$this->db->getUniqueID("ec_field").",'description','ec_crmentity',1,'19','description','Description',1,0,0,100,1,12,1,'V~O',1,null,'BAS')");

		//Account Details -- END


		//Lead Details --- START

		//Block13 -- Start

		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'salutation','ec_leaddetails',1,'55','salutationtype','Salutation',1,0,0,100,1,13,3,'V~O',1,null,'BAS')");	
		//$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'firstname','ec_leaddetails',1,'55','firstname','First Name',1,0,0,100,2,13,1,'V~O',0,1,'BAS')");	
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'company','ec_leaddetails',1,'2','company','Company',1,0,0,100,4,13,1,'V~M',0,3,'BAS')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'lastname','ec_leaddetails',1,'2','lastname','Last Name',1,0,0,100,4,13,1,'V~M',0,2,'BAS')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'phone','ec_leadaddress',1,'11','phone','Phone',1,0,0,100,5,13,1,'V~O',0,4,'BAS')"); 	
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'mobile','ec_leadaddress',1,'1','mobile','Mobile',1,0,0,100,6,13,1,'V~O',1,null,'BAS')");	 
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'fax','ec_leadaddress',1,'1','fax','Fax',1,0,0,100,7,13,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'designation','ec_leaddetails',1,'1','designation','Designation',1,0,0,100,8,13,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'email','ec_leaddetails',1,'13','email','Email',1,0,0,100,9,13,1,'E~O',0,5,'BAS')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'leadsource','ec_leaddetails',1,'15','leadsource','Lead Source',1,0,0,100,10,13,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'website','ec_leadsubdetails',1,'17','website','Website',1,0,0,100,11,13,1,'V~O',1,null,'ADV')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'industry','ec_leaddetails',1,'15','industry','Industry',1,0,0,100,12,13,1,'V~O',1,null,'ADV')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'leadstatus','ec_leaddetails',1,'15','leadstatus','Lead Status',1,0,0,100,13,13,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'annualrevenue','ec_leaddetails',1,'71','annualrevenue','Annual Revenue',1,0,0,100,14,13,1,'I~O',1,null,'ADV')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'rating','ec_leaddetails',1,'15','rating','Rating',1,0,0,100,15,13,1,'V~O',1,null,'ADV')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'noofemployees','ec_leaddetails',1,'1','noofemployees','No Of Employees',1,0,0,100,16,13,1,'V~O',1,null,'ADV')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'smownerid','ec_crmentity',1,'53','assigned_user_id','Assigned To',1,0,0,100,17,13,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'yahooid','ec_leaddetails',1,'13','yahooid','Yahoo Id',1,0,0,100,18,13,1,'V~O',1,null,'ADV')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,19,13,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,20,13,2,'T~O',1,null,'BAS')");

		//Block13 -- End


		//Block15 -- Start

		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'lane','ec_leadaddress',1,'21','lane','Street',1,0,0,100,1,15,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'code','ec_leadaddress',1,'1','code','Postal Code',1,0,0,100,3,15,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'city','ec_leadaddress',1,'1','city','City',1,0,0,100,4,15,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'country','ec_leadaddress',1,'1','country','Country',1,0,0,100,5,15,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'state','ec_leadaddress',1,'1','state','State',1,0,0,100,6,15,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'pobox','ec_leadaddress',1,'1','pobox','Po Box',1,0,0,100,2,15,1,'V~O',1,null,'BAS')");

		//Block15 --End

		//Block16 -- Start

		$this->db->query("insert into ec_field values (7,".$this->db->getUniqueID("ec_field").",'description','ec_crmentity',1,'19','description','Description',1,0,0,100,1,16,1,'V~O',1,null,'BAS')");

		//Block16 -- End

		//Lead Details -- END


		//Contact Details -- START
		//Block4 -- Start

			
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'lastname','ec_contactdetails',1,'2','lastname','Last Name',1,0,0,100,1,4,1,'V~M',0,2,'BAS')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'salutationtype','ec_contactdetails',1,'15','salutationtype','Salutation Type',1,0,0,100,2,4,1,'V~O',1,null,'BAS')");
		//changed by dingjianting on 2007-01-11 for chinese name
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'englishname','ec_contactdetails',1,'1','englishname','English Name',1,0,0,100,3,4,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'title','ec_contactdetails',1,'1','title','Title',1,0,0,100,4,4,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'accountid','ec_contactdetails',1,'51','account_id','Account Name',1,0,0,100,5,4,1,'I~O',0,3,'BAS')");	
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'phone','ec_contactdetails',1,'11','phone','Office Phone',1,0,0,100,6,4,1,'V~O',0,4,'BAS')");	
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'mobile','ec_contactdetails',1,'1','mobile','Mobile',1,0,0,100,7,4,1,'V~O',1,null,'BAS')"); 
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'xiaolingtong','ec_contactdetails',1,'1','xiaolingtong','XiaoLingTong',1,0,0,100,8,4,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'fax','ec_contactdetails',1,'1','fax','Fax',1,0,0,100,9,4,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'email','ec_contactdetails',1,'13','email','Email',1,0,0,100,10,4,1,'E~O',0,5,'BAS')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'leadsource','ec_contactsubdetails',1,'15','leadsource','Lead Source',1,0,0,100,11,4,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'smownerid','ec_crmentity',1,'53','assigned_user_id','Assigned To',1,0,0,100,12,4,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'homephone','ec_contactsubdetails',1,'11','homephone','Home Phone',1,0,0,100,13,4,1,'V~O',1,null,'ADV')");	
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'otherphone','ec_contactsubdetails',1,'11','otherphone','Other Phone',1,0,0,100,14,4,1,'V~O',1,null,'ADV')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'assistantphone','ec_contactsubdetails',1,'11','assistantphone','Assistant Phone',1,0,0,100,15,4,1,'V~O',1,null,'ADV')");	  	
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'department','ec_contactdetails',1,'1','department','Department',1,0,0,100,16,4,1,'V~O',1,null,'ADV')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'birthday','ec_contactsubdetails',1,'5','birthday','Birthdate',1,0,0,100,17,4,1,'V~O',1,null,'ADV')"); 
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'reportsto','ec_contactdetails',1,'57','contact_id','Reports To',1,0,0,100,18,4,1,'V~O',1,null,'ADV')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'assistant','ec_contactsubdetails',1,'1','assistant','Assistant',1,0,0,100,19,4,1,'V~O',1,null,'ADV')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'msn','ec_contactdetails',1,'87','msn','MSN',1,0,0,100,20,4,1,'V~O',1,null,'BAS')"); 
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'qq','ec_contactdetails',1,'86','qq','QQ',1,0,0,100,21,4,1,'V~O',1,null,'BAS')"); 
		//$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'yahooid','ec_contactdetails',1,'13','yahooid','Yahoo Id',1,0,0,100,20,4,1,'V~O',1,null,'ADV')"); 
		//$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'donotcall','ec_contactdetails',1,'56','donotcall','Do Not Call',1,0,0,100,20,4,1,'C~O',1,null,'ADV')");
		//$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'emailoptout','ec_contactdetails',1,'56','emailoptout','Email Opt Out',1,0,0,100,21,4,1,'C~O',1,null,'ADV')"); 
		//$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'reference','ec_contactdetails',1,'56','reference','Reference',1,0,0,10,23,4,1,'C~O',1,null,'ADV')");
		//$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'notify_owner','ec_contactdetails',1,'56','notify_owner','Notify Owner',1,0,0,10,24,4,1,'C~O',1,null,'ADV')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,25,4,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,26,4,2,'T~O',1,null,'BAS')");
		//Block4 -- End

		//Block6 - Begin Customer Portal

		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'portal','ec_customerdetails',1,'56','portal','Portal User',1,0,0,100,1,6,1,'C~O',1,null,'ADV')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'support_start_date','ec_customerdetails',1,'5','support_start_date','Support Start Date',1,0,0,100,2,6,1,'D~O',1,null,'ADV')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'support_end_date','ec_customerdetails',1,'5','support_end_date','Support End Date',1,0,0,100,3,6,1,'D~O~OTH~GE~support_start_date~Support Start Date',1,null,'ADV')");

		//Block6 - End Customer Portal

		//Block 7 -- Start

        $this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'mailingcountry','ec_contactaddress',1,'1','mailingcountry','Mailing Country',1,0,0,100,1,7,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'othercountry','ec_contactaddress',1,'1','othercountry','Other Country',1,0,0,100,2,7,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'mailingstate','ec_contactaddress',1,'1','mailingstate','Mailing State',1,0,0,100,3,7,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'otherstate','ec_contactaddress',1,'1','otherstate','Other State',1,0,0,100,4,7,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'mailingcity','ec_contactaddress',1,'1','mailingcity','Mailing City',1,0,0,100,5,7,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'othercity','ec_contactaddress',1,'1','othercity','Other City',1,0,0,100,6,7,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'mailingstreet','ec_contactaddress',1,'21','mailingstreet','Mailing Street',1,0,0,100,7,7,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'otherstreet','ec_contactaddress',1,'21','otherstreet','Other Street',1,0,0,100,8,7,1,'V~O',1,null,'BAS')");
		
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'mailingpobox','ec_contactaddress',1,'1','mailingpobox','Mailing Po Box',1,0,0,100,9,7,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'otherpobox','ec_contactaddress',1,'1','otherpobox','Other Po Box',1,0,0,100,10,7,1,'V~O',1,null,'BAS')");
		
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'mailingzip','ec_contactaddress',1,'1','mailingzip','Mailing Zip',1,0,0,100,11,7,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'otherzip','ec_contactaddress',1,'1','otherzip','Other Zip',1,0,0,100,12,7,1,'V~O',1,null,'BAS')");
		
		
		//Block7 -- End

		//ContactImageInformation
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'imagename','ec_contactdetails',1,'69','imagename','Contact Image',1,0,0,100,1,75,1,'V~O',1,null,'ADV')");


		//Block8 -- Start
		$this->db->query("insert into ec_field values (4,".$this->db->getUniqueID("ec_field").",'description','ec_crmentity',1,'19','description','Description',1,0,0,100,1,8,1,'V~O',1,null,'BAS')");
		//Block8 -- End
		//Contact Details -- END


		//Potential Details -- START
		//Block1 -- Start

		$this->db->query("insert into ec_field values (2,".$this->db->getUniqueID("ec_field").",'potentialname','ec_potential',1,'2','potentialname','Potential Name',1,0,0,100,1,1,1,'V~M',0,1,'BAS')");	
		$this->db->query("insert into ec_field values (2,".$this->db->getUniqueID("ec_field").",'amount','ec_potential',1,71,'amount','Amount',1,0,0,100,2,1,1,'N~M',0,5,'BAS')");	
		$this->db->query("insert into ec_field values (2,".$this->db->getUniqueID("ec_field").",'accountid','ec_potential',1,'50','account_id','Account Name',1,0,0,100,3,1,1,'V~M',0,2,'BAS')");	
		$this->db->query("insert into ec_field values (2,".$this->db->getUniqueID("ec_field").",'contact_id','ec_potential',1,'57','contact_id','Contact Name',1,0,0,100,4,1,1,'V~O',0,1,'BAS')");
		$this->db->query("insert into ec_field values (2,".$this->db->getUniqueID("ec_field").",'closingdate','ec_potential',1,'23','closingdate','Expected Close Date',1,0,0,100,5,1,1,'D~M',0,3,'BAS')");	
		$this->db->query("insert into ec_field values (2,".$this->db->getUniqueID("ec_field").",'potentialtype','ec_potential',1,'15','opportunity_type','Type',1,0,0,100,6,1,1,'V~O',1,null,'BAS')");	
		$this->db->query("insert into ec_field values (2,".$this->db->getUniqueID("ec_field").",'nextstep','ec_potential',1,'1','nextstep','Next Step',1,0,0,100,7,1,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (2,".$this->db->getUniqueID("ec_field").",'leadsource','ec_potential',1,'15','leadsource','Lead Source',1,0,0,100,8,1,1,'V~O',1,null,'BAS')");	
		$this->db->query("insert into ec_field values (2,".$this->db->getUniqueID("ec_field").",'sales_stage','ec_potential',1,'16','sales_stage','Sales Stage',1,0,0,100,9,1,1,'V~O',0,4,'BAS')");
		$this->db->query("insert into ec_field values (2,".$this->db->getUniqueID("ec_field").",'smownerid','ec_crmentity',1,'53','assigned_user_id','Assigned To',1,0,0,100,10,1,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (2,".$this->db->getUniqueID("ec_field").",'probability','ec_potential',1,'15','probability','Probability',1,0,0,100,11,1,1,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (2,".$this->db->getUniqueID("ec_field").",'probableamount','ec_potential',1,'71','probableamount','probableamount',1,0,0,100,12,1,2,'N~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (2,".$this->db->getUniqueID("ec_field").",'campaignid','ec_potential',1,'58','campaignid','Campaign Source',1,0,0,100,13,1,1,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (2,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,14,1,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (2,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,15,1,2,'T~O',1,null,'BAS')");

		//Block1 -- End

		//Block3 -- Start

		$this->db->query("insert into ec_field values (2,".$this->db->getUniqueID("ec_field").",'description','ec_crmentity',1,'19','description','Description',1,0,0,100,1,3,1,'V~O',1,null,'BAS')");

		//Block3 -- End
		//Potential Details -- END


		//campaign entries being added


		$this->db->query("insert into ec_field values (26,".$this->db->getUniqueID("ec_field").",'campaignname','ec_campaign',1,'2','campaignname','Campaign Name',1,0,0,100,1,76,1,'V~M',0,1,'BAS')");
		$this->db->query("insert into ec_field values (26,".$this->db->getUniqueID("ec_field").",'campaigntype','ec_campaign',1,15,'campaigntype','Campaign Type',1,0,0,100,5,76,1,'V~O',0,3,'BAS')");
		$this->db->query("insert into ec_field values (26,".$this->db->getUniqueID("ec_field").",'product_id','ec_campaign',1,59,'product_id','Product',1,0,0,100,4,76,1,'I~O',0,5,'BAS')");
		$this->db->query("insert into ec_field values (26,".$this->db->getUniqueID("ec_field").",'campaignstatus','ec_campaign',1,15,'campaignstatus','Campaign Status',1,0,0,100,2,76,1,'V~O',0,6,'BAS')");
		$this->db->query("insert into ec_field values (26,".$this->db->getUniqueID("ec_field").",'closingdate','ec_campaign',1,'23','closingdate','Expected Close Date',1,0,0,100,6,76,1,'D~M',0,2,'BAS')");
		$this->db->query("insert into ec_field values (26,".$this->db->getUniqueID("ec_field").",'smownerid','ec_crmentity',1,'53','assigned_user_id','Assigned To',1,0,0,100,3,76,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (26,".$this->db->getUniqueID("ec_field").",'numsent','ec_campaign',1,'9','numsent','Num Sent',1,0,0,100,10,76,1,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (26,".$this->db->getUniqueID("ec_field").",'sponsor','ec_campaign',1,'1','sponsor','Sponsor',1,0,0,100,9,76,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (26,".$this->db->getUniqueID("ec_field").",'targetaudience','ec_campaign',1,'1','targetaudience','Target Audience',1,0,0,100,7,76,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values(26,".$this->db->getUniqueID("ec_field").",'targetsize','ec_campaign',1,'1','targetsize','TargetSize',1,0,0,100,8,76,1,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (26,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,11,76,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (26,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,12,76,2,'T~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (26,".$this->db->getUniqueID("ec_field").",'expectedresponse','ec_campaign',1,'15','expectedresponse','Expected Response',1,0,0,100,3,78,1,'V~O',0,4,'BAS')");
		$this->db->query("insert into ec_field values (26,".$this->db->getUniqueID("ec_field").",'expectedrevenue','ec_campaign',1,'1','expectedrevenue','Expected Revenue',1,0,0,100,4,78,1,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (26,".$this->db->getUniqueID("ec_field").",'budgetcost','ec_campaign',1,'1','budgetcost','Budget Cost',1,0,0,100,1,78,1,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (26,".$this->db->getUniqueID("ec_field").",'actualcost','ec_campaign',1,'1','actualcost','Actual Cost',1,0,0,100,2,78,1,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values(26,".$this->db->getUniqueID("ec_field").",'expectedresponsecount','ec_campaign',1,'1','expectedresponsecount','Expected Response Count',1,0,0,100,7,78,1,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values(26,".$this->db->getUniqueID("ec_field").",'expectedsalescount','ec_campaign',1,'1','expectedsalescount','Expected Sales Count',1,0,0,100,5,78,1,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values(26,".$this->db->getUniqueID("ec_field").",'expectedroi','ec_campaign',1,'1','expectedroi','Expected ROI',1,0,0,100,9,78,1,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values(26,".$this->db->getUniqueID("ec_field").",'actualresponsecount','ec_campaign',1,'1','actualresponsecount','Actual Response Count',1,0,0,100,8,78,1,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values(26,".$this->db->getUniqueID("ec_field").",'actualsalescount','ec_campaign',1,'1','actualsalescount','Actual Sales Count',1,0,0,100,6,78,1,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values(26,".$this->db->getUniqueID("ec_field").",'actualroi','ec_campaign',1,'1','actualroi','Actual ROI',1,0,0,100,10,78,1,'N~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (26,".$this->db->getUniqueID("ec_field").",'description','ec_crmentity',1,'19','description','Description',1,0,0,100,1,82,1,'V~O',1,null,'BAS')");
		//Campaign entries end


		//Ticket Details -- START
		//Block25 -- Start

		$this->db->query("insert into ec_field values (13,".$this->db->getUniqueID("ec_field").",'smownerid','ec_crmentity',1,'53','assigned_user_id','Assigned To',1,0,0,100,2,25,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (13,".$this->db->getUniqueID("ec_field").",'parent_id','ec_troubletickets',1,'68','parent_id','Related To',1,0,0,100,4,25,1,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (13,".$this->db->getUniqueID("ec_field").",'priority','ec_troubletickets',1,'15','ticketpriorities','Priority',1,0,0,100,5,25,1,'V~O',0,4,'BAS')");
		$this->db->query("insert into ec_field values (13,".$this->db->getUniqueID("ec_field").",'product_id','ec_troubletickets',1,'59','product_id','Product Name',1,0,0,100,6,25,1,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (13,".$this->db->getUniqueID("ec_field").",'severity','ec_troubletickets',1,'15','ticketseverities','Severity',1,0,0,100,7,25,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (13,".$this->db->getUniqueID("ec_field").",'status','ec_troubletickets',1,'111','ticketstatus','Status',1,0,0,100,8,25,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (13,".$this->db->getUniqueID("ec_field").",'category','ec_troubletickets',1,'15','ticketcategories','Category',1,0,0,100,9,25,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (13,".$this->db->getUniqueID("ec_field").",'update_log','ec_troubletickets',1,'15','update_log','Update History',1,0,0,100,9,25,3,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (13,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,10,25,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (13,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,11,25,2,'T~O',1,null,'BAS')");
		//Added on 26-12-2005 to add attachment in ticket editview
		$this->db->query("insert into ec_field values (13,".$this->db->getUniqueID("ec_field").",'filename','ec_attachments',1,'61','filename','Attachment',1,0,0,100,12,25,1,'V~O',0,3,'BAS')");

		$this->db->query("insert into ec_field values (13,".$this->db->getUniqueID("ec_field").",'title','ec_troubletickets',1,'22','ticket_title','Title',1,0,0,100,1,26,1,'V~M',0,1,'BAS')");
		$this->db->query("insert into ec_field values (13,".$this->db->getUniqueID("ec_field").",'description','ec_troubletickets',1,'19','description','Description',1,0,0,100,1,28,1,'V~O',0,2,'BAS')");
		$this->db->query("insert into ec_field values (13,".$this->db->getUniqueID("ec_field").",'solution','ec_troubletickets',1,'19','solution','Solution',1,0,0,100,1,29,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (13,".$this->db->getUniqueID("ec_field").",'comments','ec_ticketcomments',1,'19','comments','Add Comment',1,0,0,100,1,30,1,'V~O',1,null,'BAS')");

		//Block25-30 -- End
		//Ticket Details -- END

		//Product Details -- START
		//Block31-36 -- Start

		$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'productname','ec_products',1,'2','productname','Product Name',1,0,0,100,1,31,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'productcode','ec_products',1,'1','productcode','Product Code',1,0,0,100,2,31,1,'V~M',1,null,'BAS')");
		
		$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'catalogid','ec_products',1,'1006','catalogid','Product Category',1,0,0,100,3,31,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'serialno','ec_products',1,'1','serial_no','Serial No',1,0,0,100,4,31,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'usageunit','ec_products',1,'15','usageunit','Usage Unit',1,0,0,100,5,31,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'reorderlevel','ec_products',1,'1','reorderlevel','Reorder Level',1,0,0,100,6,31,1,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'vendor_id','ec_products',1,'75','vendor_id','Vendor Name',1,0,0,100,7,31,1,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'website','ec_products',1,'17','website','Website',1,0,0,100,8,31,1,'V~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'productsheet','ec_products',1,'1','productsheet','Product Sheet',1,0,0,100,9,31,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'weight','ec_products',1,'1','weight','weight',1,0,0,100,9,31,1,'N~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'qtyinstock','ec_products',1,'1','qtyinstock','Qty In Stock',1,0,0,100,10,31,2,'I~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,11,31,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,12,31,2,'T~O',1,null,'BAS')");

        //$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'discontinued','ec_products',1,'56','discontinued','Product Active',1,0,0,100,3,31,1,'V~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'sales_start_date','ec_products',1,'5','sales_start_date','Sales Start Date',1,0,0,100,5,31,1,'D~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'sales_end_date','ec_products',1,'5','sales_end_date','Sales End Date',1,0,0,100,6,31,1,'D~O~OTH~GE~sales_start_date~Sales Start Date',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'start_date','ec_products',1,'5','start_date','Support Start Date',1,0,0,100,7,31,1,'D~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'expiry_date','ec_products',1,'5','expiry_date','Support Expiry Date',1,0,0,100,8,31,1,'D~O~OTH~GE~start_date~Start Date',1,null,'BAS')");

		//deleted by dingjianting on 2007-1-11 for gloso project
		//account has product subpanel,campaign subpanel
		//$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'crmid','ec_seproductsrel',1,'66','parent_id','Related To',1,0,0,100,10,31,1,'I~O',1,null,'BAS')");

		//$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'contactid','ec_products',1,'57','contact_id','Contact Name',1,0,0,100,11,31,1,'I~O',1,null,'BAS')");

		//$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'manufacturer','ec_products',1,'15','manufacturer','Manufacturer',1,0,0,100,12,31,1,'V~O',1,null,'BAS')");
		
		//$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'mfr_part_no','ec_products',1,'1','mfr_part_no','Mfr PartNo',1,0,0,100,14,31,1,'V~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'vendor_part_no','ec_products',1,'1','vendor_part_no','Vendor PartNo',1,0,0,100,15,31,1,'V~O',1,null,'BAS')");
		
		
		
		//$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'glacct','ec_products',1,'15','glacct','GL Account',1,0,0,100,19,31,1,'V~O',1,null,'BAS')");
		


		//Block32 Pricing Information

		$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'unit_price','ec_products',1,'71','unit_price','Unit Price',1,0,0,100,1,32,1,'N~O',1,null,'BAS')"); 
		//$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'commissionrate','ec_products',1,'9','commissionrate','Commission Rate',1,0,0,100,2,32,1,'N~O',1,null,'BAS')"); 
		//$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'taxclass','ec_producttaxrel',1,'83','taxclass','Tax Class',1,0,0,100,4,32,1,'V~O',1,null,'BAS')");


		//Block 33 stock info

		
		//$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'qty_per_unit','ec_products',1,'1','qty_per_unit','Qty/Unit',1,0,0,100,2,33,1,'N~O',1,null,'ADV')");
		
		
		//$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'handler','ec_products',1,'52','assigned_user_id','Handler',1,0,0,100,5,33,1,'I~O',1,null,'ADV')");
		//$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'qtyindemand','ec_products',1,'1','qtyindemand','Qty In Demand',1,0,0,100,6,33,1,'I~O',1,null,'ADV')");


		//ProductImageInformation

		$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'imagename','ec_products',1,'69','imagename','Product Image',1,0,0,100,1,35,1,'V~O',1,null,'ADV')");


		//Block 36 Description Info
		$this->db->query("insert into ec_field values (14,".$this->db->getUniqueID("ec_field").",'product_description','ec_products',1,'19','product_description','Description',1,0,0,100,1,36,1,'V~O',1,null,'BAS')");

		//Product Details -- END

		//Note Details -- START
		//Block17 -- Start
		//changed by dingjianting on 2007-1-7 for gloso project
		$this->db->query("insert into ec_field values (8,".$this->db->getUniqueID("ec_field").",'accountid','ec_notes',1,'51','account_id','Account Name',1,0,0,100,1,17,1,'V~M',0,1,'BAS')");
		$this->db->query("insert into ec_field values (8,".$this->db->getUniqueID("ec_field").",'contact_id','ec_notes',1,'57','contact_id','Contact Name',1,0,0,100,2,17,1,'V~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (8,".$this->db->getUniqueID("ec_field").",'crmid','ec_senotesrel',1,'62','parent_id','Related To',1,0,0,100,2,17,1,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (8,".$this->db->getUniqueID("ec_field").",'title','ec_notes',1,'2','notes_title','Note Title',1,0,0,200,3,17,1,'V~M',0,1,'BAS')");
		$this->db->query("insert into ec_field values (8,".$this->db->getUniqueID("ec_field").",'notetype','ec_notes',1,'15','notetype','Note Type',1,0,0,100,4,17,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (8,".$this->db->getUniqueID("ec_field").",'contact_date','ec_notes',1,'5','contact_date','Contact Date',1,0,0,100,5,17,1,'D~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (8,".$this->db->getUniqueID("ec_field").",'smownerid','ec_crmentity',1,'53','assigned_user_id','Assigned To',1,0,0,100,6,17,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (8,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,7,17,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (8,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,8,17,2,'T~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (8,".$this->db->getUniqueID("ec_field").",'address','ec_notes',1,'2','address','Address',1,0,0,100,7,17,1,'V~M',0,1,'BAS')");
		//$this->db->query("insert into ec_field values (8,".$this->db->getUniqueID("ec_field").",'filename','ec_notes',1,'61','filename','File',1,0,0,100,10,17,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (8,".$this->db->getUniqueID("ec_field").",'potentialid','ec_notes',1,'76','potential_id','Potential Name',1,0,0,100,9,17,1,'I~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (8,".$this->db->getUniqueID("ec_field").",'projectsid','ec_notes',1,'1012','projectsid','project',1,0,0,100,21,17,1,'V~O',0,1,'BAS')");



		//will add smownerid later by dingjianting on 2006-12-27 for gloso
		$this->db->query("insert into ec_field values (8,".$this->db->getUniqueID("ec_field").",'notecontent','ec_notes',1,'19','notecontent','Note',1,0,0,100,10,18,1,'V~O',1,null,'BAS')");


		//Block17 -- End
		//Note Details -- END

		//Email Details -- START
		//Block21 -- Start

		$this->db->query("insert into ec_field values (10,".$this->db->getUniqueID("ec_field").",'date_start','ec_activity',1,'6','date_start','Date & Time Sent',1,0,0,100,1,21,1,'DT~M~time_start~Time Start',1,null,'BAS')");
		$this->db->query("insert into ec_field values (10,".$this->db->getUniqueID("ec_field").",'semodule','ec_activity',1,'2','parent_type','Sales Enity Module',1,0,0,100,2,21,3,'',1,null,'BAS')");
		$this->db->query("insert into ec_field values (10,".$this->db->getUniqueID("ec_field").",'activitytype','ec_activity',1,'2','activitytype','Activtiy Type',1,0,0,100,3,21,3,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (10,".$this->db->getUniqueID("ec_field").",'crmid','ec_seactivityrel',1,'357','parent_id','Related To',1,0,0,100,1,22,1,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (10,".$this->db->getUniqueID("ec_field").",'smownerid','ec_crmentity',1,'53','assigned_user_id','Assigned To',1,0,0,100,5,21,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (10,".$this->db->getUniqueID("ec_field").",'subject','ec_activity',1,'2','subject','Subject',1,0,0,100,1,23,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (10,".$this->db->getUniqueID("ec_field").",'status','ec_activity',1,'2','status','Status',1,0,0,100,1,23,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (10,".$this->db->getUniqueID("ec_field").",'filename','ec_attachments',1,'61','filename','Attachment',1,0,0,100,2,23,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (10,".$this->db->getUniqueID("ec_field").",'description','ec_crmentity',1,'19','description','Description',1,0,0,100,1,24,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (10,".$this->db->getUniqueID("ec_field").",'time_start','ec_activity',1,'2','time_start','Time Start',1,0,0,100,9,23,1,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (10,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,10,22,1,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (10,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,11,21,2,'T~O',1,null,'BAS')");

		//Block21 -- End
		//Email Details -- END

		//Task Details --START
		//Block19 -- Start
		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'subject','ec_activity',1,'2','subject','Subject',1,0,0,100,1,19,1,'V~M',0,1,'BAS')");
		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'smownerid','ec_crmentity',1,'53','assigned_user_id','Assigned To',1,0,0,100,2,19,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'date_start','ec_activity',1,'6','date_start','Start Date & Time',1,0,0,100,3,19,1,'DT~M~time_start',0,2,'BAS')");
		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'time_start','ec_activity',1,'2','time_start','Time Start',1,0,0,100,4,19,3,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'time_end','ec_activity',1,'2','time_end','End Time',1,0,0,100,4,19,3,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'due_date','ec_activity',1,'23','due_date','Due Date',1,0,0,100,5,19,1,'D~M~OTH~GE~date_start~Start Date & Time',1,null,'BAS')");
		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'crmid','ec_seactivityrel',1,'66','parent_id','Related To',1,0,0,100,7,19,1,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'contactid','ec_cntactivityrel',1,'57','contact_id','Contact Name',1,0,0,100,8,19,1,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'status','ec_activity',1,'111','taskstatus','Status',1,0,0,100,9,19,1,'V~O',0,3,'BAS')");
		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'eventstatus','ec_activity',1,'111','eventstatus','Status',1,0,0,100,9,19,3,'V~O',1,null,'BAS')");
		//added by dingjianting on 2006-11-25 for simplized chinese
		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'eventtype','ec_activity',1,'111','eventtype','Event Type',1,0,0,100,12,19,3,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'priority','ec_activity',1,'15','taskpriority','Priority',1,0,0,100,10,19,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'sendnotification','ec_activity',1,'56','sendnotification','Send Notification',1,0,0,100,11,19,1,'C~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,14,19,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,15,19,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'activitytype','ec_activity',1,'15','activitytype','Activity Type',1,0,0,100,16,19,3,'V~O',1,null,'BAS')");
		$this->db->query("Insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'visibility','ec_activity',1,15,'visibility','Visibility',1,0,0,100,17,19,3,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'description','ec_crmentity',1,'19','description','Description',1,0,0,100,1,20,1,'V~O',1,null,'BAS')");


		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'duration_hours','ec_activity',1,'63','duration_hours','Duration',1,0,0,100,17,19,3,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'duration_minutes','ec_activity',1,'15','duration_minutes','Duration Minutes',1,0,0,100,18,19,3,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'location','ec_activity',1,'1','location','Location',1,0,0,100,19,19,3,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'reminder_time','ec_activity_reminder',1,'30','reminder_time','Send Reminder',1,0,0,100,1,19,3,'I~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'recurringtype','ec_recurringevents',1,'15','recurringtype','Recurrence',1,0,0,100,6,19,3,'O~O',1,null,'BAS')");

		$this->db->query("Insert into ec_field values (9,".$this->db->getUniqueID("ec_field").",'notime','ec_activity',1,56,'notime','No Time',1,0,0,100,20,19,3,'C~O',1,null,'BAS')");
		//Block19 -- End
		//Task Details -- END

		//Event Details --START
		//Block41-43-- Start
		$this->db->query("insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'subject','ec_activity',1,'2','subject','Subject',1,0,0,100,1,41,1,'V~M',0,1,'BAS')");
		$this->db->query("insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'smownerid','ec_crmentity',1,'53','assigned_user_id','Assigned To',1,0,0,100,2,41,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'date_start','ec_activity',1,'6','date_start','Start Date & Time',1,0,0,100,3,41,1,'DT~M~time_start',0,2,'BAS')");
		$this->db->query("insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'time_start','ec_activity',1,'2','time_start','Time Start',1,0,0,100,4,41,3,'T~M',1,null,'BAS')");

		$this->db->query("insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'due_date','ec_activity',1,'23','due_date','End Date',1,0,0,100,5,41,1,'D~M~OTH~GE~date_start~Start Date & Time',0,5,'BAS')");
		$this->db->query("insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'time_end','ec_activity',1,'2','time_end','End Time',1,0,0,100,5,41,3,'T~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'recurringtype','ec_recurringevents',1,'15','recurringtype','Recurrence',1,0,0,100,6,41,1,'O~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'duration_hours','ec_activity',1,'63','duration_hours','Duration',1,0,0,100,7,41,1,'I~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'duration_minutes','ec_activity',1,'15','duration_minutes','Duration Minutes',1,0,0,100,8,41,3,'O~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'crmid','ec_seactivityrel',1,'66','parent_id','Related To',1,0,0,100,9,41,1,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'eventstatus','ec_activity',1,'111','eventstatus','Status',1,0,0,100,10,41,1,'V~O',0,3,'BAS')");
		$this->db->query("insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'sendnotification','ec_activity',1,'56','sendnotification','Send Notification',1,0,0,100,11,41,1,'C~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'activitytype','ec_activity',1,'15','activitytype','Activity Type',1,0,0,100,12,41,1,'V~O',0,4,'BAS')");
		$this->db->query("insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'calendartype','ec_activity',1,'15','calendartype','CalendarType',1,0,0,100,20,41,1,'V~O',0,4,'BAS')");
		$this->db->query("insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'location','ec_activity',1,'1','location','Location',1,0,0,100,13,41,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,14,41,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,15,41,2,'T~O',1,null,'BAS')");
		$this->db->query("Insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'priority','ec_activity',1,15,'taskpriority','Priority',1,0,0,100,16,41,1,'V~O',1,null,'BAS')");
		$this->db->query("Insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'notime','ec_activity',1,56,'notime','No Time',1,0,0,100,17,41,1,'C~O',1,null,'BAS')");
		$this->db->query("Insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'visibility','ec_activity',1,15,'visibility','Visibility',1,0,0,100,18,41,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'description','ec_crmentity',1,'19','description','Description',1,0,0,100,1,43,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (16,".$this->db->getUniqueID("ec_field").",'reminder_time','ec_activity_reminder',1,'30','reminder_time','Send Reminder',1,0,0,100,1,42,1,'I~O',1,null,'BAS')");
		//Block41-43 -- End
		//Event Details -- END

		//Faq Details -- START
		//Block37-40 -- Start

		$this->db->query("insert into ec_field values (15,".$this->db->getUniqueID("ec_field").",'product_id','ec_faq',1,'59','product_id','Product Name',1,0,0,100,1,37,1,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (15,".$this->db->getUniqueID("ec_field").",'faqcategoryid','ec_faq',1,'1013','faqcategoryid','Category',1,0,0,100,2,37,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (15,".$this->db->getUniqueID("ec_field").",'status','ec_faq',1,'111','faqstatus','Status',1,0,0,100,3,37,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (15,".$this->db->getUniqueID("ec_field").",'keywords','ec_faq',1,'1','keywords','keywords',1,0,0,100,5,37,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (15,".$this->db->getUniqueID("ec_field").",'faqno','ec_faq',1,'1','faqno','faqno',1,0,0,100,6,37,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (15,".$this->db->getUniqueID("ec_field").",'readtimes','ec_faq',1,'1','readtimes','readtimes',1,0,0,100,7,37,2,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (15,".$this->db->getUniqueID("ec_field").",'question','ec_faq',1,'20','question','Question',1,0,0,100,1,38,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (15,".$this->db->getUniqueID("ec_field").",'answer','ec_faq',1,'20','faq_answer','Answer',1,0,0,100,1,39,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (15,".$this->db->getUniqueID("ec_field").",'comments','ec_faqcomments',1,'19','comments','Add Comment',1,0,0,100,1,40,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (15,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,3,37,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (15,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,4,37,2,'T~O',1,null,'BAS')");


		//Block37-40 -- End
		//Ticket Details -- END

		//Vendor Details --START
		//Block44-47

		$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'vendorname','ec_vendor',1,'2','vendorname','Vendor Name',1,0,0,100,1,44,1,'V~M',0,1,'BAS')");
		$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'category','ec_vendor',1,'1','category','Category',1,0,0,100,2,44,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'phone','ec_vendor',1,'1','phone','Phone',1,0,0,100,3,44,1,'V~O',0,2,'BAS')");
		$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'fax','ec_vendor',1,'1','fax','Fax',1,0,0,100,4,44,1,'V~O',0,2,'BAS')");
		$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'email','ec_vendor',1,'13','email','Email',1,0,0,100,5,44,1,'E~O',0,3,'BAS')");
		$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'website','ec_vendor',1,'17','website','Website',1,0,0,100,6,44,1,'V~O',1,null,'BAS')");
		
		$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'employees','ec_vendor',1,'15','employees','Employees',1,0,0,100,7,44,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'grade','ec_vendor',1,'15','grade','Grade',1,0,0,100,8,44,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'rating','ec_vendor',1,'15','rating','Rating',1,0,0,100,9,44,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'industry','ec_vendor',1,'15','industry','industry',1,0,0,100,10,44,1,'V~O',1,null,'BAS')");
        $this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'ownership','ec_vendor',1,'15','ownership','Ownership',1,0,0,100,11,44,1,'V~O',1,null,'BAS')");
    	$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'annualrevenue','ec_vendor',1,'15','annualrevenue','Annual Revenue',1,0,0,100,12,44,1,'V~O',1,null,'BAS')");


		//$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'glacct','ec_vendor',1,'15','glacct','GL Account',1,0,0,100,12,44,1,'V~O',1,null,'BAS')");
		
		$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,14,44,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,15,44,2,'T~O',1,null,'BAS')");

		//Block 46

        $this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'country','ec_vendor',1,'1','country','Country',1,0,0,100,1,46,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'state','ec_vendor',1,'1','state','State',1,0,0,100,2,46,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'city','ec_vendor',1,'1','city','City',1,0,0,100,3,46,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'street','ec_vendor',1,'21','street','Street',1,0,0,100,4,46,1,'V~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'pobox','ec_vendor',1,'1','pobox','Po Box',1,0,0,100,5,46,1,'V~O',1,null,'BAS')");		
		$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'postalcode','ec_vendor',1,'1','postalcode','Postal Code',1,0,0,100,6,46,1,'V~O',1,null,'BAS')");
		

		//Block 47

		$this->db->query("insert into ec_field values (18,".$this->db->getUniqueID("ec_field").",'description','ec_crmentity',1,'19','description','Description',1,0,0,100,1,47,1,'V~O',1,null,'BAS')");

		//Vendor Details -- END

		//PriceBook Details Start
		//Block48

		$this->db->query("insert into ec_field values (19,".$this->db->getUniqueID("ec_field").",'bookname','ec_pricebook',1,'2','bookname','Price Book Name',1,0,0,100,1,48,1,'V~M',0,1,'BAS')");
		//add booknum for gloso project
		$this->db->query("insert into ec_field values (19,".$this->db->getUniqueID("ec_field").",'booknum','ec_pricebook',1,'1','booknum','Price Book Number',1,0,0,100,2,48,1,'V~M',0,1,'BAS')");
		//$this->db->query("insert into ec_field values (19,".$this->db->getUniqueID("ec_field").",'active','ec_pricebook',1,'56','active','Active',1,0,0,100,3,48,1,'V~O',0,2,'BAS')");
		$this->db->query("insert into ec_field values (19,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,4,48,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (19,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,5,48,2,'T~O',1,null,'BAS')");

		//Block50

		$this->db->query("insert into ec_field values (19,".$this->db->getUniqueID("ec_field").",'description','ec_crmentity',1,'19','description','Description',1,0,0,100,1,50,1,'V~O',1,null,'BAS')");

		//PriceBook Details End


		//Quote Details -- START
		//Block51

		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'subject','ec_quotes',1,'2','subject','Subject',1,0,0,100,1,51,1,'V~M',1,null,'BAS')");	
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'potentialid','ec_quotes',1,'76','potential_id','Potential Name',1,0,0,100,2,51,1,'I~O',1,null,'BAS')");	
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'quotestage','ec_quotes',1,'111','quotestage','Quote Stage',1,0,0,100,3,51,1,'V~O',1,null,'BAS')");	

		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'validtill','ec_quotes',1,'5','validtill','Valid Till',1,0,0,100,4,51,1,'D~O',1,null,'BAS')");	
		//$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'team','ec_quotes',1,'1','team','Team',1,0,0,100,5,51,1,'V~O',1,null,'BAS')");	
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'accountid','ec_quotes',1,'73','account_id','Account Name',1,0,0,100,5,51,1,'I~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'contactid','ec_quotes',1,'57','contact_id','Contact Name',1,0,0,100,6,51,1,'V~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'carrier','ec_quotes',1,'15','carrier','Carrier',1,0,0,100,8,51,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'subtotal','ec_quotes',1,'1','hdnSubTotal','Sub Total',1,0,0,100,9,51,3,'N~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'shipping','ec_quotes',1,'1','shipping','Shipping',1,0,0,100,10,51,1,'V~O',1,null,'BAS')");
		//changed by dingjianting on 2007-1-11 only for gloso project
		//need not send email notification to inventory manager
		//$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'inventorymanager','ec_quotes',1,'77','assigned_user_id1','Inventory Manager',1,0,0,100,11,51,1,'I~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'tax','ec_quotes',1,'1','txtTax','Tax',1,0,0,100,13,51,3,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'adjustment','ec_quotes',1,'1','txtAdjustment','Adjustment',1,0,0,100,20,51,3,'NN~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'total','ec_quotes',1,'1','hdnGrandTotal','Total',1,0,0,100,14,51,3,'N~O',1,null,'BAS')");
		//Added fields taxtype, discount percent, discount amount and S&H amount for Tax process
		//$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'taxtype','ec_quotes',1,'15','hdnTaxType','Tax Type',1,0,0,100,14,51,3,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'discount_percent','ec_quotes',1,'1','hdnDiscountPercent','Discount Percent',1,0,0,100,14,51,3,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'discount_amount','ec_quotes',1,'1','hdnDiscountAmount','Discount Amount',1,0,0,100,14,51,3,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'s_h_amount','ec_quotes',1,'1','hdnS_H_Amount','S&H Amount',1,0,0,100,14,51,3,'N~O',1,null,'BAS')");

		
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'smownerid','ec_crmentity',1,'53','assigned_user_id','Assigned To',1,0,0,100,17,51,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,18,51,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,19,51,2,'T~O',1,null,'BAS')");
		//add field currency for Gloso project by dingjianting on 2006-12-28
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'currency','ec_quotes',1,'15','currency','Currency',1,0,0,100,20,51,1,'V~O',1,null,'BAS')");	
		//$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'projectsid','ec_quotes',1,'1012','projectsid','project',1,0,0,100,21,51,1,'V~O',0,1,'BAS')");


		//Block 53
		/*
        $this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'bill_country','ec_quotesbillads',1,'1','bill_country','Billing Country',1,0,0,100,1,53,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'ship_country','ec_quotesshipads',1,'1','ship_country','Shipping Country',1,0,0,100,2,53,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'bill_state','ec_quotesbillads',1,'1','bill_state','Billing State',1,0,0,100,3,53,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'ship_state','ec_quotesshipads',1,'1','ship_state','Shipping State',1,0,0,100,4,53,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'bill_city','ec_quotesbillads',1,'1','bill_city','Billing City',1,0,0,100,5,53,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'ship_city','ec_quotesshipads',1,'1','ship_city','Shipping City',1,0,0,100,6,53,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'bill_street','ec_quotesbillads',1,'24','bill_street','Billing Address',1,0,0,100,7,53,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'ship_street','ec_quotesshipads',1,'24','ship_street','Shipping Address',1,0,0,100,8,53,1,'V~M',1,null,'BAS')");

		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'bill_pobox','ec_quotesbillads',1,'1','bill_pobox','Billing Po Box',1,0,0,100,9,53,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'ship_pobox','ec_quotesshipads',1,'1','ship_pobox','Shipping Po Box',1,0,0,100,10,53,1,'V~O',1,null,'BAS')");		

		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'bill_code','ec_quotesbillads',1,'1','bill_code','Billing Code',1,0,0,100,11,53,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'ship_code','ec_quotesshipads',1,'1','ship_code','Shipping Code',1,0,0,100,12,53,1,'V~O',1,null,'BAS')");		
		*/
		//Block55

		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'description','ec_crmentity',1,'19','description','Description',1,0,0,100,1,56,1,'V~O',1,null,'BAS')");

		//Block 56
		$this->db->query("insert into ec_field values (20,".$this->db->getUniqueID("ec_field").",'terms_conditions','ec_quotes',1,'19','terms_conditions','Terms & Conditions',1,0,0,100,1,55,1,'V~O',1,null,'BAS')");


		//Quote Details -- END

		//Purchase Order Details -- START
		//Block57

		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'subject','ec_purchaseorder',1,'2','subject','Subject',1,0,0,100,1,57,1,'V~M',1,null,'BAS')");	
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'vendorid','ec_purchaseorder',1,'81','vendor_id','Vendor Name',1,0,0,100,3,57,1,'I~M',1,null,'BAS')");	
		//$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'requisition_no','ec_purchaseorder',1,'1','requisition_no','Requisition No',1,0,0,100,4,57,1,'V~O',1,null,'BAS')");	

		//$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'tracking_no','ec_purchaseorder',1,'1','tracking_no','Tracking Number',1,0,0,100,5,57,1,'V~O',1,null,'BAS')");	
		//$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'contactid','ec_purchaseorder',1,'57','contact_id','Contact Name',1,0,0,100,6,57,1,'I~O',1,null,'BAS')");	
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'duedate','ec_purchaseorder',1,'5','duedate','Due Date',1,0,0,100,7,57,1,'V~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'carrier','ec_purchaseorder',1,'15','carrier','Carrier',1,0,0,100,8,57,1,'V~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'salestax','ec_purchaseorder',1,'1','txtTax','Sales Tax',1,0,0,100,10,57,3,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'adjustment','ec_purchaseorder',1,'1','txtAdjustment','Adjustment',1,0,0,100,10,57,3,'NN~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'salescommission','ec_purchaseorder',1,'1','salescommission','Sales Commission',1,0,0,100,11,57,1,'N~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'exciseduty','ec_purchaseorder',1,'1','exciseduty','Excise Duty',1,0,0,100,12,57,1,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'total','ec_purchaseorder',1,'1','hdnGrandTotal','Total',1,0,0,100,13,57,3,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'subtotal','ec_purchaseorder',1,'1','hdnSubTotal','Sub Total',1,0,0,100,14,57,3,'N~O',1,null,'BAS')");
		//Added fields taxtype, discount percent, discount amount and S&H amount for Tax process
		//$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'taxtype','ec_purchaseorder',1,'15','hdnTaxType','Tax Type',1,0,0,100,14,57,3,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'discount_percent','ec_purchaseorder',1,'1','hdnDiscountPercent','Discount Percent',1,0,0,100,14,57,3,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'discount_amount','ec_purchaseorder',1,'1','hdnDiscountAmount','Discount Amount',1,0,0,100,14,57,3,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'s_h_amount','ec_purchaseorder',1,'1','hdnS_H_Amount','S&H Amount',1,0,0,100,14,57,3,'N~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'postatus','ec_purchaseorder',1,'111','postatus','Status',1,0,0,100,15,57,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'smownerid','ec_crmentity',1,'53','assigned_user_id','Assigned To',1,0,0,100,16,57,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,17,57,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,18,57,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'currency','ec_purchaseorder',1,'15','currency','Currency',1,0,0,100,19,57,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'approved','ec_crmentity',1,'1007','approved','Approve Status',1,0,0,100,20,57,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'approvedby','ec_crmentity',1,'1008','approvedby','Approved By',1,0,0,100,21,57,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'salesorderid','ec_purchaseorder',1,'80','salesorder_id','Sales Orders',1,0,0,100,22,57,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'vcontactsid','ec_purchaseorder',1,'1009','vcontactsid','Contact Name',1,0,0,100,23,57,1,'V~O',0,1,'BAS')");
		//$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'projectsid','ec_purchaseorder',1,'1012','projectsid','project',1,0,0,100,23,69,1,'V~O',0,1,'BAS')");


		//Block 59
		/*
        $this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'bill_country','ec_pobillads',1,'1','bill_country','Billing Country',1,0,0,100,1,59,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'ship_country','ec_poshipads',1,'1','ship_country','Shipping Country',1,0,0,100,2,59,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'bill_state','ec_pobillads',1,'1','bill_state','Billing State',1,0,0,100,3,59,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'ship_state','ec_poshipads',1,'1','ship_state','Shipping State',1,0,0,100,4,59,1,'V~O',1,null,'BAS')");

        $this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'bill_city','ec_pobillads',1,'1','bill_city','Billing City',1,0,0,100,5,59,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'ship_city','ec_poshipads',1,'1','ship_city','Shipping City',1,0,0,100,6,59,1,'V~O',1,null,'BAS')");
		
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'bill_street','ec_pobillads',1,'24','bill_street','Billing Address',1,0,0,100,7,59,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'ship_street','ec_poshipads',1,'24','ship_street','Shipping Address',1,0,0,100,8,59,1,'V~M',1,null,'BAS')");

		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'bill_pobox','ec_pobillads',1,'1','bill_pobox','Billing Po Box',1,0,0,100,9,59,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'ship_pobox','ec_poshipads',1,'1','ship_pobox','Shipping Po Box',1,0,0,100,10,59,1,'V~O',1,null,'BAS')");		

		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'bill_code','ec_pobillads',1,'1','bill_code','Billing Code',1,0,0,100,11,59,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'ship_code','ec_poshipads',1,'1','ship_code','Shipping Code',1,0,0,100,12,59,1,'V~O',1,null,'BAS')");
		*/
		//Block61
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'description','ec_crmentity',1,'19','description','Description',1,0,0,100,1,62,1,'V~O',1,null,'BAS')");
		

		//Block62
		$this->db->query("insert into ec_field values (21,".$this->db->getUniqueID("ec_field").",'terms_conditions','ec_purchaseorder',1,'19','terms_conditions','Terms & Conditions',1,0,0,100,1,61,1,'V~O',1,null,'BAS')");

		//Purchase Order Details -- END

		//Sales Order Details -- START
		//Block63

		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'subject','ec_salesorder',1,'2','subject','Subject',1,0,0,100,1,63,1,'V~M',1,null,'BAS')");	
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'sostatus','ec_salesorder',1,'111','sostatus','Status',1,0,0,100,2,63,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'accountid','ec_salesorder',1,'73','account_id','Account Name',1,0,0,100,3,63,1,'I~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'contactid','ec_salesorder',1,'57','contact_id','Contact Name',1,0,0,100,4,63,1,'I~O',1,null,'BAS')");	
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'potentialid','ec_salesorder',1,'76','potential_id','Potential Name',1,0,0,100,5,63,1,'I~O',1,null,'BAS')");	
		//$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'customerno','ec_salesorder',1,'1','customerno','Customer No',1,0,0,100,3,63,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'quoteid','ec_salesorder',1,'78','quote_id','Quote Name',1,0,0,100,6,63,1,'I~O',1,null,'BAS')");	
		//$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'purchaseorder','ec_salesorder',1,'1','ec_purchaseorder','Purchase Order',1,0,0,100,4,63,1,'V~O',1,null,'BAS')");		
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'duedate','ec_salesorder',1,'5','duedate','Due Date',1,0,0,100,7,63,1,'D~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'carrier','ec_salesorder',1,'15','carrier','Carrier',1,0,0,100,8,63,1,'V~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'pending','ec_salesorder',1,'1','pending','Pending',1,0,0,100,10,63,1,'V~O',1,null,'BAS')");
		
		//$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'salestax','ec_salesorder',1,'1','txtTax','Sales Tax',1,0,0,100,9,63,3,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'adjustment','ec_salesorder',1,'1','txtAdjustment','Sales Tax',1,0,0,100,10,63,3,'NN~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'salescommission','ec_salesorder',1,'1','salescommission','Sales Commission',1,0,0,100,11,63,1,'N~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'exciseduty','ec_salesorder',1,'1','exciseduty','Excise Duty',1,0,0,100,12,63,1,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'total','ec_salesorder',1,'1','hdnGrandTotal','Total',1,0,0,100,13,63,3,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'subtotal','ec_salesorder',1,'1','hdnSubTotal','Sub Total',1,0,0,100,14,63,3,'N~O',1,null,'BAS')");
		//Added fields taxtype, discount percent, discount amount and S&H amount for Tax process
		//$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'taxtype','ec_salesorder',1,'15','hdnTaxType','Tax Type',1,0,0,100,15,63,3,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'discount_percent','ec_salesorder',1,'1','hdnDiscountPercent','Discount Percent',1,0,0,100,16,63,3,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'discount_amount','ec_salesorder',1,'1','hdnDiscountAmount','Discount Amount',1,0,0,100,17,63,3,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'s_h_amount','ec_salesorder',1,'1','hdnS_H_Amount','S&H Amount',1,0,0,100,18,63,3,'N~O',1,null,'BAS')");		
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'smownerid','ec_crmentity',1,'53','assigned_user_id','Assigned To',1,0,0,100,19,63,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,20,63,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,21,63,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'currency','ec_salesorder',1,'15','currency','Currency',1,0,0,100,22,63,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'approved','ec_crmentity',1,'1007','approved','Approve Status',1,0,0,100,23,63,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'approvedby','ec_crmentity',1,'1008','approvedby','Approved By',1,0,0,100,24,63,2,'T~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'projectsid','ec_salesorder',1,'1012','projectsid','project',1,0,0,100,25,63,1,'V~O',0,1,'BAS')");


		//Block 65
		/*

        $this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'bill_country','ec_sobillads',1,'1','bill_country','Billing Country',1,0,0,100,1,65,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'ship_country','ec_soshipads',1,'1','ship_country','Shipping Country',1,0,0,100,2,65,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'bill_state','ec_sobillads',1,'1','bill_state','Billing State',1,0,0,100,3,65,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'ship_state','ec_soshipads',1,'1','ship_state','Shipping State',1,0,0,100,4,65,1,'V~O',1,null,'BAS')");

        $this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'bill_city','ec_sobillads',1,'1','bill_city','Billing City',1,0,0,100,5,65,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'ship_city','ec_soshipads',1,'1','ship_city','Shipping City',1,0,0,100,6,65,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'bill_street','ec_sobillads',1,'24','bill_street','Billing Address',1,0,0,100,7,65,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'ship_street','ec_soshipads',1,'24','ship_street','Shipping Address',1,0,0,100,8,65,1,'V~M',1,null,'BAS')");

		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'bill_pobox','ec_sobillads',1,'1','bill_pobox','Billing Po Box',1,0,0,100,9,65,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'ship_pobox','ec_soshipads',1,'1','ship_pobox','Shipping Po Box',1,0,0,100,10,65,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'bill_code','ec_sobillads',1,'1','bill_code','Billing Code',1,0,0,100,11,65,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'ship_code','ec_soshipads',1,'1','ship_code','Shipping Code',1,0,0,100,12,65,1,'V~O',1,null,'BAS')");
		*/

		//Block67
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'description','ec_crmentity',1,'19','description','Description',1,0,0,100,1,68,1,'V~O',1,null,'BAS')");

		//Block68
		$this->db->query("insert into ec_field values (22,".$this->db->getUniqueID("ec_field").",'terms_conditions','ec_salesorder',1,'19','terms_conditions','Terms & Conditions',1,0,0,100,1,67,1,'V~O',1,null,'BAS')");


		//Sales Order Details -- END

		//Invoice Details -- START
		//Block69

		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'subject','ec_invoice',1,'2','subject','Subject',1,0,0,100,1,69,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'invoicestatus','ec_invoice',1,'111','invoicestatus','Status',1,0,0,100,2,69,1,'V~O',1,null,'BAS')");		
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'accountid','ec_invoice',1,'73','account_id','Account Name',1,0,0,100,3,69,1,'I~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'contactid','ec_invoice',1,'57','contact_id','Contact Name',1,0,0,100,4,69,1,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'salesorderid','ec_invoice',1,'80','salesorder_id','Sales Order',1,0,0,100,5,69,1,'I~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'customerno','ec_invoice',1,'1','customerno','Customer No',1,0,0,100,3,69,1,'V~O',1,null,'BAS')");	
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'invoicedate','ec_invoice',1,'5','invoicedate','Invoice Date',1,0,0,100,6,69,1,'D~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'duedate','ec_invoice',1,'5','duedate','Due Date',1,0,0,100,7,69,1,'D~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'purchaseorder','ec_invoice',1,'1','ec_purchaseorder','Purchase Order',1,0,0,100,8,69,1,'V~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'salestax','ec_invoice',1,'1','txtTax','Sales Tax',1,0,0,100,8,69,3,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'adjustment','ec_invoice',1,'1','txtAdjustment','Sales Tax',1,0,0,100,9,69,3,'NN~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'salescommission','ec_invoice',1,'1','salescommission','Sales Commission',1,0,0,10,13,69,1,'N~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'exciseduty','ec_invoice',1,'1','exciseduty','Excise Duty',1,0,0,100,11,69,1,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'subtotal','ec_invoice',1,'1','hdnSubTotal','Sub Total',1,0,0,100,12,69,3,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'total','ec_invoice',1,'1','hdnGrandTotal','Total',1,0,0,100,13,69,3,'N~O',1,null,'BAS')");
		//Added fields taxtype, discount percent, discount amount and S&H amount for Tax process
		//$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'taxtype','ec_invoice',1,'15','hdnTaxType','Tax Type',1,0,0,100,13,69,3,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'discount_percent','ec_invoice',1,'1','hdnDiscountPercent','Discount Percent',1,0,0,100,13,69,3,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'discount_amount','ec_invoice',1,'1','hdnDiscountAmount','Discount Amount',1,0,0,100,13,69,3,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'s_h_amount','ec_invoice',1,'1','hdnS_H_Amount','S&H Amount',1,0,0,100,14,69,3,'N~O',1,null,'BAS')");

		
		
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'smownerid','ec_crmentity',1,'53','assigned_user_id','Assigned To',1,0,0,100,16,69,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,17,69,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,18,69,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'currency','ec_invoice',1,'15','currency','Currency',1,0,0,100,19,69,1,'V~O',1,null,'BAS')");	
		//$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'salesorders','ec_invoice',1,'1','salesorders','Sales Orders',1,0,0,200,20,69,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'smcreatorid','ec_crmentity',1,'1004','smcreatorid','smcreator',1,0,0,100,20,69,1,'V~M', 1, NULL, 'BAS')");	
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'invoicenumber','ec_invoice',1,'1','invoicenumber','Invoice Number',1,0,0,100,21,69,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'approvedby','ec_crmentity',1,'1008','approvedby','Approved By',1,0,0,100,23,69,2,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'approved','ec_crmentity',1,'1007','approved','Approve Status',1,0,0,100,24,69,2,'I~O',1,null,'BAS')");

		//Block 71
		/*
        $this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'bill_country','ec_invoicebillads',1,'1','bill_country','Billing Country',1,0,0,100,1,71,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'ship_country','ec_invoiceshipads',1,'1','ship_country','Shipping Country',1,0,0,100,2,71,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'bill_state','ec_invoicebillads',1,'1','bill_state','Billing State',1,0,0,100,3,71,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'ship_state','ec_invoiceshipads',1,'1','ship_state','Shipping State',1,0,0,100,4,71,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'bill_city','ec_invoicebillads',1,'1','bill_city','Billing City',1,0,0,100,5,71,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'ship_city','ec_invoiceshipads',1,'1','ship_city','Shipping City',1,0,0,100,6,71,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'bill_street','ec_invoicebillads',1,'24','bill_street','Billing Address',1,0,0,100,7,71,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'ship_street','ec_invoiceshipads',1,'24','ship_street','Shipping Address',1,0,0,100,8,71,1,'V~M',1,null,'BAS')");

		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'bill_pobox','ec_invoicebillads',1,'1','bill_pobox','Billing Po Box',1,0,0,100,9,71,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'ship_pobox','ec_invoiceshipads',1,'1','ship_pobox','Shipping Po Box',1,0,0,100,10,71,1,'V~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'bill_code','ec_invoicebillads',1,'1','bill_code','Billing Code',1,0,0,100,11,71,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'ship_code','ec_invoiceshipads',1,'1','ship_code','Shipping Code',1,0,0,100,12,71,1,'V~O',1,null,'BAS')");
		*/
		//Block73
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'description','ec_crmentity',1,'19','description','Description',1,0,0,100,1,74,1,'V~O',1,null,'BAS')");
		//Block74
		$this->db->query("insert into ec_field values (23,".$this->db->getUniqueID("ec_field").",'terms_conditions','ec_invoice',1,'19','terms_conditions','Terms & Conditions',1,0,0,100,1,73,1,'V~O',1,null,'BAS')");


		//Invoice Details -- END
		//users Details Starts Block 79,80,81
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'user_name','ec_users',1,'106','user_name','User Name',1,0,0,11,1,79,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'is_admin','ec_users',1,'156','is_admin','Admin',1,0,0,3,2,79,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'user_password','ec_users',1,'99','user_password','Password',1,0,0,30,3,79,4,'P~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'confirm_password','ec_users',1,'99','confirm_password','Confirm Password',1,0,0,30,5,79,4,'P~M',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'first_name','ec_users',1,'1','first_name','First Name',1,0,0,30,7,79,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'last_name','ec_users',1,'2','last_name','Last Name',1,0,0,30,9,79,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'roleid','ec_user2role',1,'98','roleid','Role',1,0,0,200,11,79,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'email1','ec_users',1,'104','email1','Email',1,0,0,100,4,79,1,'E~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'status','ec_users',1,'115','status','Status',1,0,0,100,6,79,1,'V~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'activity_view','ec_users',1,'15','activity_view','Default Activity View',1,0,0,100,12,79,1,'V~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'lead_view','ec_users',1,'15','lead_view','Default Lead View',1,0,0,100,10,79,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'currency_id','ec_users',1,'116','currency_id','Currency',1,0,0,100,8,79,1,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'hour_format','ec_users',1,'116','hour_format','Calendar Hour Format',1,0,0,100,13,79,3,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'end_hour','ec_users',1,'116','end_hour','Day ends at',1,0,0,100,15,79,3,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'start_hour','ec_users',1,'116','start_hour','Day starts at',1,0,0,100,14,79,3,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'title','ec_users',1,'1','title','Title',1,0,0,50,1,80,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'phone_work','ec_users',1,'1','phone_work','Office Phone',1,0,0,50,5,80,1,'V~O',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'department','ec_users',1,'1','department','Department',1,0,0,50,3,80,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'phone_mobile','ec_users',1,'1','phone_mobile','Mobile',1,0,0,50,7,80,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'reports_to_id','ec_users',1,'101','reports_to_id','Reports To',1,0,0,50,8,80,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'phone_other','ec_users',1,'1','phone_other','Other Phone',1,0,0,50,11,80,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'email2','ec_users',1,'13','email2','Other Email',1,0,0,100,4,80,1,'E~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'phone_fax','ec_users',1,'1','phone_fax','Fax',1,0,0,50,2,80,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'yahoo_id','ec_users',1,'13','yahoo_id','Yahoo id',1,0,0,100,6,80,1,'E~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'phone_home','ec_users',1,'1','phone_home','Home Phone',1,0,0,50,9,80,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'date_format','ec_users',1,'15','date_format','Date Format',1,0,0,30,12,80,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'signature','ec_users',1,'21','signature','Signature',1,0,0,250,13,80,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'description','ec_users',1,'21','description','Description',1,0,0,250,14,80,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'address_street','ec_users',1,'21','address_street','Street Address',1,0,0,250,1,81,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'address_city','ec_users',1,'1','address_city','City',1,0,0,100,3,81,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'address_state','ec_users',1,'1','address_state','State',1,0,0,100,5,81,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'address_postalcode','ec_users',1,'1','address_postalcode','Postal Code',1,0,0,100,4,81,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'address_country','ec_users',1,'1','address_country','Country',1,0,0,100,2,81,1,'V~O',1,null,'BAS')");

		//User Image Information
		$this->db->query("insert into ec_field values (29,".$this->db->getUniqueID("ec_field").",'imagename','ec_users',1,'105','imagename','User Image',1,0,0,250,10,83,1,'V~O',1,null,'BAS')");
		//user Details End

		//Messages Details -- START
		//Block91 -- Start
		$this->db->query("insert into ec_field values (32,".$this->db->getUniqueID("ec_field").",'phones','ec_messages',1,'19','phones','Mobile Phones',1,0,0,100,1,91,1,'V~M',1,null,'BAS')");
		//Block91 -- end

		//Block90 -- Start
		$this->db->query("insert into ec_field values (32,".$this->db->getUniqueID("ec_field").",'messagename','ec_messages',1,'19','messagename','Message Name',1,0,0,100,1,90,1,'V~M',0,1,'BAS')");
		//Block90 -- end

				

		//Block92 -- Start
		$this->db->query("insert into ec_field values (32,".$this->db->getUniqueID("ec_field").",'send_date','ec_messages',1,'5','send_date','Send Date',1,0,0,100,3,92,1,'D~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (32,".$this->db->getUniqueID("ec_field").",'smownerid','ec_crmentity',1,'53','assigned_user_id','Assigned To',1,0,0,100,4,92,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (32,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,5,92,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (32,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,6,92,2,'T~O',1,null,'BAS')");
		//Block92 -- End
		//Messages Details -- END

		//Gathers Details -- START
		//Block94 -- Start
		$this->db->query("insert into ec_field values (33,".$this->db->getUniqueID("ec_field").",'gathername','ec_gathers',1,'2','gathername','Gather Name',1,0,0,100,1,94,1,'V~M',0,1,'BAS')");
		$this->db->query("insert into ec_field values (33,".$this->db->getUniqueID("ec_field").",'amountcomment','ec_gathers',1,'1','amountcomment','Amount Comment',1,0,0,100,2,94,1,'V~O',0,1,'BAS')");
		$this->db->query("insert into ec_field values (33,".$this->db->getUniqueID("ec_field").",'accountid','ec_gathers',1,'51','account_id','Account Name',1,0,0,100,3,94,1,'V~M',0,1,'BAS')");
		$this->db->query("insert into ec_field values (33,".$this->db->getUniqueID("ec_field").",'salesorderid','ec_gathers',1,'80','salesorder_id','Sales Order',1,0,0,100,4,94,1,'I~O',1,null,'BAS')");	
		$this->db->query("insert into ec_field values (33,".$this->db->getUniqueID("ec_field").",'invoiceid','ec_gathers',1,'1010','invoiceid','Invoice',1,0,0,100,4,94,1,'I~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (33,".$this->db->getUniqueID("ec_field").",'planamount','ec_gathers',1,'1','planamount','Plan Amount',1,0,0,100,5,94,1,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (33,".$this->db->getUniqueID("ec_field").",'plandate','ec_gathers',1,'5','plandate','Plan Date',1,0,0,100,6,94,1,'D~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (33,".$this->db->getUniqueID("ec_field").",'actualamount','ec_gathers',1,'1','actualamount','Actual Amount',1,0,0,100,7,94,1,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (33,".$this->db->getUniqueID("ec_field").",'actualdate','ec_gathers',1,'5','actualdate','Actual Date',1,0,0,100,8,94,1,'D~O',1,null,'BAS')");				
		$this->db->query("insert into ec_field values (33,".$this->db->getUniqueID("ec_field").",'gatherstatus','ec_gathers',1,'15','gatherstatus','Gather Status',1,0,0,100,9,94,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (33,".$this->db->getUniqueID("ec_field").",'isinvoice','ec_gathers',1,'15','isinvoice','Gather Invoice',1,0,0,100,10,94,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (33,".$this->db->getUniqueID("ec_field").",'gathertimes','ec_gathers',1,'15','gathertimes','Gather Times',1,0,0,100,11,94,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (33,".$this->db->getUniqueID("ec_field").",'smownerid','ec_crmentity',1,'53','assigned_user_id','Assigned To',1,0,0,100,12,94,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (33,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,13,94,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (33,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,14,94,2,'T~O',1,null,'BAS')");
		

		//Block94 -- End
		$this->db->query("insert into ec_field values (33,".$this->db->getUniqueID("ec_field").",'description','ec_crmentity',1,'19','description','Description',1,0,0,100,15,96,1,'V~O',1,null,'BAS')");

		//Charges Details -- START
		//Block94 -- Start
		$this->db->query("insert into ec_field values (34,".$this->db->getUniqueID("ec_field").",'chargename','ec_charges',1,'2','chargename','Charge Name',1,0,0,100,1,97,1,'V~M',0,1,'BAS')");
		$this->db->query("insert into ec_field values (34,".$this->db->getUniqueID("ec_field").",'amountcomment','ec_charges',1,'1','amountcomment','Amount Comment',1,0,0,100,2,97,1,'V~O',0,1,'BAS')");
		//$this->db->query("insert into ec_field values (34,".$this->db->getUniqueID("ec_field").",'accountid','ec_charges',1,'51','account_id','Account Name',1,0,0,100,3,947,1,'V~M',0,1,'BAS')");
		$this->db->query("insert into ec_field values (34,".$this->db->getUniqueID("ec_field").",'vendorid','ec_charges',1,'81','vendor_id','Vendor Name',1,0,0,100,3,97,1,'I~M',1,null,'BAS')");	
		$this->db->query("insert into ec_field values (34,".$this->db->getUniqueID("ec_field").",'purchaseorderid','ec_charges',1,'79','purchaseorder_id','Purchase Order',1,0,0,100,4,97,1,'I~O',1,null,'BAS')");	
		$this->db->query("insert into ec_field values (34,".$this->db->getUniqueID("ec_field").",'planamount','ec_charges',1,'1','planamount','Plan Amount',1,0,0,100,5,97,1,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (34,".$this->db->getUniqueID("ec_field").",'plandate','ec_charges',1,'5','plandate','Plan Date',1,0,0,100,6,97,1,'D~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (34,".$this->db->getUniqueID("ec_field").",'actualamount','ec_charges',1,'1','actualamount','Actual Amount',1,0,0,100,7,97,1,'N~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (34,".$this->db->getUniqueID("ec_field").",'actualdate','ec_charges',1,'5','actualdate','Actual Date',1,0,0,100,8,97,1,'D~O',1,null,'BAS')");				
		$this->db->query("insert into ec_field values (34,".$this->db->getUniqueID("ec_field").",'chargestatus','ec_charges',1,'15','chargestatus','Charge Status',1,0,0,100,9,97,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (34,".$this->db->getUniqueID("ec_field").",'isinvoice','ec_charges',1,'15','isinvoice','Charge Invoice',1,0,0,100,10,97,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (34,".$this->db->getUniqueID("ec_field").",'chargetimes','ec_charges',1,'15','chargetimes','Charge Times',1,0,0,100,11,97,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (34,".$this->db->getUniqueID("ec_field").",'smownerid','ec_crmentity',1,'53','assigned_user_id','Assigned To',1,0,0,100,12,97,1,'V~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (34,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,13,97,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (34,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,14,97,2,'T~O',1,null,'BAS')");
		

		//Block94 -- End
		$this->db->query("insert into ec_field values (34,".$this->db->getUniqueID("ec_field").",'description','ec_crmentity',1,'19','description','Description',1,0,0,100,15,99,1,'V~O',1,null,'BAS')");

		//Expenses Details -- START
		//Block100 -- Start
		$this->db->query("insert into ec_field values (35,".$this->db->getUniqueID("ec_field").",'expensename','ec_expenses',1,'2','expensename','Expense Name',1,0,0,100,1,100,1,'V~M',0,1,'BAS')");
		$this->db->query("insert into ec_field values (35,".$this->db->getUniqueID("ec_field").",'total','ec_expenses',1,'1','total','Total',1,0,0,100,2,100,1,'N~M',1,null,'BAS')");
		$this->db->query("insert into ec_field values (35,".$this->db->getUniqueID("ec_field").",'expensecategory','ec_expenses',1,'15','expensecategory','Expense Category',1,0,0,100,3,100,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (35,".$this->db->getUniqueID("ec_field").",'expensebill','ec_expenses',1,'15','expensebill','Expense Bill',1,0,0,100,4,100,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (35,".$this->db->getUniqueID("ec_field").",'accountid','ec_expenses',1,'51','account_id','Account Name',1,0,0,100,5,100,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (35,".$this->db->getUniqueID("ec_field").",'contact_id','ec_expenses',1,'57','contact_id','Contact Name',1,0,0,100,6,100,1,'V~O',1,null,'BAS')");        
		$this->db->query("insert into ec_field values (35,".$this->db->getUniqueID("ec_field").",'expensestatus','ec_expenses',1,'15','expensestatus','Expense Status',1,0,0,100,7,100,1,'V~O',1,null,'BAS')");
        $this->db->query("insert into ec_field values (35,".$this->db->getUniqueID("ec_field").",'expensedate','ec_expenses',1,'5','expensedate','Expense Date',1,0,0,100,8,100,1,'D~O',1,null,'BAS')");		
		
		$this->db->query("insert into ec_field values (35,".$this->db->getUniqueID("ec_field").",'approvedby','ec_crmentity',1,'1008','approvedby','Approved By',1,0,0,100,9,100,2,'I~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (35,".$this->db->getUniqueID("ec_field").",'approved','ec_crmentity',1,'1007','approved','Approve Status',1,0,0,100,10,100,2,'I~O',1,null,'BAS')");

		$this->db->query("insert into ec_field values (35,".$this->db->getUniqueID("ec_field").",'smownerid','ec_crmentity',1,'53','assigned_user_id','Assigned To',1,0,0,100,11,100,1,'V~M',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (35,".$this->db->getUniqueID("ec_field").",'projectsid','ec_expenses',1,'1012','projectsid','project',1,0,0,100,21,100,1,'V~O',0,1,'BAS')");

		$this->db->query("insert into ec_field values (35,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,12,100,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (35,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,13,100,2,'T~O',1,null,'BAS')");
		

		//Block94 -- End
		$this->db->query("insert into ec_field values (35,".$this->db->getUniqueID("ec_field").",'description','ec_crmentity',1,'19','description','Description',1,0,0,100,12,102,1,'V~M',1,null,'BAS')");


		//Documents Details -- START
		//Block100 -- Start
		$this->db->query("insert into ec_field values (37,".$this->db->getUniqueID("ec_field").",'documentname','ec_documents',1,'2','documentname','Document Name',1,0,0,100,1,103,1,'V~M',0,1,'BAS')");
		$this->db->query("insert into ec_field values (37,".$this->db->getUniqueID("ec_field").",'documentcategory','ec_documents',1,'15','documentcategory','Document Category',1,0,0,100,2,103,1,'V~O',1,null,'BAS')");	
		$this->db->query("insert into ec_field values (37,".$this->db->getUniqueID("ec_field").",'smownerid','ec_crmentity',1,'53','assigned_user_id','Assigned To',1,0,0,100,3,103,1,'V~M',1,null,'BAS')");
		//$this->db->query("insert into ec_field values (37,".$this->db->getUniqueID("ec_field").",'filename','ec_documents',1,'61','filename','File',1,0,0,100,4,103,1,'V~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (37,".$this->db->getUniqueID("ec_field").",'createdtime','ec_crmentity',1,'70','createdtime','Created Time',1,0,0,100,5,103,2,'T~O',1,null,'BAS')");
		$this->db->query("insert into ec_field values (37,".$this->db->getUniqueID("ec_field").",'modifiedtime','ec_crmentity',1,'70','modifiedtime','Modified Time',1,0,0,100,6,103,2,'T~O',1,null,'BAS')");
		

		//Block94 -- End
		$this->db->query("insert into ec_field values (37,".$this->db->getUniqueID("ec_field").",'description','ec_crmentity',1,'19','description','Description',1,0,0,100,12,105,1,'V~M',1,null,'BAS')");

		if($is_upgrade) {
			$this->db->query("delete from ec_profile2field");
		}
		//Insert into ec_profile2field
		insertProfile2field($profile1_id);
		insertProfile2field($profile2_id);	
		insertProfile2field($profile3_id);	
		insertProfile2field($profile4_id);

		//if($is_upgrade) {
		//	$this->db->query("delete from ec_def_org_field");
		//}
		insert_def_org_field();

		

		if(!$is_upgrade) {
			
			//The Entity Name for the modules are maintained in this table
			//$this->db->query("insert into ec_entityname values(7,'Leads','ec_leaddetails','lastname,firstname','leadid')");
			//changed by dingjianting on 2007-1-11 for chinese name
			$this->db->query("insert into ec_entityname values(7,'Leads','ec_leaddetails','lastname','leadid')");
			$this->db->query("insert into ec_entityname values(6,'Accounts','ec_account','accountname','accountid')");
			//$this->db->query("insert into ec_entityname values(4,'Contacts','ec_contactdetails','lastname,firstname','contactid')");
			$this->db->query("insert into ec_entityname values(4,'Contacts','ec_contactdetails','lastname','contactid')");
			$this->db->query("insert into ec_entityname values(2,'Potentials','ec_potential','potentialname','potentialid')");
			$this->db->query("insert into ec_entityname values(8,'Notes','ec_notes','title','notesid')");
			$this->db->query("insert into ec_entityname values(13,'HelpDesk','ec_troubletickets','title','ticketid')");
			$this->db->query("insert into ec_entityname values(9,'Calendar','ec_activity','subject','activityid')");
			$this->db->query("insert into ec_entityname values(10,'Emails','ec_activity','subject','activityid')");
			$this->db->query("insert into ec_entityname values(14,'Products','ec_products','productname','productid')");
			//$this->db->query("insert into ec_entityname values(29,'Users','ec_users','last_name,first_name','id')");
			$this->db->query("insert into ec_entityname values(29,'Users','ec_users','last_name','id')");
			$this->db->query("insert into ec_entityname values(23,'Invoice','ec_invoice','subject','invoiceid')");
			$this->db->query("insert into ec_entityname values(20,'Quotes','ec_quotes','subject','quoteid')");
			$this->db->query("insert into ec_entityname values(21,'PurchaseOrder','ec_purchaseorder','subject','purchaseorderid')");
			$this->db->query("insert into ec_entityname values(22,'SalesOrder','ec_salesorder','subject','salesorderid')");
			$this->db->query("insert into ec_entityname values(18,'Vendors','ec_vendor','vendorname','vendorid')");
			$this->db->query("insert into ec_entityname values(19,'PriceBooks','ec_pricebook','bookname','pricebookid')");
			$this->db->query("insert into ec_entityname values(26,'Campaigns','ec_campaign','campaignname','campaignid')");
			$this->db->query("insert into ec_entityname values(15,'Faq','ec_faq','question','id')");
			//new module Exhibitions
			//$this->db->query("insert into ec_entityname values(30,'Exhibitions','ec_exhibitions','exhibitionname','exhibitionsid')");

			//new module Messages
			$this->db->query("insert into ec_entityname values(32,'Messages','ec_messages','messagename','messagesid')");

			//new module Gathers
			$this->db->query("insert into ec_entityname values(33,'Gathers','ec_gathers','gathername','gathersid')");

			//new module Charges
			$this->db->query("insert into ec_entityname values(34,'Charges','ec_charges','chargename','chargesid')");

			//new module Expenses
			$this->db->query("insert into ec_entityname values(35,'Expenses','ec_expenses','expensename','expensesid')");

			//new module Documents
			$this->db->query("insert into ec_entityname values(37,'Documents','ec_documents','documentname','documentsid')");

			// Insert End

			//Inserting into ec_groups table
			$group1_id = $this->db->getUniqueID("ec_groups");
			$group2_id = $this->db->getUniqueID("ec_groups");
			$group3_id = $this->db->getUniqueID("ec_groups");

			$this->db->query("insert into ec_groups values ('".$group1_id."','销售部','与销售有关的部门')");	
			$this->db->query("insert into ec_group2role values ('".$group1_id."','H".$role4_id."')");	
			$this->db->query("insert into ec_group2rs values ('".$group1_id."','H".$role5_id."')");	

			$this->db->query("insert into ec_groups values ('".$group2_id."','市场部','与市场活动有关的部门')");	
			$this->db->query("insert into ec_group2role values ('".$group2_id."','H".$role2_id."')");	
			$this->db->query("insert into ec_group2rs values ('".$group2_id."','H".$role3_id."')");	

			$this->db->query("insert into ec_groups values ('".$group3_id."','售后服务部','为客户提供支持的部门')");
			$this->db->query("insert into ec_group2role values ('".$group3_id."','H".$role3_id."')");
			$this->db->query("insert into ec_group2rs values ('".$group3_id."','H".$role3_id."')");

			//New Security Start
			//Inserting into ec_profile ec_table
			$this->db->query("insert into ec_profile values ('".$profile1_id."','管理员组','管理员角色的权限设置')");	
			$this->db->query("insert into ec_profile values ('".$profile2_id."','副总经理','副总经理角色的权限设置')");
			$this->db->query("insert into ec_profile values ('".$profile3_id."','销售经理','销售经理角色的权限设置')");
			$this->db->query("insert into ec_profile values ('".$profile4_id."','销售人员','销售人员角色的权限设置')");


			//Inserting into ec_profile2gloabal permissions
			//0表示能浏览或编辑所有用户的所有信息
			$this->db->query("insert into ec_profile2globalpermissions values ('".$profile1_id."',1,0)");
			$this->db->query("insert into ec_profile2globalpermissions values ('".$profile1_id."',2,0)");
			$this->db->query("insert into ec_profile2globalpermissions values ('".$profile2_id."',1,1)");
			$this->db->query("insert into ec_profile2globalpermissions values ('".$profile2_id."',2,1)");
			$this->db->query("insert into ec_profile2globalpermissions values ('".$profile3_id."',1,1)");
			$this->db->query("insert into ec_profile2globalpermissions values ('".$profile3_id."',2,1)");
			$this->db->query("insert into ec_profile2globalpermissions values ('".$profile4_id."',1,1)");
			$this->db->query("insert into ec_profile2globalpermissions values ('".$profile4_id."',2,1)");

			//Inserting into ec_profile2tab
			//$this->db->query("insert into ec_profile2tab values (".$profile1_id.",1,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",2,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",3,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",4,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",6,0)");
			//$this->db->query("insert into ec_profile2tab values (".$profile1_id.",7,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",8,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",9,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",28,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",13,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",14,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",15,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",16,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",18,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",19,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",20,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",21,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",22,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",23,0)");
			//$this->db->query("insert into ec_profile2tab values (".$profile1_id.",24,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",25,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",26,0)");
			//$this->db->query("insert into ec_profile2tab values (".$profile1_id.",27,0)");
			//new module exhibitions
			//$this->db->query("insert into ec_profile2tab values (".$profile1_id.",30,0)");

			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",32,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",33,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",34,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",35,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",36,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile1_id.",37,0)");

			//Inserting into ec_profile2tab
			//$this->db->query("insert into ec_profile2tab values (".$profile2_id.",1,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",2,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",3,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",4,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",6,0)");
			//$this->db->query("insert into ec_profile2tab values (".$profile2_id.",7,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",8,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",9,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",28,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",13,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",14,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",15,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",16,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",18,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",19,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",20,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",21,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",22,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",23,0)");
			//$this->db->query("insert into ec_profile2tab values (".$profile2_id.",24,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",25,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",26,0)");
			//$this->db->query("insert into ec_profile2tab values (".$profile2_id.",27,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",32,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",33,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",34,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",35,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",36,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile2_id.",37,0)");

			//Inserting into ec_profile2tab
			//$this->db->query("insert into ec_profile2tab values (".$profile3_id.",1,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",2,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",3,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",4,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",6,0)");
			//$this->db->query("insert into ec_profile2tab values (".$profile3_id.",7,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",8,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",9,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",28,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",13,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",14,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",15,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",16,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",18,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",19,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",20,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",21,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",22,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",23,0)");
			//$this->db->query("insert into ec_profile2tab values (".$profile3_id.",24,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",25,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",26,0)");
			//$this->db->query("insert into ec_profile2tab values (".$profile3_id.",27,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",32,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",33,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",34,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",35,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",36,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile3_id.",37,0)");


			//Inserting into ec_profile2tab
			//$this->db->query("insert into ec_profile2tab values (".$profile4_id.",1,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",2,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",3,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",4,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",6,0)");
			//$this->db->query("insert into ec_profile2tab values (".$profile4_id.",7,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",8,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",9,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",28,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",13,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",14,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",15,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",16,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",18,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",19,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",20,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",21,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",22,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",23,0)");
			//$this->db->query("insert into ec_profile2tab values (".$profile4_id.",24,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",25,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",26,0)");
			//$this->db->query("insert into ec_profile2tab values (".$profile4_id.",27,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",32,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",33,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",34,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",35,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",36,0)");
			$this->db->query("insert into ec_profile2tab values (".$profile4_id.",37,0)");
			//Inserting into ec_profile2standardpermissions  Adminsitrator

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",2,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",2,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",2,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",2,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",2,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",2,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",4,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",4,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",4,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",4,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",4,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",4,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",6,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",6,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",6,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",6,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",6,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",6,10,0)");

			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",7,0,0)");
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",7,1,0)");
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",7,2,0)");
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",7,3,0)");
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",7,4,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",8,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",8,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",8,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",8,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",8,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",8,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",9,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",9,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",9,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",9,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",9,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",9,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",13,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",13,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",13,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",13,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",13,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",13,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",14,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",14,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",14,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",14,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",14,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",14,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",15,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",15,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",15,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",15,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",15,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",15,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",16,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",16,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",16,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",16,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",16,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",16,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",18,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",18,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",18,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",18,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",18,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",18,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",19,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",19,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",19,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",19,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",19,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",19,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",20,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",20,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",20,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",20,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",20,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",20,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",21,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",21,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",21,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",21,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",21,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",21,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",22,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",22,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",22,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",22,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",22,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",22,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",23,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",23,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",23,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",23,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",23,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",23,10,0)");



			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",26,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",26,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",26,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",26,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",26,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",26,10,0)");
            
			//new module Exhibitions
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",30,0,0)");
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",30,1,0)");
			///$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",30,2,0)");
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",30,3,0)");
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",30,4,0)");

			//new module Messages
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",32,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",32,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",32,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",32,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",32,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",32,10,0)");

			//new module Gathers
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",33,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",33,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",33,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",33,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",33,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",33,10,0)");

			//new module Charges
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",34,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",34,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",34,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",34,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",34,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",34,10,0)");

			//new module Expenses
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",35,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",35,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",35,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",35,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",35,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",35,10,0)");

			//new module Documents
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",37,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",37,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",37,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",37,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",37,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile1_id.",37,10,0)");

			//Insert into Profile 2 std permissions for Sales User  
			//Help Desk Create/Delete not allowed. Read-Only	

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",2,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",2,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",2,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",2,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",2,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",2,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",4,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",4,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",4,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",4,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",4,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",4,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",6,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",6,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",6,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",6,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",6,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",6,10,0)");

			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",7,0,0)");
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",7,1,0)");
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",7,2,0)");
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",7,3,0)");
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",7,4,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",8,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",8,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",8,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",8,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",8,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",8,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",9,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",9,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",9,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",9,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",9,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",9,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",13,0,1)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",13,1,1)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",13,2,1)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",13,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",13,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",13,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",14,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",14,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",14,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",14,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",14,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",14,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",15,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",15,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",15,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",15,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",15,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",15,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",16,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",16,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",16,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",16,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",16,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",16,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",18,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",18,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",18,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",18,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",18,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",18,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",19,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",19,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",19,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",19,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",19,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",19,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",20,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",20,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",20,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",20,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",20,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",20,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",21,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",21,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",21,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",21,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",21,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",21,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",22,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",22,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",22,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",22,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",22,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",22,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",23,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",23,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",23,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",23,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",23,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",23,10,0)");


			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",26,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",26,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",26,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",26,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",26,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",26,10,0)");

			//new module Messages
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",32,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",32,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",32,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",32,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",32,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",32,10,0)");

			//new module Gathers
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",33,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",33,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",33,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",33,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",33,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",33,10,0)");

			//new module Charges
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",34,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",34,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",34,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",34,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",34,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",34,10,0)");

			//new module Expenses
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",35,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",35,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",35,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",35,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",35,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",35,10,0)");

			//new module Documents
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",37,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",37,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",37,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",37,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",37,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile2_id.",37,10,0)");

			//Inserting into ec_profile2std for Support Profile
			// Potential is read-only

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",2,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",2,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",2,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",2,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",2,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",2,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",4,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",4,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",4,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",4,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",4,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",4,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",6,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",6,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",6,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",6,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",6,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",6,10,0)");

			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",7,0,0)");
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",7,1,0)");
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",7,2,0)");
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",7,3,0)");
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",7,4,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",8,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",8,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",8,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",8,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",8,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",8,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",9,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",9,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",9,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",9,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",9,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",9,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",13,0,1)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",13,1,1)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",13,2,1)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",13,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",13,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",13,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",14,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",14,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",14,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",14,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",14,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",14,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",15,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",15,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",15,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",15,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",15,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",15,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",16,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",16,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",16,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",16,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",16,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",16,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",18,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",18,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",18,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",18,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",18,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",18,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",19,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",19,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",19,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",19,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",19,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",19,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",20,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",20,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",20,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",20,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",20,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",20,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",21,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",21,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",21,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",21,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",21,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",21,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",22,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",22,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",22,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",22,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",22,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",22,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",23,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",23,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",23,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",23,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",23,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",23,10,0)");


			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",26,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",26,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",26,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",26,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",26,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",26,10,0)");

			//new module Messages
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",32,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",32,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",32,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",32,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",32,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",32,10,0)");

			//new module Gathers
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",33,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",33,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",33,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",33,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",33,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",33,10,0)");

			//new module Charges
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",34,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",34,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",34,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",34,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",34,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",34,10,0)");

			//new module Expenses
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",35,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",35,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",35,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",35,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",35,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",35,10,0)");

			//new module Documents
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",37,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",37,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",37,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",37,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",37,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile3_id.",37,10,0)");

			//Inserting into ec_profile2stdper for Profile Guest Profile
			//All Read-Only

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",2,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",2,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",2,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",2,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",2,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",2,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",4,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",4,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",4,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",4,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",4,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",4,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",6,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",6,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",6,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",6,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",6,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",6,10,0)");

			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",7,0,0)");
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",7,1,0)");
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",7,2,0)");
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",7,3,0)");
			//$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",7,4,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",8,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",8,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",8,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",8,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",8,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",8,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",9,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",9,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",9,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",9,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",9,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",9,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",13,0,1)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",13,1,1)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",13,2,1)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",13,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",13,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",13,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",14,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",14,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",14,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",14,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",14,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",14,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",15,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",15,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",15,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",15,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",15,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",15,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",16,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",16,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",16,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",16,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",16,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",16,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",18,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",18,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",18,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",18,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",18,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",18,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",19,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",19,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",19,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",19,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",19,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",19,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",20,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",20,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",20,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",20,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",20,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",20,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",21,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",21,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",21,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",21,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",21,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",21,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",22,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",22,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",22,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",22,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",22,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",22,10,0)");

			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",23,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",23,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",23,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",23,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",23,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",23,10,0)");


			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",26,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",26,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",26,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",26,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",26,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",26,10,0)");

			//new module Messages
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",32,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",32,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",32,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",32,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",32,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",32,10,0)");

			//new module Gathers
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",33,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",33,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",33,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",33,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",33,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",33,10,0)");

			//new module Charges
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",34,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",34,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",34,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",34,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",34,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",34,10,0)");

			//new module Expenses
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",35,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",35,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",35,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",35,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",35,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",35,10,0)");

			//new module Documents
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",37,0,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",37,1,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",37,2,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",37,3,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",37,4,0)");
			$this->db->query("insert into ec_profile2standardpermissions values (".$profile4_id.",37,10,0)");

			//Insert into ec_role2profile
			$this->db->query("insert into ec_role2profile values ('H".$role2_id."',".$profile1_id.")");
			$this->db->query("insert into ec_role2profile values ('H".$role3_id."',".$profile2_id.")");
			$this->db->query("insert into ec_role2profile values ('H".$role4_id."',".$profile3_id.")");
			$this->db->query("insert into ec_role2profile values ('H".$role5_id."',".$profile4_id.")"); 

			
		//}
        //if($is_upgrade) {
		//	$this->db->query("delete from ec_profile2field");
		//}
		//Insert into ec_profile2field
		//insertProfile2field($profile1_id);
		//insertProfile2field($profile2_id);	
		//insertProfile2field($profile3_id);	
		//insertProfile2field($profile4_id);

		//if($is_upgrade) {
		//	$this->db->query("delete from ec_def_org_field");
		//}
		//insert_def_org_field();
		//if(!$is_upgrade) {
			//Inserting into ec_profile 2 utility Admin
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",2,5,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",2,6,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",4,5,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",4,6,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",6,5,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",6,6,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",7,5,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",7,6,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",8,6,0)");
			//$this->db->query("insert into ec_profile2utility values (".$profile1_id.",9,6,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",10,6,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",7,8,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",6,8,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",4,8,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",13,8,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",14,5,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",14,6,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",7,9,0)");
			//vendors
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",18,5,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",18,6,0)");

			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",21,11,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",22,11,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",23,11,0)");

			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",32,5,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",32,6,0)");

			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",33,5,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",33,6,0)");

			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",34,5,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",34,6,0)");

			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",35,5,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",35,6,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",35,11,0)");

			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",37,5,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile1_id.",37,6,0)");


			//Inserting into ec_profile2utility Sales Profile
			//Import Export Not Allowed.	
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",2,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",2,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",4,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",4,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",6,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",6,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",7,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",7,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",8,6,1)");
			//$this->db->query("insert into ec_profile2utility values (".$profile2_id.",9,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",10,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",7,8,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",6,8,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",4,8,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",13,8,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",14,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",14,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",7,9,0)");

			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",18,5,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",18,6,1)");

			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",21,11,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",22,11,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",22,11,0)");

			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",32,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",32,6,1)");

			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",33,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",33,6,1)");

			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",34,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",34,6,1)");

			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",35,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",35,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",35,11,0)");

			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",37,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile2_id.",37,6,1)");

			//Inserting into ec_profile2utility Support Profile
			//Import Export Not Allowed.	
			//Inserting into ec_profile2utility Sales Profile
			//Import Export Not Allowed.	
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",2,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",2,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",4,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",4,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",6,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",6,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",7,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",7,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",8,6,1)");
			//$this->db->query("insert into ec_profile2utility values (".$profile3_id.",9,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",10,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",7,8,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",6,8,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",4,8,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",13,8,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",14,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",14,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",7,9,0)");

			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",18,5,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",18,6,1)");

			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",21,11,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",22,11,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",23,11,0)");

			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",32,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",32,6,1)");

			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",33,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",33,6,1)");

			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",34,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",34,6,1)");

			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",35,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",35,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",35,11,0)");

			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",37,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile3_id.",37,6,1)");

			//Inserting into ec_profile2utility Guest Profile Read-Only
			//Import Export BusinessCar Not Allowed.	
			//Inserting into ec_profile2utility Sales Profile
			//Import Export Not Allowed.	
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",2,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",2,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",4,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",4,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",6,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",6,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",7,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",7,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",8,6,1)");
			//$this->db->query("insert into ec_profile2utility values (".$profile4_id.",9,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",10,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",7,8,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",6,8,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",4,8,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",13,8,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",14,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",14,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",7,9,0)");

			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",18,5,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",18,6,1)");

			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",21,11,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",22,11,0)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",23,11,0)");

			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",32,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",32,6,1)");

			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",33,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",33,6,1)");

			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",34,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",34,6,1)");

			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",35,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",35,6,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",35,11,0)");

			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",37,5,1)");
			$this->db->query("insert into ec_profile2utility values (".$profile4_id.",37,6,1)");

			//Inserting values into org share action mapping
			$this->db->query("insert into ec_org_share_action_mapping values(0,'Public: Read Only')");
			$this->db->query("insert into ec_org_share_action_mapping values(1,'Public: Read, Create/Edit')");
			$this->db->query("insert into ec_org_share_action_mapping values(2,'Public: Read, Create/Edit, Delete')");
			$this->db->query("insert into ec_org_share_action_mapping values(3,'Private')");

			$this->db->query("insert into ec_org_share_action_mapping values(4,'Hide Details')");
			$this->db->query("insert into ec_org_share_action_mapping values(5,'Hide Details and Add Events')");
			$this->db->query("insert into ec_org_share_action_mapping values(6,'Show Details')");
			$this->db->query("insert into ec_org_share_action_mapping values(7,'Show Details and Add Events')");


			//Inserting for all ec_tabs
			$def_org_tabid= Array(2,4,6,8,9,10,13,16,20,21,22,23,26,32,33,34,35,37);

			foreach($def_org_tabid as $def_tabid)
			{
			$this->db->query("insert into ec_org_share_action2tab values(0,".$def_tabid.")");
			$this->db->query("insert into ec_org_share_action2tab values(1,".$def_tabid.")");
			$this->db->query("insert into ec_org_share_action2tab values(2,".$def_tabid.")");
			$this->db->query("insert into ec_org_share_action2tab values(3,".$def_tabid.")");
			}

			//Insert into default_org_sharingrule
			$this->db->query("insert into ec_def_org_share values (".$this->db->getUniqueID('ec_def_org_share').",2,3,0)");

			$this->db->query("insert into ec_def_org_share values (".$this->db->getUniqueID('ec_def_org_share').",4,3,0)");

			$this->db->query("insert into ec_def_org_share values (".$this->db->getUniqueID('ec_def_org_share').",6,3,0)");

			//$this->db->query("insert into ec_def_org_share values (".$this->db->getUniqueID('ec_def_org_share').",7,3,0)");

			$this->db->query("insert into ec_def_org_share values (".$this->db->getUniqueID('ec_def_org_share').",8,3,0)");

			$this->db->query("insert into ec_def_org_share values (".$this->db->getUniqueID('ec_def_org_share').",9,3,0)");
			$this->db->query("insert into ec_def_org_share values (".$this->db->getUniqueID('ec_def_org_share').",10,3,0)");
			$this->db->query("insert into ec_def_org_share values (".$this->db->getUniqueID('ec_def_org_share').",13,3,0)");
			$this->db->query("insert into ec_def_org_share values (".$this->db->getUniqueID('ec_def_org_share').",16,3,0)");
			$this->db->query("insert into ec_def_org_share values (".$this->db->getUniqueID('ec_def_org_share').",20,3,0)");
			$this->db->query("insert into ec_def_org_share values (".$this->db->getUniqueID('ec_def_org_share').",21,3,0)");
			$this->db->query("insert into ec_def_org_share values (".$this->db->getUniqueID('ec_def_org_share').",22,3,0)");
			$this->db->query("insert into ec_def_org_share values (".$this->db->getUniqueID('ec_def_org_share').",23,3,0)");
			$this->db->query("insert into ec_def_org_share values (".$this->db->getUniqueID('ec_def_org_share').",26,3,0)");
			$this->db->query("insert into ec_def_org_share values (".$this->db->getUniqueID('ec_def_org_share').",32,3,0)");
			$this->db->query("insert into ec_def_org_share values (".$this->db->getUniqueID('ec_def_org_share').",33,3,0)");
			$this->db->query("insert into ec_def_org_share values (".$this->db->getUniqueID('ec_def_org_share').",34,3,0)");
			$this->db->query("insert into ec_def_org_share values (".$this->db->getUniqueID('ec_def_org_share').",35,3,0)");
			$this->db->query("insert into ec_def_org_share values (".$this->db->getUniqueID('ec_def_org_share').",37,3,0)");

			//Populating the DataShare Related Modules

			//Lead Related Module

			//Account Related Module
			/*
			$this->db->query("insert into ec_datashare_relatedmodules values (".$this->db->getUniqueID('ec_datashare_relatedmodules').",6,2)");
			$this->db->query("insert into ec_datashare_relatedmodules values (".$this->db->getUniqueID('ec_datashare_relatedmodules').",6,13)");
			$this->db->query("insert into ec_datashare_relatedmodules values (".$this->db->getUniqueID('ec_datashare_relatedmodules').",6,20)");
			$this->db->query("insert into ec_datashare_relatedmodules values (".$this->db->getUniqueID('ec_datashare_relatedmodules').",6,22)");
			$this->db->query("insert into ec_datashare_relatedmodules values (".$this->db->getUniqueID('ec_datashare_relatedmodules').",6,23)");

			//Potential Related Module
			$this->db->query("insert into ec_datashare_relatedmodules values (".$this->db->getUniqueID('ec_datashare_relatedmodules').",2,20)");
			$this->db->query("insert into ec_datashare_relatedmodules values (".$this->db->getUniqueID('ec_datashare_relatedmodules').",2,22)");

			//Quote Related Module
			$this->db->query("insert into ec_datashare_relatedmodules values (".$this->db->getUniqueID('ec_datashare_relatedmodules').",20,22)");

			//SO Related Module
			$this->db->query("insert into ec_datashare_relatedmodules values (".$this->db->getUniqueID('ec_datashare_relatedmodules').",22,23)");
			*/
		}




		// New Secutity End


		//insert into the ec_notificationscheduler ec_table

		//insert into related list ec_table
		//Inserting for ec_account related lists
		if($is_upgrade) {
			$this->db->query("delete from ec_relatedlists");
		}
        $this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Accounts").",0,'get_notes',0,'Notes',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Accounts").",0,'get_attachments',1,'Attachments',0)");
        $this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Accounts").",".getTabid("Gathers").",'get_gathers',2,'Gathers',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Accounts").",".getTabid("Contacts").",'get_contacts',3,'Contacts',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Accounts").",".getTabid("Calendar").",'get_activities',4,'Activities',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Accounts").",".getTabid("Potentials").",'get_opportunities',5,'Potentials',0)");	
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Accounts").",".getTabid("HelpDesk").",'get_tickets',6,'HelpDesk',0)");
    	$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Accounts").",".getTabid("Quotes").",'get_quotes',7,'Quotes',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Accounts").",".getTabid("Invoice").",'get_invoices',8,'Invoice',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Accounts").",".getTabid("SalesOrder").",'get_salesorder',9,'Sales Order',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Accounts").",".getTabid("Products").",'get_products',10,'Products',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Accounts").",".getTabid("Campaigns").",'get_campaigns',11,'Campaigns',0)");

		//Inserting Lead Related Lists	

		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Leads").",".getTabid("Calendar").",'get_activities',1,'Activities',0)");

		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Leads").",".getTabid("Emails").",'get_emails',2,'Emails',0)");

		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Leads").",".getTabid("Calendar").",'get_history',3,'Activity History',0)");

		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Leads").",0,'get_attachments',3,'Attachments',0)");

		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Leads").",".getTabid("Products").",'get_products',4,'Products',0)");

		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Leads").",".getTabid("Campaigns").",'get_campaigns',5,'Campaigns',0)");

		//Inserting for contact related lists
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Contacts").",0,'get_notes',0,'Notes',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Contacts").",0,'get_attachments',1,'Attachments',0)");
		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Contacts").",".getTabid("Emails").",'get_emails',1,'Emails',0)");
		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Contacts").",".getTabid("Emails").",'get_to_emails',2,'To Emails',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Contacts").",".getTabid("Calendar").",'get_activities',3,'Activities',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Contacts").",".getTabid("Potentials").",'get_opportunities',2,'Potentials',0)");	
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Contacts").",".getTabid("Quotes").",'get_quotes',4,'Quotes',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Contacts").",".getTabid("HelpDesk").",'get_tickets',5,'HelpDesk',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Contacts").",".getTabid("Campaigns").",'get_campaigns',6,'Campaigns',0)");		
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Contacts").",".getTabid("SalesOrder").",'get_salesorder',7,'Sales Order',0)");
		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Contacts").",".getTabid("PurchaseOrder").",'get_purchase_orders',8,'Purchase Order',0)");		

		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Contacts").",".getTabid("Products").",'get_products',8,'Products',0)");

		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Contacts").",".getTabid("Calendar").",'get_history',9,'Activity History',0)");

		

		

		//Inserting Potential Related Lists
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Potentials").",0,'get_notes',0,'Notes',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Potentials").",0,'get_attachments',1,'Attachments',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Potentials").",".getTabid("Calendar").",'get_activities',2,'Activities',0)");
		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Potentials").",".getTabid("Contacts").",'get_contacts',3,'Contacts',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Potentials").",".getTabid("Products").",'get_products',3,'Products',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Potentials").",0,'get_stage_history',4,'Sales Stage History',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Potentials").",".getTabid("Quotes").",'get_Quotes',6,'Quotes',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Potentials").",".getTabid("SalesOrder").",'get_salesorder',7,'Sales Order',0)");

		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Potentials").",".getTabid("Calendar").",'get_history',8,'Activity History',0)");

		//Inserting Product Related Lists	

		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Products").",".getTabid("HelpDesk").",'get_tickets',1,'HelpDesk',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Products").",0,'get_attachments',2,'Attachments',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Products").",".getTabid("Accounts").",'get_accounts',3,'Accounts',0)");	
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Products").",".getTabid("Quotes").",'get_quotes',4,'Quotes',0)");

		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Products").",".getTabid("PurchaseOrder").",'get_purchase_orders',5,'Purchase Order',0)");

		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Products").",".getTabid("SalesOrder").",'get_salesorder',6,'Sales Order',0)");

		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Products").",".getTabid("Invoice").",'get_invoices',7,'Invoice',0)");

		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Products").",".getTabid("PriceBooks").",'get_product_pricebooks',8,'PriceBooks',0)");

		//Inserting Emails Related Lists	

		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Emails").",".getTabid("Contacts").",'get_contacts',1,'Contacts',0)");


		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Emails").",0,'get_users',2,'Users',0)");


		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Emails").",0,'get_attachments',3,'Attachments',0)");

		//Inserting HelpDesk Related Lists

		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("HelpDesk").",".getTabid("Calendar").",'get_activities',1,'Activities',0)");

		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("HelpDesk").",0,'get_attachments',2,'Attachments',0)");

		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("HelpDesk").",0,'get_ticket_history',3,'Ticket History',0)");

		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("HelpDesk").",".getTabid("Calendar").",'get_history',4,'Activity History',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Faq").",0,'get_attachments',1,'Attachments',0)");

		//Inserting PriceBook Related Lists
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("PriceBooks").",14,'get_pricebook_products',2,'Products',0)");

		// Inserting Vendor Related Lists
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Vendors").",0,'get_attachments',0,'Attachments',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Vendors").",".getTabid("Calendar").",'get_activities',1,'Activities',0)");
		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Vendors").",4,'get_contacts',1,'Contacts',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Vendors").",".getTabid("Charges").",'get_charges',2,'Charges',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Vendors").",14,'get_products',3,'Products',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Vendors").",21,'get_purchase_orders',4,'Purchase Order',0)");
		

		

		// Inserting Quotes Related Lists
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Quotes").",0,'get_attachments',0,'Attachments',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Quotes").",".getTabid("Invoice").",'get_salesorder',1,'Sales Order',0)");
		

		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Quotes").",9,'get_activities',2,'Activities',0)");

		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Quotes").",9,'get_history',3,'Activity History',0)");

		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Quotes").",0,'get_quotestagehistory',3,'Quote Stage History',0)");

		// Inserting Purchase order Related Lists

		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("PurchaseOrder").",9,'get_activities',1,'Activities',0)");

		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("PurchaseOrder").",0,'get_attachments',0,'Attachments',0)");

		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("PurchaseOrder").",".getTabid("Calendar").",'get_history',3,'Activity History',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("PurchaseOrder").",".getTabid("Charges").",'get_charges',1,'Charges',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("PurchaseOrder").",".getTabid("Warehouses").",'get_warehouses',2,'Warehouses',0)");

		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("PurchaseOrder").",0,'get_postatushistory',3,'PurchaseOrder Status History',0)");

		// Inserting Sales order Related Lists
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("SalesOrder").",0,'get_attachments',0,'Attachments',0)");
        $this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("SalesOrder").",".getTabid("Gathers").",'get_gathers',1,'Gathers',0)");
		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("SalesOrder").",9,'get_activities',2,'Activities',0)");		
		
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("SalesOrder").",".getTabid("Invoice").",'get_invoices',3,'Invoice',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("SalesOrder").",".getTabid("PurchaseOrder").",'get_purchase_orders',4,'PurchaseOrder',0)");
		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("SalesOrder").",".getTabid("Calendar").",'get_history',4,'Activity History',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("SalesOrder").",0,'get_sostatushistory',5,'SalesOrder Status History',0)");

		// Inserting Invoice Related Lists

		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Invoice").",9,'get_activities',1,'Activities',0)");

		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Invoice").",0,'get_attachments',0,'Attachments',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Invoice").",".getTabid("Gathers").",'get_gathers',2,'Gathers',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Invoice").",".getTabid("Deliverys").",'get_deliverys',3,'Deliverys',0)");

		//$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Invoice").",".getTabid("Calendar").",'get_history',3,'Activity History',0)");

		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Invoice").",0,'get_invoicestatushistory',4,'Invoice Status History',0)");

		// Inserting Activities Related Lists

		$this->db->query("insert into ec_relatedlists values (".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Calendar").",0,'get_users',1,'Users',0)");
		$this->db->query("insert into ec_relatedlists values (".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Calendar").",4,'get_contacts',2,'Contacts',0)");

		// Inserting Campaigns Related Lists


		//$this->db->query("insert into ec_relatedlists values (".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Campaigns").",".getTabid("Leads").",'get_leads',2,'Leads',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Campaigns").",0,'get_attachments',0,'Attachments',0)");
		$this->db->query("insert into ec_relatedlists values (".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Campaigns").",".getTabid("Accounts").",'get_accounts',1,'Accounts',0)");
		$this->db->query("insert into ec_relatedlists values (".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Campaigns").",".getTabid("Contacts").",'get_contacts',2,'Contacts',0)");
		$this->db->query("insert into ec_relatedlists values (".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Campaigns").",".getTabid("Potentials").",'get_opportunities',3,'Potentials',0)");
		$this->db->query("insert into ec_relatedlists values (".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Campaigns").",9,'get_activities',4,'Activities',0)");

		$this->db->query("insert into ec_relatedlists values (".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Messages").",".getTabid("Users").",'get_users',2,'Users',0)");
		$this->db->query("insert into ec_relatedlists values (".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Messages").",".getTabid("Contacts").",'get_contacts',1,'Contacts',0)");

		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Documents").",0,'get_attachments',1,'Attachments',0)");
		$this->db->query("insert into ec_relatedlists values(".$this->db->getUniqueID('ec_relatedlists').",".getTabid("Notes").",0,'get_attachments',1,'Attachments',0)");

		
		
		
		if($is_upgrade) {
			$this->db->query("delete from ec_organizationdetails");
		}
		//Insert into ec_organizationdetails ec_table 
		$this->db->query("insert into ec_organizationdetails(organizationname,address,city,state,country,code,phone,fax,website,logoname) values ('中国瑞策软件有限公司',' 中国上海零陵路631号','上海','上海','中国','600 042','+8621-64876448','+8621-64876441','http://www.crmone.cn','crm-logo.jpg')");

		if($is_upgrade) {
			$this->db->query("delete from ec_actionmapping");
		}
		$this->db->query("insert into ec_actionmapping values(0,'Save',0)");
		$this->db->query("insert into ec_actionmapping values(1,'EditView',0)");
		$this->db->query("insert into ec_actionmapping values(2,'Delete',0)");
		$this->db->query("insert into ec_actionmapping values(3,'index',0)");
		$this->db->query("insert into ec_actionmapping values(4,'DetailView',0)");
		$this->db->query("insert into ec_actionmapping values(5,'Import',0)");
		$this->db->query("insert into ec_actionmapping values(6,'Export',0)");
		//$this->db->query("insert into ec_actionmapping values(7,'AddBusinessCard',0)");
		$this->db->query("insert into ec_actionmapping values(8,'Merge',0)");
		$this->db->query("insert into ec_actionmapping values(1,'VendorEditView',1)");
		$this->db->query("insert into ec_actionmapping values(4,'VendorDetailView',1)");
		$this->db->query("insert into ec_actionmapping values(0,'SaveVendor',1)");
		$this->db->query("insert into ec_actionmapping values(2,'DeleteVendor',1)");
		$this->db->query("insert into ec_actionmapping values(1,'PriceBookEditView',1)");
		$this->db->query("insert into ec_actionmapping values(4,'PriceBookDetailView',1)");
		$this->db->query("insert into ec_actionmapping values(0,'SavePriceBook',1)");
		$this->db->query("insert into ec_actionmapping values(2,'DeletePriceBook',1)");
		$this->db->query("insert into ec_actionmapping values(9,'ConvertLead',0)");
		$this->db->query("insert into ec_actionmapping values(1,'DetailViewAjax',1)");
		$this->db->query("insert into ec_actionmapping values(4,'TagCloud',1)");
		$this->db->query("insert into ec_actionmapping values(1,'QuickCreate',1)");
		$this->db->query("insert into ec_actionmapping values(3,'Popup',1)");

		//added by dingjianting on 2008-01-22 for 
		$this->db->query("insert into ec_actionmapping values(10,'Create',0)");
		$this->db->query("insert into ec_actionmapping values(11,'Approve',0)");

		//Insert values for ec_moduleowners ec_table which contains the modules and their ec_users. default user id admin - after 4.2 patch 2
		if($is_upgrade) {
			$this->db->query("delete from ec_moduleowners");
		}
		$module_array = Array('Potentials','Contacts','Accounts','Leads','Notes','Calendar','Emails','HelpDesk','Products','Faq','Vendors','PriceBooks','Quotes','PurchaseOrder','SalesOrder','Invoice','Reports','Campaigns','Messages','Gathers','Charges','Expenses','Workflows','Documents');
		foreach($module_array as $mod)
		{
			$this->db->query("insert into ec_moduleowners values(".getTabid($mod).",1)");
		}
		//added by jeri for category view from db
		if($is_upgrade) {
			$this->db->query("delete from ec_parenttab");
		}
		$query = "INSERT INTO `ec_parenttab` VALUES (1, 'My Home Page', 1, 0)";
		$this->db->query($query);
		$query = "INSERT INTO `ec_parenttab` VALUES (2, 'Marketing', 2, 0)";
		$this->db->query($query);
		$query = "INSERT INTO `ec_parenttab` VALUES (3, 'Customer', 3, 0)";
		$this->db->query($query);
		$query = "INSERT INTO `ec_parenttab` VALUES (4, 'Product', 4, 0)";
		$this->db->query($query);
		$query = "INSERT INTO `ec_parenttab` VALUES (5, 'Sales', 5, 0)";
		$this->db->query($query);
		$query = "INSERT INTO `ec_parenttab` VALUES (6, 'Buy', 6, 0)";
		$this->db->query($query);
		$query = "INSERT INTO `ec_parenttab` VALUES (7, 'Support', 7, 0)";
		$this->db->query($query);
		$query = "INSERT INTO `ec_parenttab` VALUES (8, 'Inventory', 8, 0)";
		$this->db->query($query);
		$query = "INSERT INTO `ec_parenttab` VALUES (9, 'Accounting', 9, 0)";
		$this->db->query($query);
		$query = "INSERT INTO `ec_parenttab` VALUES (10, 'Analytics', 10, 0)";
		$this->db->query($query);
		$query = "INSERT INTO `ec_parenttab` VALUES (11, 'Settings', 11, 0)";
		$this->db->query($query);
		//home
		if($is_upgrade) {
			$this->db->query("delete from ec_parenttabrel");
		}
		//home page
		$this->db->query("insert into ec_parenttabrel values (1,3,1)");
		$this->db->query("insert into ec_parenttabrel values (1,9,2)");
		$this->db->query("insert into ec_parenttabrel values (1,28,3)");		
		//$this->db->query("insert into ec_parenttabrel values (1,32,4)");
		$this->db->query("insert into ec_parenttabrel values (1,37,5)");
        //marketing
		$this->db->query("insert into ec_parenttabrel values (2,26,2)");
		//customer	
		$this->db->query("insert into ec_parenttabrel values (3,6,2)");
		$this->db->query("insert into ec_parenttabrel values (3,4,3)");		
		$this->db->query("insert into ec_parenttabrel values (3,8,4)");

		//products
		$this->db->query("insert into ec_parenttabrel values (4,14,2)");
		$this->db->query("insert into ec_parenttabrel values (4,19,3)");
		
		//sales
		$this->db->query("insert into ec_parenttabrel values (5,2,2)");		
		$this->db->query("insert into ec_parenttabrel values (5,20,4)");		
		$this->db->query("insert into ec_parenttabrel values (5,22,5)");
		$this->db->query("insert into ec_parenttabrel values (5,23,6)");
		
		//buy
		$this->db->query("insert into ec_parenttabrel values (6,21,2)");
		$this->db->query("insert into ec_parenttabrel values (6,18,3)");

		
		//support
		$this->db->query("insert into ec_parenttabrel values (7,13,2)");
		$this->db->query("insert into ec_parenttabrel values (7,15,3)");

        //inventory
		//$this->db->query("insert into ec_parenttabrel values (5,19,3)");
		//$this->db->query("insert into ec_parenttabrel values (5,21,4)");

		//accounting
		$this->db->query("insert into ec_parenttabrel values (9,33,2)");
		$this->db->query("insert into ec_parenttabrel values (9,34,3)");
		$this->db->query("insert into ec_parenttabrel values (9,35,4)");

		//Analytics	
		//$this->db->query("insert into ec_parenttabrel values (5,1,1)");
		$this->db->query("insert into ec_parenttabrel values (10,25,2)");
		//$this->db->query("insert into ec_parenttabrel values (5,36,3)");
		


		


	}
}
?>
